#ident "@(#)$Header: ip_var.h,v 1.8 93/04/06 09:52:18 schmuell Exp $ SNI"
/*
 * "@(#)ip_var.h  Revision: 3.1   93/01/18 13:39:28" 
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _NETINET_IP_VAR_H
#define _NETINET_IP_VAR_H

/*#ident "@(#)$Header: ip_var.h,v 1.8 93/04/06 09:52:18 schmuell Exp $ SNI"*/

/* #ident	"@(#)genneti:ip_var.h	1.1" */

/*
 *  		PROPRIETARY NOTICE (Combined)
 *  
 *  This source code is unpublished proprietary information
 *  constituting, or derived under license from AT&T's Unix(r) System V.
 *  In addition, portions of such source code were derived from Berkeley
 *  4.3 BSD under license from the Regents of the University of
 *  California.
 *  
 *  
 *  
 *  		Copyright Notice 
 *  
 *  Notice of copyright on this source code product does not indicate 
 *  publication.
 *  
 *  	(c) 1986,1987,1988,1989  Sun Microsystems, Inc.
 *  	(c) 1983,1984,1985,1986,1987,1988,1989  AT&T.
 *  	          All rights reserved.
 */


/*
 * System V STREAMS TCP - Release 3.0 
 *
 * Copyright 1987, 1988, 1989 Lachman Associates, Incorporated (LAI) 
 * All Rights Reserved. 
 *
 * The copyright above and this notice must be preserved in all copies of this
 * source code.  The copyright above does not evidence any actual or intended
 * publication of this source code. 
 *
 * This is unpublished proprietary trade secret source code of Lachman
 * Associates.  This source code may not be copied, disclosed, distributed,
 * demonstrated or licensed except as expressly authorized by Lachman
 * Associates. 
 *
 * System V STREAMS TCP was jointly developed by Lachman Associates and
 * Convergent Technologies. 
 */

/*
 * Overlay for ip header used by other protocols (tcp, udp).
 */
struct ipovly {
	caddr_t	ih_next;		/* for protocol sequence q's */
#ifdef STRNET
	mblk_t *ih_mblk;
#else
	caddr_t ih_prev;
#endif /* STRNET */
	u_char	ih_x1;			/* (unused) */
	u_char	ih_pr;			/* protocol */
	short	ih_len;			/* protocol length */
	struct	in_addr ih_src;		/* source internet address */
	struct	in_addr ih_dst;		/* destination internet address */
};

/*
 * Ip reassembly queue structure.  Each fragment
 * being reassembled is attached to one of these structures.
 * They are timed out after ipq_ttl drops to 0, and may also
 * be reclaimed if memory becomes tight.
 */
struct ipq {
	struct	ipq *next,*prev;	/* to other reass headers */
	u_char	ipq_ttl;		/* time for reass q to live */
	u_char	ipq_p;			/* protocol of this fragment */
	u_short	ipq_id;			/* sequence id for reassembly */
	struct	ipasfrag *ipq_next;
					/* to ip headers of fragments */
	struct	in_addr ipq_src,ipq_dst;
};

/*
 * Ip header, when holding a fragment.
 *
 * Note: ipf_next must be at same offset as ipq_next above
 */
struct	ipasfrag {
#if defined(__vax__) || defined(__i386__)
	u_char	ip_hl:4,
		ip_v:4;
#endif
#if defined(__mc68000__) || defined(__sparc__) || defined(u3b2) || defined(mips)
	u_char	ip_v:4,
		ip_hl:4;
#endif
	u_char	ipf_mff;		/* copied from (ip_off&IP_MF) */
	short	ip_len;
	u_short	ip_id;
	short	ip_off;
	u_char	ip_ttl;
	u_char	ip_p;
	u_short	ip_sum;
	struct	ipasfrag *ipf_next;	/* next fragment */
#ifdef STRNET
	mblk_t	*ipf_mblk;	/* The mblk header for this data */
#else
	struct	ipasfrag *ipf_prev;	/* previous fragment */
#endif /* STRNET */
};

#ifdef STRNET
/* get a pointer to an IP header from a pointer to a fragment */

#define IPHDR(ip) ((struct ip *) (ip))
#define IPASFRAG(ip) ((struct ipasfrag *) (ip))

#endif /* STRNET */


/*
 * Structure stored in mbuf in inpcb.ip_options
 * and passed to ip_output when ip options are in use.
 * The actual length of the options (including ipopt_dst)
 * is in m_len.
 */
#define MAX_IPOPTLEN	40

struct ipoption {
	struct	in_addr ipopt_dst;	/* first-hop dst if source routed */
	char	ipopt_list[MAX_IPOPTLEN];	/* options proper */
};

struct	ipstat {
	long	ips_total;		/* total packets received */
	long	ips_badsum;		/* checksum bad */
	long	ips_tooshort;		/* packet too short */
	long	ips_toosmall;		/* not enough data */
	long	ips_badhlen;		/* ip header length < data size */
	long	ips_badlen;		/* ip length < ip header length */
	long	ips_fragments;		/* fragments received */
	long	ips_fragdropped;	/* frags dropped (dups, out of space) */
	long	ips_fragtimeout;	/* fragments timed out */
	long	ips_forward;		/* packets forwarded */
	long	ips_cantforward;	/* packets rcvd for unreachable dest */
	long	ips_redirectsent;	/* packets forwarded on same net */
#ifdef mips
	long	ips_netunreach;		/* network unreachable */
	long	ips_iffdn;		/* packets rcvd from i.f. marked DOWN */
	long	ips_badproto_inp;	/* bad protocol in input packet */
	long	ips_badalloc_inp;	/* failed allocs in ip_input */
	long	ips_upqfull_inp;	/* upq full for ip packet */
	long	ips_upqfull_icmp;	/* upq full for icmp packet */
	long	ips_badprim;		/* internal error: bad str prim */
	long	ips_badopt;		/* bad IP option or args */
	long	ips_badbroad;		/* bad bdcst dest addr */
	long	ips_smallfrag;		/* output frag dropped -- too small */
	long	ips_badalloc_out;	/* failed allocs in ip_output */
	long	ips_dnqfull_out;	/* dnq full in ip_output() */
	long	ips_dnqfull_lwput;	/* dnq full in iplwput() */
	long	ips_dnqfull_lwsrv;	/* dnq full in iplwsrv() */
	long	ips_duprange;		/* failure in dup_range() */
	long	ips_hostunreach;	/* host unreachable */
	long    ips_outrequests;        /* ip datagram from ip users protocol */
	long    ips_reasmoks;           /* ip datagram suc. re-assembled */
	long    ips_fragoks;            /* ip datagram suc. fragmented */
	long    ips_fragcreates;        /* ip fragments suc. generated */
#endif /* mips */
};


/*
 * additional statistics for SNMP
 */
struct snmpipstat {
	int	ipInHdrErrors;		/* 4 - only additional values */
	int	ipInAddrErrors;		/* 5 */
	int	ipForwDatagrams;	/* 6 */
	int	ipInUnknownProtos;	/* 7 */
	int	ipInDiscards;		/* 8 */
	int	ipInDelivers;		/* 9 */
	int	ipOutRequests;		/* 10 */
	int	ipOutDiscards;		/* 11 */
	int	ipOutNoRoutes;		/* 12 */
	int	ipReasmOKs;		/* 15 */
	int	ipFragOKs;		/* 17 */
	int	ipFragFails;		/* 18 */
	int	ipFragCreates;		/* 19 */
	int	ipRoutingDiscards;	/* 23 */
};


#ifdef _KERNEL
/* flags passed to ip_output as last parameter */
#define	IP_FORWARDING		0x1		/* most of ip header exists */
#define	IP_ROUTETOIF		SO_DONTROUTE	/* bypass routing tables */
#define	IP_ALLOWBROADCAST	SO_BROADCAST	/* can send broadcast packets */

extern	struct ipstat	ipstat;
extern	u_short		ip_id;

#ifdef STRNET
mblk_t	*ip_srcroute();
#else
struct	mbuf *ip_srcroute();
#endif /* STRNET */
#endif
#endif	/* _NETINET_IP_VAR_H */
