#ident "@(#)$Header: stdlib.h,v 1.8 94/03/02 15:08:44 jd Exp $ SNI"
/*	Copyright (c) 1990 UNIX System Laboratories, Inc.	*/
/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF     	*/
/*	UNIX System Laboratories, Inc.                     	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _STDLIB_H
#define _STDLIB_H

/*#ident	"@(#)head:stdlib.h	1.23"*/
/*#ident "$Header: stdlib.h,v 1.8 94/03/02 15:08:44 jd Exp $"*/

#ifndef _SSIZE_T
#define _SSIZE_T
typedef	int	ssize_t;	/* return byte count or indicate error */
#endif

#if (!defined (__STRICT_ANSI__)) && !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)
/* for XPG4 conformance, used to decode the return value from system() */

#define WUNTRACED	0004	
#define WNOHANG		0100	
#define WIFEXITED(stat)		(((int)((stat)&0377))==0)
#define WIFSIGNALED(stat)	(((int)((stat)&0377))>0&&((int)(((stat)>>8)&0377))==0)
#define WIFSTOPPED(stat)	(((int)((stat)&0377))==0177&&((int)(((stat)>>8)&0377))!=0)
#define WEXITSTATUS(stat)	((int)(((stat)>>8)&0377))
#define WTERMSIG(stat)		(((int)((stat)&0377))&0177)
#define WSTOPSIG(stat)		((int)(((stat)>>8)&0377))

/* for XPG4 */
void	setkey(const char *);
#endif

typedef	struct {
	 int	quot;
	 int	rem;
	} div_t;

typedef struct {
	 long	quot;
	 long	rem;
	} ldiv_t;

#ifndef _SIZE_T
#define _SIZE_T
#ifndef __SIZE_TYPE__
#define __SIZE_TYPE__ long unsigned int
#endif
typedef __SIZE_TYPE__ size_t;
#endif

#ifndef NULL
#define NULL            0
#endif

#define EXIT_FAILURE	1
#define EXIT_SUCCESS    0
#define RAND_MAX	32767

#ifndef _WCHAR_T
#define _WCHAR_T
#ifndef __WCHAR_TYPE__
#define __WCHAR_TYPE__ int
#endif
typedef __WCHAR_TYPE__ wchar_t;
#endif

#ifndef MB_CUR_MAX
extern unsigned char 	__ctype[];
#define MB_CUR_MAX	(int)__ctype[520]
#endif /* MB_CUR_MAX */

#if defined(__STDC__)

extern double atof(const char *);
extern int atoi(const char *);
extern long int atol(const char *);
extern double strtod(const char *, char **);
extern long int strtol(const char *, char **, int);
extern unsigned long int strtoul(const char *, char **, int );

extern int rand(void);
extern void srand(unsigned int);

extern void *calloc(size_t, size_t);
extern void free(void *);
extern void *malloc(size_t);
extern void *realloc(void *, size_t);

extern void abort(void);
extern int atexit(void (*)(void));
extern void exit(int);
extern char *getenv(const char *);
extern int system(const char *);

extern void *bsearch(const void *, const void *, size_t, size_t,
	int (*)(const void *, const void *));
extern void qsort(void *, size_t, size_t,
	int (*)(const void *, const void *));

extern int abs(int);
extern div_t div(int, int);
extern long int labs(long);
extern ldiv_t ldiv(long, long);

extern int mbtowc(wchar_t *, const char *, size_t);
extern int mblen(const char *, size_t);
extern int wctomb(char *, wchar_t);

extern size_t mbstowcs(wchar_t *, const char *, size_t);
extern size_t wcstombs(char *, const wchar_t *, size_t);

#if !defined (__STRICT_ANSI__) && !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)

extern long a64l(const char *);
extern char *ecvt(double, int, int *, int *);
extern char *fcvt(double, int, int *, int *);
extern int getsubopt(char **, char *const *, char **);
extern int getpw(int, char *);
extern char *gcvt(double, int, char *);
extern void l3tol(long *, const char *, int);
extern char *l64a(long);
extern void ltol3(char *, const long *, int);
extern void * memalign(size_t, size_t);
extern char *mktemp(char *);
extern char *realpath(const char *, char *);
extern int ttyslot(void);
extern void *valloc(size_t);
#endif /* !defined (__STRICT_ANSI__) && !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)*/

#if !defined (__STRICT_ANSI__) && !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)
extern double drand48(void);
extern double erand48(unsigned short *);
extern long jrand48(unsigned short *);
extern void lcong48(unsigned short *);
extern long lrand48(void);
extern long mrand48(void);
extern long nrand48(unsigned short *);
extern int putenv(const char *);
extern unsigned short *seed48(unsigned short *);
extern void srand48(long);
#endif /* !defined (__STRICT_ANSI__) && !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)*/

#if !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)

extern int dup2(int, int);
extern char *getcwd(char *, size_t);
extern char *getlogin(void);
extern int getopt(int, char *const *, const char *);
extern char *optarg;
extern int optind, opterr, optopt;
extern char *getpass(const char *);
extern void swab(const void *, void *, ssize_t);
extern char *ttyname(int);

#endif /* !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE) */

#else /* not __STDC__ */

extern double atof();
extern int atoi();
extern long int atol();
extern double strtod();
extern long int strtol();
extern unsigned long strtoul();

extern int rand();
extern void srand();

extern char *calloc();
extern void free();
extern char *malloc();
extern char *realloc();

extern void abort();
extern int atexit();
extern void exit();
extern char *getenv();
extern int system();

extern char *bsearch();
extern void qsort();

extern int abs();
extern div_t div();
extern long int labs();
extern ldiv_t ldiv();

extern int mbtowc();
extern int mblen();
extern int wctomb();

extern size_t mbstowcs();
extern size_t wcstombs();

#if !defined (_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)
extern long a64l();
extern int dup2();
extern char *ecvt();
extern char *fcvt();
extern char *getcwd();
extern char *getlogin();
extern int getopt();
extern char *getpass();
extern int getsubopt();
extern int getpw();
extern char *gcvt();
extern void l3tol();
extern char *l64a();
extern void ltol3();
extern char *memalign();
extern char *mktemp();
extern char *optarg;
extern int optind, opterr, optopt;
extern char *realpath();
extern void swab();
extern char *ttyname();
extern int ttyslot();
extern char *valloc();
#endif /* !defined (_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)*/

#if !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE)
extern double drand48();
extern double erand48();
extern long jrand48();
extern void lcong48();
extern long lrand48();
extern long mrand48();
extern long nrand48();
extern int putenv();
extern unsigned short *seed48();
extern void srand48();
#endif /* !defined(_POSIX_SOURCE) || defined(_XOPEN_SOURCE) */

#endif	/* __STDC__ */

#define mblen(s, n)	mbtowc((wchar_t *)0, s, n)

#endif 	/* _STDLIB_H */
