#ident "@(#)$Header: disp.h,v 1.1.1.3 93/03/09 11:57:47 reinsch Exp $ SNI"
/*
 * "@(#)disp.h	Revision: 3.2	92/08/24 14:12:34"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_DISP_H
#define _SYS_DISP_H


#ifndef _SYS_PRIOCNTL_H
#include <sys/priocntl.h>
#endif

#include <sys/cpupriv.h>

/*
 * The following is the format of a dispatcher queue entry.
 */
typedef struct dispq {
	struct proc	*dq_first;	/* first proc on queue or NULL */
	struct proc	*dq_last;	/* last proc on queue or NULL */
#if defined(mips) && !defined(u3b2v4)
	lck_t		dq_mplock;	/* lock for this queue */
	cpumask_t	dq_cpus;	/* cpus for whom this q holds work */
#else
	int		dq_sruncnt;	/* no. of loaded, runnable procs on queue */
#endif
} dispq_t;


#ifdef _KERNEL

/*
 * Global scheduling variables.
 */
extern int	maxrunpri;	/* priority of highest priority active queue */
extern volatile int	cpumaxrunpri[];	/* as above, but on per-cpu base */

#if defined(mips) && !defined(u3b2v4)
#define MAXRUNPRI(cpu)	cpumaxrunpri[cpu]
#else
#define MAXRUNPRI(cpu)	maxrunpri
#endif

/*
 * Public scheduling functions.
 */
#if defined(__STDC__)

extern boolean_t	dispdeq(struct proc *pp);
extern int	getcid(char *clname, id_t *cidp);
extern int	parmsin(pcparms_t *parmsp, struct proc *reqpp, struct proc *targpp);
extern int	parmsout(pcparms_t *parmsp, struct proc *reqpp, struct proc *targpp);
extern int	parmsset(pcparms_t *parmsp, struct proc *reqpp, struct proc *targpp);
extern void	dispinit();
extern void	getglobpri(pcparms_t *parmsp, int *globprip);
extern void	parmsget(struct proc *pp, pcparms_t *parmsp);
extern void	preempt();
extern void	setbackdq(struct proc *pp);
extern void	setfrontdq(struct proc *pp);
#ifndef KPERF
extern void	swtch();
#endif /* KPERF */
extern void	dq_sruninc(int pri);
extern void	dq_srundec(int pri);
extern int	swapinub(struct proc *);
#ifdef _SMP
extern void	checkresched(int, struct proc *, int);
extern void	setaffinity(struct proc *, cpuid_t);
extern void	eval_bindings(struct proc *);
extern void	eval_bindings_async(struct proc *);
extern void	release_bindings(struct proc *);

#endif /* _SMP */

#else

extern boolean_t	dispdeq();
extern int	getcid(), parmsin(), parmsout(), parmsset();
extern void	dispinit(), getglobpri(), parmsget(), preempt();
extern void	setbackdq(), setfrontdq(), swtch(), dq_sruninc(), dq_srundec();
extern int	swapinub();
#ifdef _SMP
extern void	checkresched(), setaffinity();
extern void	eval_bindings(), eval_bindings_async();
extern void	release_bindings();
#endif /* _SMP */

#endif	/* __STDC__ */


#ifdef __i386__
asm void
kperf_savepc()
{
	movl	%eip, Kpc
}
#endif

#ifdef u3b2
kperf_savepc()
{
	MOVAW  0(%pc),Kpc
}
#endif

#ifdef	KPERF
#define PREEMPT() \
{ \
	if (kprunrun != 0) { \
		preempt(); \
	} \
	else if (kpftraceflg) { \
		kperf_savepc(); \
		kperf_write(KPT_PREEMPT,Kpc,curproc); \
	} \
}

#else	/* !KPERF */

#define	PREEMPT()	if (kprunrun != 0){ \
				preempt(); \
			}

#endif	/* KPERF */

#endif	/* _KERNEL */

/*
 * sleep-wakeup hashing:  Each entry in sleepq[] points
 * to the front and back of a linked list of sleeping processes.
 * Processes going to sleep go to the back of the appropriate
 * sleep queue and wakeprocs wakes them from front to back (so the
 * first process to go to sleep on a given channel will be the first
 * to run after a wakeup on that channel).
 * NSLEEPQ must be a power of 2.  Sqhash(x) is used to index into
 * sleepq[] based on the sleep channel.
 */

#ifdef mips

#define NSLEEPQ         1024

#else

#ifdef _SMP
#define NSLEEPQ         1024
#else
#define NSLEEPQ         256
#endif

#endif

#define sqhash(X)       (&sleepq[((int)X >> 8) & (NSLEEPQ - 1)])

typedef struct sleepq {
        struct  proc  *sq_first;
        struct  proc  *sq_last;
#ifdef _SMP
        lck_t   sq_lock;
#endif
#ifdef SQDEBUG
        int     sq_length;      /* number of sleepers in this Q
*/
        int     sq_max;         /* high water mark # of sleepers in this Q
*/
        unsigned sq_count;      /* total sleepers that have ever been in this Q
*/
        unsigned sq_overflow;   /* Number of sq_count overflows
*/
#endif
} sleepq_t;


#endif	/* _SYS_DISP_H */
