#ident "@(#)$Header: mplocks.h,v 1.12.1.1 94/05/06 15:18:17 V542flo Exp $ SNI"
/*
 * "@(#)mplocks.h	Revision: 3.7	93/02/03 15:35:03"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_MPLOCKS_H
#define _SYS_MPLOCKS_H

/*#ident	"@(#)ATTDSG gencpu/gensys/uts/sys/mplocks.h	1.1.1.4"*/

#ifdef mips
#include <sys/prilevel.h>	/* For lock initializers; see below */
#endif
#ifdef __i386__
#include <sys/ipl.h>
#endif
#ifdef u3b2
#include <sys/ipl.h>
#endif
#include <sys/proc.h>

/*
 * Lock types and status flags
 */
#define LCK_SPIN	0x01	/* Lock based on spin */
#define	LCK_SEMA	0x02	/* Lock based on blocking semaphore */
#define	LCK_NCXT	0x04	/* Non-context reentrant lock */
#define	LCK_RDWR	0x08	/* Read/Write lock */
#define	LCK_REENT	0x10	/* Reentrant lock */
#define	LCK_MPSTATS	0x20	/* Lock should have stats collected */
#define	LCK_LOCKTEST	0x40	/* Lock should be locktested */
#define	LCK_DDI		0x80	/* Lock belongs to driver rather than kernel */

#define	LCK_QUEUED	(LCK_NCXT|LCK_RDWR) /* Lock is a queued lock */
#define	LCK_DBG		(LCK_MPSTATS|LCK_LOCKTEST|LCK_DDI) /* Lock is in debug mode */

/*
 * Read/write lock attributes
 */
#define	RDWR_READ	0x01	/* Read lock request flag */
#define	RDWR_WRITE	0x02	/* Write lock request flag */
#define	RDWR_WRTORD	0x04	/* Degrade write to read lock */
#define	RDWR_RDTOWR	0x08	/* Upgrade read to write lock */

/*
 * Lock operations - for logging purposes
 */
#define	LLOG_REL	0x00	/* Release the lock */
#define	LLOG_SET	0x01	/* Unconditionally acquire the lock */
#define	LLOG_CSET	0x02	/* Conditionally acquire the lock */
#define	LLOG_INIT	0x04	/* Initialize lock */
#define LLOG_BEGIN	0x10	/* Begin lock operation */
#define	LLOG_END	0x20	/* End of lock operation */

/*
 * locktest flags
 */
#define LTEST_SAMEOK	0x01	/* Allow locking at current level */
#define LTEST_COMPLEX	0x02	/* Complex lock, so don't use the lck field */
#define LTEST_NOLISTCHK	0x04	/* Don't check the locklist */
#define LTEST_NOINSERT	0x08	/* Don't insert into the lock list */
#define LTEST_NOLVLCHK	0x10	/* Don't do lock level checking */
#define	LTEST_CHKRETVAL	0x20	/* Check return value before inserting */

/*
 * locktest status
 */
#define LTEST_RUNNING	1	/* Locktest is running */

#ifdef __i386__
#define MAXWAITTIME	0x7fffffff
#endif

#ifdef mips
#define MAXWAITTIME 	20000000   /* max time to wait for all spinlock types */
#define QUEUED_MAXWAITTIME 	200000000   /* time to wait for queued lockss */
#endif

/*
 * Stats buffer bucket identifiers
 */

#define IM_MINSYNC              1000    /* defines for crash - CPP delimiter */

#define	MPS_SPIN_SEMLCK		0	/* Semaphore spin lock */
#define	MPS_SPIN_CMNERR		1	/* Lock for cmn_err() printing */
#define	MPS_SPIN_PROC		2	/* Process spin lock */
#define	MPS_SPIN_SLPQ		3	/* Sleep hash queue lock */
#define	MPS_SEMA_PSLP		4	/* Process sleep sema */
#define MPS_AUTO_LOCKS		5	/* Automatic compatibility locks */
#define MPS_SPIN_QUIES		6	/* Quiescent spin lock */
#define MPS_SEMA_QUIES		7	/* Quiescent semaphore */
#define MPS_SPIN_PRINTLCK	8	/* Printf spin lock */
#define MPS_SPIN_PIRLCK		9	/* PIR handler lock */
#define MPS_SPIN_RUNIO		10	/* Sched runin/runout lock */
#define	MPS_SEMA_SCHED		11	/* Sched semaphores */
#define	MPS_SPIN_ATOM		12	/* Atomic data operators */
#define MPS_SPIN_DNLC		13	/* Directory name lookup cache lock */
#define MPS_SPIN_PNCACHE	14	/* Pathname cache lock */
#define	MPS_SPIN_RSEMLCK	15	/* Reent Semaphore spin lock */
#define	MPS_SPIN_RWSEMLCK	16	/* Rdwr Semaphore spin lock */
#define MPS_AVAILMEM		17	/* Availrmem,availsmem,pages_pp_kernel lock */
#define MPS_KMEM		18	/* KMA small/large/osize buffers */
#define MPS_KMEMFAST		19	/* KMA fast allocation */
#define MPS_KMEMIDLE		20	/* KMA idle pools */
#define MPS_MALLOC		21	/* One of the malloc locks */
#define MPS_SEGKMEM		22	/* seg_kmem driver */
#define MPS_SPIN_PRA		23	/* practive link		*/
#define MPS_SPIN_KIN		24	/* next of kin linkages		*/
#define MPS_SPIN_PGRP		25	/* process group linkages	*/
#define MPS_SPIN_CRED		26	/* credentials			*/
#define MPS_SPIN_PID		27	/* pid linkage			*/
#define MPS_SPIN_PARENTCHILD	28	/* parent/child/sibling		*/
#define MPS_SPIN_ACCT		29	/* accounting			*/
#define MPS_SPIN_SIGNAL		30	/* p_sig modifications		*/
#define MPS_SPIN_PFLAG		31	/* p_flag modifications		*/
#define MPS_SPIN_CLKTIM		32	/* p_clktim modifications	*/
#define MPS_SPIN_SIGQ		33	/* p_sigqueue modifications	*/
#define MPS_SPIN_NPROC		34	/* misc. process thingies	*/
#define MPS_SEMA_ZOMBIE		35	/* process zombie still running	*/
#define MPS_SEMA_EXITING	36	/* process exiting		*/
#define MPS_SEMA_VFORK		37	/* vfork semaphore		*/
#define MPS_SPIN_ZWAIT		38	/* zombie to wakeup parent	*/
#define MPS_SPIN_PGORPH		39	/* pid_pgorphaned set/check	*/
#define	MPS_SPIN_BUF		40	/* individual buffer lock	*/
#define	MPS_SPIN_BUFMP		41	/* buffer list lock		*/
#define	MPS_SPIN_BUFMPF		42	/* buffer free list lock	*/
#define	MPS_SPIN_BASYNC		43	/* buffer async ctl. lock	*/
#define	MPS_SPIN_PGBUF		44	/* buffer/page interface lock	*/
#define	MPS_SEMA_SBUF		45	/* dksize buffer lock		*/
#define	MPS_SPIN_FILEE		46	/* individual file table entry lock	*/
#define	MPS_SPIN_FILE		47	/* file table lock		*/
#define	MPS_SEMA_PFREE		48	/* pfree buf allocation semaphore	*/
#define	MPS_SPIN_PFREE		49	/* pfree list protection	*/
#define	MPS_SPIN_FLCKI		50	/* flckinfo protection		*/
#define	MPS_SPIN_VFLCKS		51	/* vnode flock list		*/
#define	MPS_SPIN_SLPFLCK	52	/* flock sleep lock list	*/
#define	MPS_SPIN_TIMEOUT	53	/* timeout processing */
#define	MPS_SPIN_ONESEC		54	/* one second clock processing */
#define	MPS_SPIN_DELAYWAKE	55	/* delaywakeup() mplock */
#define	MPS_SPIN_UNIQTIME	56	/* uniqtime_mplock */
#define MPS_PAGEOUT		57	/* Pageout read/write lock */
#define MPS_V_PAGELOCK		58	/* Vnode page chain lock */
#define MPS_P_PAGELOCK		59	/* Page lock */
#define MPS_PAGE_WANT		60	/* Page want lock */
#define MPS_SMD_LOCK		61	/* Segmap specific data lock */
#define MPS_SMD_WANT		62	/* Segmap smap want lock */
#define MPS_PAGE_HASH		63	/* Page hash table/chains lock */
#define MPS_PAGE_FREE		64	/* Page free/cache lists lock */
#define MPS_DELMEM		65	/* Delmem linked list lock */
#define MPS_SPIN_VFSLIST	66	/* vfs list lock */
#define MPS_SPIN_STABLE		67	/* snode hash table lock */
#define MPS_SPIN_STABLEE	68	/* individual snode hash table entry */
#define MPS_SPIN_VNODE		69	/* vnode lock */
#define MPS_AUTO_FSCOMPAT	70	/* file system compatibility sema */
#define	MPS_SPIN_DISP		71	/* General Dispatcher lock */
#define	MPS_SPIN_TS		72	/* TS Dispatcher lock */
#define	MPS_SPIN_SEGU		73	/* Seg_u ublock management	*/
#define MPS_ANON		74	/* Swap area specific data lock */
#define MPS_SEMA_DMACHAN	75	/* DMA channel semaphore */
#define MPS_SPIN_DMACHANLCK	76	/* DMAC channel lock */
#define MPS_SPIN_EDMACBUFLCK	77	/* EISA DMA channel buffer lock */
#define MPS_SPIN_DMAHDLCK	78	/* DMA channel buffer header lock */
#define MPS_SEMA_DMAHDCHAN	79	/* DMA channel header semaphore */
#define MPS_SPIN_DMAPGLCK	80	/* DMA page lock */
#define MPS_SPIN_DMASLPLCK	81	/* DMA sleep lock */
#define MPS_SPIN_PIOMAPNEEDLCK	82	/* piomapneed lock */
#define MPS_SPIN_DMACINTRLCK	83	/* i82380 INTR lock */
#define MPS_SPIN_MAPINLCK	84	/* mapin_count lock */
#define	MPS_SPIN_RT		85	/* RT Dispatcher lock */
#define MPS_SPIN_CFLIST		86	/* cfreelist & clist lock */
#define MPS_ANONMAP		87	/* Anonmap lock */
#define MPS_TLBSHOOT		88	/* TLB shootdown lock */
#define	MPS_SPIN_FTABLE		89	/* fifonode hash table lock */
#define	MPS_SPIN_FTABLEE	90	/* individual fifonode lock */
#define	MPS_SPIN_SYSWAIT	91	/* lock for syswait */
#define	MPS_SPIN_CINFO		92	/* cpuinfo lock */
#define MPS_SPIN_BCLNLIST	93	/* block clean list lock */
#define	MPS_SPIN_PRNODE		94	/* /proc node lock */
#define	MPS_SPIN_PRPID		95	/* /proc proc pid lock */
#define	MPS_SPIN_PTRACE		96	/* ptrace lock */
#define	MPS_SPIN_AIOBUF		97	/* async I/O buffer allocation lock */
#define	MPS_SPIN_AIOQ		98	/* async I/O queue lock */
#define	MPS_SPIN_LICENSE	99	/* per-user licensing - i386 */
#define	MPS_SPIN_UTSNAME	100	/* lock for utsname structure */
#define	MPS_SPIN_USEMA		101	/* spin lock for user semaphores */
#define	MPS_SPIN_UMSG		102	/* spin lock for user messages */
#define	MPS_SPIN_USHM		103	/* spin lock for user shared memory */
#define MPS_SPIN_BSUP		104	/* bfs super block lock */
#define MPS_SPIN_BCORE		105	/* bfs incore vnode list lock */
#define MPS_SPIN_NAMEFS		106	/* namefs lock */
#define	MPS_SPIN_FSS		107	/* FSS dispatcher lock - mips */
#define	MPS_FAIR_SPIN_FSS	108	/* FSS fss_fair table lock - mips */
#define	MPS_HAT			109	/* HAT mplock mpstats collection - mips */
#define	MPS_SPIN_HRT		110	/* High Res timer locks */
#define	MPS_SPIN_STR_Q		111	/* STREAMS - per queue msg list lock */
#define	MPS_SPIN_STR_QX		112	/* STREAMS - per stream lock */
#define	MPS_SPIN_STR_QI		113	/* STREAMS - per queue internal lock */
#define	MPS_SPIN_STR_LINK	114	/* STREAMS - global mux link lock */
#define	MPS_SPIN_STR_RUNQ	115	/* STREAMS - global job queue lock */
#define	MPS_SPIN_STR_ALLC	116	/* STREAMS - global resource lock */
#define	MPS_SPIN_STR_SCAN	117	/* STREAMS - global scan queue lock */
#define	MPS_SPIN_STR_PUSH	118	/* STREAMS - global autopush lock */
#define MPS_SEMA_STR_LINK	119	/* STREAMS - global mux link sema */
#define MPS_SPIN_STR_BC		120	/* STREAMS - global bufcall lock */
#define MPS_SPIN_STR_QS		121	/* STREAMS - per stream USL lock */
#define MPS_SPIN_STR_TWIST	122	/* STREAMS - per twisted stream lock */
#define MPS_SPIN_DRSP		123	/* COMPAT - driver state structure */
#define	MPS_SPIN_STATIS		124	/* Statis - hash spinlock */
#define	MPS_SEMA_STATIS		125	/* Statis - rdwr semaphore */
#define	MPS_SPIN_PIRSEND	126	/* Pirsend - control lock */
#define	MPS_SPIN_KMP		127	/* KMP - shared spin bucket */
#define	MPS_SEMA_KMP		128	/* KMP - shared sema bucket */
#define	MPS_SEMA_SESSION	129	/* session semaphore */
#define MPS_HAT_RDWR_LOCK	130	/* HAT read/write lock */
#define	MPS_HAT_ACLIST_LOCK	131	/* HAT active list lock */
#define	MPS_HAT_MCLIST_LOCK	132	/* HAT mapping chunk lock */
#define	MPS_HAT_AS_LOCK		133	/* HAT address space lock */
#define	MPS_HAT_PP_LOCK		134	/* HAT page mapping lock */
#define	MPS_SPIN_TIME		135	/* hrestime lock */
#define	MPS_SPIN_UFS_ALLOC	136	/* UFS inode/block allocation locks */
#define	MPS_SPIN_UFS_INODE	137	/* UFS inode spinlock */
#define	MPS_SPIN_UFS_ITABLE	138	/* UFS inode table lock */
#define	MPS_SPIN_UFS_QUOTA	139	/* UFS quota spinlock */
#define	MPS_SPIN_UFS_RENAME	140	/* UFS rename spinlock */
#define	MPS_SPIN_DISPQ		141	/* Dispatcher queue slot lock */
#define	MPS_SPIN_SESSION	142	/* Spinlock on session */
#define	MPS_SPIN_V86TAB  	143	/* VPIX v86tablock */
#define	MPS_SPIN_S5FH		144	/* S5 inode free/hash list lock */
#define	MPS_SPIN_S5INO		145	/* S5 individual inode lock */
#define	MPS_SPIN_S5VFS		146	/* S5 vfs lock */
#define	MPS_SPIN_S5SBI		147	/* S5 superblock inode free list lck */
#define	MPS_SPIN_S5SBB		148	/* S5 superblock block free list lck */
#define	MPS_HAT_SHPT_LOCK	149	/* HAT shared page tables list */
#define	MPS_SPIN_FILE_REC	150	/* Used for sleep queue in os/flock.c */
#define	MPS_SPIN_EUA_LOCK	151	/* enable user alloc lock in os/mod.c */
#define	MPS_ABI_TEST_AND_SET	152	/* ABI test and set lock */
/* Gap */
#define	MPS_SPIN_INP_LCK	162	/* pcb chain rdwr lock */
#define	MPS_SPIN_TCP_SOCKET	163	/* pcb socket lock */
#define	MPS_SPIN_TCP_LCK	164	/* general TCP lock */
#define	MPS_SPIN_TCP_QBOT	165	/* TCP qbot rdwr lock */
#define	MPS_SPIN_UDP_LCK	166	/* general UDP lock */
#define	MPS_SPIN_LOOP_DRVR	167	/* Loopback driver lock */
#define	MPS_SPIN_RTE_LCK	168	/* Routing table lock */
#define	MPS_SPIN_PROV_TBL	169	/* Provider table rdwr lock */
#define	MPS_SPIN_IPPCB_LCK	170	/* IP up queue rdwr lock */
#define	MPS_SPIN_IP_FRAGQ	171	/* IP fragment reass lock */
#define	MPS_SPIN_APP_PCB	172	/* ARP/APP pcb rdwr lock */
#define	MPS_SPIN_ARP_TBL	173	/* ARP table lock */
#define	MPS_SPIN_GEU_LCK        174	/* TPE iocb chain lock */
#define IM_MAXASYNC             1002    /* defines for crash - CPP delimiter */

#define	MPS_SBUF_SZ		200	/* Size of stats buffer		*/

#ifdef u3b2v4
#ifndef _SMP
#define	eval_bindings(p)
#define	release_bindings(p)
#endif
#endif


#ifdef _KERNEL

extern	mpstats_t	mpsbuf[MPS_SBUF_SZ];

#ifdef _MPSTATS

#if 0	/* ##arana: not implemented yet */
#define MPSASSERT_ENABLED(mode)		__ASSERTENABLED(MPSTATS_ASSERT, mode)
#else
#define MPSASSERT_ENABLED(mode)		1		
#endif

/* Macros for collecting MPSTATS information
 */

#define	MPS_REQ(s, i)	if (s) (s)->mps_req[i]++
#define MPS_COL(s)	if (s) (s)->mps_col++
#define MPS_TIME(s)	if (s) (s)->mps_time++

#else /* _MPSTATS */ 

#define MPSASSERT_ENABLED(mode)		0

#define	MPS_REQ(s, i)	
#define MPS_COL(s)
#define MPS_TIME(s)

#endif /* _MPSTATS */

/*
 * The following macros simplify access to the stat buffers:
 */
#define STAT_PRA		&mpsbuf[MPS_SPIN_PRA]
#define STAT_KIN		&mpsbuf[MPS_SPIN_KIN]
#define STAT_PGRP		&mpsbuf[MPS_SPIN_PGRP]
#define STAT_CRED		&mpsbuf[MPS_SPIN_CRED]
#define STAT_PID		&mpsbuf[MPS_SPIN_PID]
#define STAT_PARENTCHILD	&mpsbuf[MPS_SPIN_PARENTCHILD]
#define STAT_ACCT		&mpsbuf[MPS_SPIN_ACCT]
#define STAT_SIGNAL		&mpsbuf[MPS_SPIN_SIGNAL]
#define STAT_P_FLAG		&mpsbuf[MPS_SPIN_PFLAG]
#define STAT_P_CLKTIM		&mpsbuf[MPS_SPIN_CLKTIM]
#define STAT_P_SIGQ		&mpsbuf[MPS_SPIN_SIGQ]
#define STAT_NPROC		&mpsbuf[MPS_SPIN_NPROC]
#define STAT_ZOMBIE		&mpsbuf[MPS_SEMA_ZOMBIE]
#define STAT_EXITING		&mpsbuf[MPS_SEMA_EXITING]
#define STAT_VFORK		&mpsbuf[MPS_SEMA_VFORK]
#define STAT_ZWAIT		&mpsbuf[MPS_SPIN_ZWAIT]
#define STAT_PGORPH		&mpsbuf[MPS_SPIN_PGORPH]
#define	STAT_TIME		&mpsbuf[MPS_SPIN_TIME]

/*
 * The following macros have been used on certain locks which
 * allow easy and fast transition between normal spin locks and
 * read/write spin locks. This allows for maximal performance
 * based upon hardware architecture.
 */
#if 1
#define	SWITCHABLE_PSPIN(lck,rw,stb) 		PSPIN(lck,stb)
#define	SWITCHABLE_CPSPIN(lck,rw,stb) 		CPSPIN(lck,stb)
#define	SWITCHABLE_VSPIN(lck,stb)		VSPIN(lck,stb)
#define SWITCHABLE_is_readlocked(lck)		is_spinlocked(lck)
#define SWITCHABLE_is_writelocked(lck)		is_spinlocked(lck)
#define SWITCHABLE_is_NOT_readlocked(lck)	is_NOT_spinlocked(lck)
#define SWITCHABLE_is_NOT_writelocked(lck)	is_NOT_spinlocked(lck)
#else
#define	SWITCHABLE_PSPIN(lck,rw,stb) 		RDWR_PSPIN(lck,rw,stb)
#define	SWITCHABLE_CPSPIN(lck,rw,stb) 		RDWR_CPSPIN(lck,rw,stb)
#define	SWITCHABLE_VSPIN(lck,stb) 		RDWR_VSPIN(lck,stb)
#define SWITCHABLE_is_readlocked(lck)		is_readlocked(lck)
#define SWITCHABLE_is_writelocked(lck)		is_writelocked(lck)
#define SWITCHABLE_is_NOT_readlocked(lck)	is_NOT_readlocked(lck)
#define SWITCHABLE_is_NOT_writelocked(lck)	is_NOT_writelocked(lck)
#endif

/*
 * Miscellaneous Switchable Lock Declarations - when toggling
 * the switch, the lock initialization also must be changed
 * in the file os/pid.c
 */
#if 1
extern lck_t kinshiplock;
extern lck_t pgrplock;
extern lck_t pidlock;
#else
extern rdwrlck_t kinshiplock;
extern rdwrlck_t pgrplock;
extern rdwrlck_t pidlock;
#endif

/*
 * Miscellaneous Lock Declarations
 */
extern lck_t credlock;
extern lck_t nproclock;
extern lck_t pgorphlock;
extern lck_t *practivelock;


/*
 * To make life simpler for the VM code conversion
 */
#define	VNPAGE_PSPIN(lck, stb)		NCXT_PSPIN(lck, stb)
#define	VNPAGE_CPSPIN(lck, stb)		NCXT_CPSPIN(lck, stb)
#define	VNPAGE_VSPIN(lck, stb)		NCXT_VSPIN(lck, stb)
#define	VNPAGE_CPSPIN_INTR(lck, stb)	NCXT_CPSPIN_INTR(lck, stb)
#define	VNPAGE_VSPIN_INTR(lck, stb)	NCXT_VSPIN_INTR(lck, stb)

#ifdef _LOCKTEST

#ifdef _MPSTATS
#define	_MDBGFLG	LCK_LOCKTEST|LCK_MPSTATS
#else
#define	_MDBGFLG	LCK_LOCKTEST
#endif

#else

#ifdef	_MPSTATS
#define	_MDBGFLG	LCK_MPSTATS
#else
#define	_MDBGFLG	0
#endif

#endif

#ifdef _SMP

extern	void	pspin(lck_t *);
extern	int	cpspin(lck_t *);
extern	void	vspin(lck_t *);
extern	void	queued_pspin(struct queued_lock *);
extern	int	queued_cpspin(struct queued_lock *);
extern	void	queued_vspin(struct queued_lock *);

#if defined(_MPSTATS) || defined(_LOCKTEST)

/*
 * Wrappers functions to collect statistics and do locktesting.
 * These involve other functions to do some of this work.
 */

#ifdef __STDC__

extern	void	mps_initspin();
extern	void	mps_initsema();
extern	void	mps_pspin(lck_t *, mpstats_t *, int);
extern	int	mps_cpspin(lck_t *, mpstats_t *, int);
extern	void	mps_vspin(lck_t *, mpstats_t *);

extern	void	mps_reent_pspin(reentlck_t *, mpstats_t *, int);
extern	int	mps_reent_cpspin(reentlck_t *, mpstats_t *, int);
extern	void	mps_reent_vspin(reentlck_t *, mpstats_t *);

extern	int	mps_rdwr_pspin(rdwrlck_t *, int, mpstats_t *, int);
extern	int	mps_rdwr_cpspin(rdwrlck_t *, int, mpstats_t *, int);
extern	void	mps_rdwr_vspin(rdwrlck_t *, mpstats_t *);

extern	void	mps_ncxt_pspin(ncxtlck_t *, mpstats_t *, int);
extern	int	mps_ncxt_cpspin(ncxtlck_t *, mpstats_t *, int);
extern	void	mps_ncxt_vspin(ncxtlck_t *, mpstats_t *);
extern	int	mps_ncxt_cpspin_intr(ncxtlck_t *, mpstats_t *, int);
extern	void	mps_ncxt_vspin_intr(ncxtlck_t *, mpstats_t *);

extern	int	mps_rdwr_psema(rdwrsema_t *, int, int, mpstats_t *);
extern	int	mps_rdwr_cpsema(rdwrsema_t *, int, mpstats_t *);
extern	int	mps_rdwr_vsema(rdwrsema_t *, mpstats_t *);

extern	void	catch_deadlock(lck_t *);
extern	int	backoff_delay(lck_t *);
extern	int	backoff_busdelay(void);
extern	int	maxspins;

#else	/* __STDC__ */

extern	void	mps_initspin();
extern	void	mps_initsema();
extern	void	mps_pspin();
extern	int	mps_cpspin();
extern	void	mps_vspin();

extern	void	mps_reent_pspin();
extern	int	mps_reent_cpspin();
extern	void	mps_reent_vspin();

extern	int	mps_rdwr_pspin();
extern	int	mps_rdwr_cpspin();
extern	void	mps_rdwr_vspin();

extern	void	mps_ncxt_pspin();
extern	int	mps_ncxt_cpspin();
extern	void	mps_ncxt_vspin();
extern	int	mps_ncxt_cpspin_intr();
extern	void	mps_ncxt_vspin_intr();

extern	int	mps_rdwr_psema();
extern	int	mps_rdwr_cpsema();
extern	int	mps_rdwr_vsema();

extern	void	catch_deadlock();
extern	int	backoff_delay();
extern	int	backoff_busdelay();
extern	int	maxspins;
 
#endif /* __STDC__ */

#define	INITSPIN(lck,type,pl,lvl,name)	mps_initspin((caddr_t)(lck),type|_MDBGFLG,pl,lvl)

#ifdef _MPPRFSTATS
#define PSPIN(lck,stb)			mps_pspin(lck,stb,getpc())
#define PSPINSAME(lck,stb)		mps_pspin(lck,stb,getpc())
#define CPSPIN(lck,stb)			mps_cpspin(lck,stb,getpc())
#define QUEUED_PSPIN(lck,stb)		mps_pspin((lck_t *)(lck),stb,getpc())
#define QUEUED_CPSPIN(lck,stb)		mps_cpspin((lck_t *)(lck),stb,getpc())
#else
#define PSPIN(lck,stb)			mps_pspin(lck,stb,0)
#define PSPINSAME(lck,stb)		mps_pspin(lck,stb,LTEST_SAMEOK)
#define CPSPIN(lck,stb)			mps_cpspin(lck,stb,0)
#define QUEUED_PSPIN(lck,stb)		mps_pspin((lck_t *)(lck),stb,0)
#define QUEUED_CPSPIN(lck,stb)		mps_cpspin((lck_t *)(lck),stb,0)
#endif
#define	VSPIN(lck,stb)			mps_vspin(lck,stb)
#define	QUEUED_VSPIN(lck,stb)		mps_vspin((lck_t *)(lck), stb)

#define	REENT_PSPIN(lck,stb)		mps_reent_pspin(lck,stb,0)
#define	REENT_CPSPIN(lck,stb)		mps_reent_cpspin(lck,stb,0)
#define	REENT_VSPIN(lck,stb)		mps_reent_vspin(lck,stb)

#define	RDWR_PSPIN(lck,rw,stb)		mps_rdwr_pspin(lck,rw,stb,0)
#define	RDWR_PSPINSAME(lck,rw,stb)	mps_rdwr_pspin(lck,rw,stb,LTEST_SAMEOK)
#define	RDWR_CPSPIN(lck,rw,stb)		mps_rdwr_cpspin(lck,rw,stb,0)
#define	RDWR_VSPIN(lck,stb)		mps_rdwr_vspin(lck,stb)
#define RDWR_FREE(lck,stb)		mps_rdwr_free(lck,stb)

#define READ_PSPIN(lck,stb)		mps_rdwr_pspin(lck,RDWR_READ,stb,0)
#define WRITE_PSPIN(lck,stb)		mps_rdwr_pspin(lck,RDWR_WRITE,stb,0)

#define READ_PSPINSAME(lck,stb)		mps_rdwr_pspin(lck,RDWR_READ,stb,LTEST_SAMEOK)
#define WRITE_PSPINSAME(lck,stb)	mps_rdwr_pspin(lck,RDWR_WRITE,stb,LTEST_SAMEOK)

#define WRTORD_PSPIN(lck,stb)		mps_rdwr_pspin(lck,RDWR_WRTORD,stb,0)
#define RDTOWR_PSPIN(lck,stb)		mps_rdwr_pspin(lck,RDWR_RDTOWR,stb,0)

#define WRTORD_CPSPIN(lck,stb)		mps_rdwr_cpspin(lck,RDWR_WRTORD,stb,0)
#define RDTOWR_CPSPIN(lck,stb)		mps_rdwr_cpspin(lck,RDWR_RDTOWR,stb,0)

#ifdef _MPPRFSTATS
#define	NCXT_PSPIN(lck, stb)		mps_ncxt_pspin(lck,stb,getpc())
#define	NCXT_CPSPIN(lck, stb)		mps_ncxt_cpspin(lck,stb,getpc())
#define	NCXT_CPSPIN_INTR(lck, stb)	mps_ncxt_cpspin_intr(lck,stb,getpc())
#else
#define	NCXT_PSPIN(lck, stb)		mps_ncxt_pspin(lck,stb,0)
#define	NCXT_CPSPIN(lck, stb)		mps_ncxt_cpspin(lck,stb,0)
#define	NCXT_CPSPIN_INTR(lck, stb)	mps_ncxt_cpspin_intr(lck,stb,0)
#endif
#define	NCXT_VSPIN(lck, stb)		mps_ncxt_vspin(lck,stb)
#define NCXT_FREE(lck,stb)		mps_ncxt_free(lck,stb)
#define	NCXT_VSPIN_INTR(lck, stb)	mps_ncxt_vspin_intr(lck,stb)

#else	/* _MPSTATS || _LOCKTEST */

#ifdef __STDC__

extern	void	initspin();
extern	void	initsema();

extern	void	reent_pspin(reentlck_t *);
extern	int	reent_cpspin(reentlck_t *);
extern	void	reent_vspin(reentlck_t *);

extern	int	rdwr_pspin(rdwrlck_t *, int);
extern	int	rdwr_cpspin(rdwrlck_t *, int);
extern	void	rdwr_vspin(rdwrlck_t *);

extern	void	ncxt_pspin(ncxtlck_t *);
extern	int	ncxt_cpspin(ncxtlck_t *);
extern	void	ncxt_vspin(ncxtlck_t *);
extern	int	ncxt_cpspin_intr(ncxtlck_t *);
extern	void	ncxt_vspin_intr(ncxtlck_t *);

extern	int	rdwr_psema(rdwrsema_t *, int, int);
extern	int	rdwr_cpsema(rdwrsema_t *, int);
extern	int	rdwr_vsema(rdwrsema_t *);

extern	void	catch_deadlock(lck_t *);
extern	int	backoff_delay(lck_t *);
extern	int	backoff_busdelay(void);
extern	int	maxspins;

#else /* __STDC__ */

extern	void	initspin();
extern	void	initsema();
extern	void	pspin();
extern	int	cpspin();
extern	void	vspin();
extern	void	queued_pspin();
extern	int	queued_cpspin();
extern	void	queued_vspin();

extern	void	reent_pspin();
extern	int	reent_cpspin();
extern	void	reent_vspin();

extern	int	rdwr_pspin();
extern	int	rdwr_cpspin();
extern	void	rdwr_vspin();

extern	void	ncxt_pspin();
extern	int	ncxt_cpspin();
extern	void	ncxt_vspin();
extern	int	ncxt_cpspin_intr();
extern	void	ncxt_vspin_intr();

extern	int	rdwr_psema();
extern	int	rdwr_cpsema();
extern	int	rdwr_vsema();

extern	void	catch_deadlock();
extern	int	backoff_delay();
extern	int	backoff_busdelay();
extern	int	maxspins;

#endif /* __STDC__ */
 
/*
 * Normal versions of the spin locking
 * primitives that do not collect statistics or
 * do locktesting
 */

#define	INITSPIN(lck,type,pl,lvl,name)	initspin((caddr_t)(lck),type,pl,lvl)

#define	PSPIN(lck,stb)			pspin(lck)
#define	PSPINSAME(lck,stb)		pspin(lck)
#define	CPSPIN(lck,stb)			cpspin(lck)
#define	VSPIN(lck,stb)			vspin(lck)
#define	QUEUED_PSPIN(lck,stb)		queued_pspin((struct queued_lock *)(lck))
#define	QUEUED_CPSPIN(lck,stb)		queued_cpspin((struct queued_lock *)(lck))
#define	QUEUED_VSPIN(lck,stb)		queued_vspin((struct queued_lock *)(lck))

#define	REENT_PSPIN(lck,stb)		reent_pspin(lck)
#define	REENT_CPSPIN(lck,stb)		reent_cpspin(lck)
#define	REENT_VSPIN(lck,stb)		reent_vspin(lck)

#define	RDWR_PSPIN(lck,rw,stb)		rdwr_pspin(lck,rw)
#define	RDWR_PSPINSAME(lck,rw,stb)	rdwr_pspin(lck,rw)
#define	RDWR_CPSPIN(lck,rw,stb)		rdwr_cpspin(lck,rw)
#define	RDWR_VSPIN(lck,stb)		rdwr_vspin(lck)
#define RDWR_FREE(lck,stb)		rdwr_free(lck)

#define READ_PSPIN(lck,stb)		rdwr_pspin(lck,RDWR_READ)
#define WRITE_PSPIN(lck,stb)		rdwr_pspin(lck,RDWR_WRITE)

#define READ_PSPINSAME(lck,stb)		rdwr_pspin(lck,RDWR_READ)
#define WRITE_PSPINSAME(lck,stb)	rdwr_pspin(lck,RDWR_WRITE)

#define WRTORD_PSPIN(lck,stb)		rdwr_pspin(lck,RDWR_WRTORD)
#define RDTOWR_PSPIN(lck,stb)		rdwr_pspin(lck,RDWR_RDTOWR)

#define WRTORD_CPSPIN(lck,stb)		rdwr_cpspin(lck,RDWR_WRTORD)
#define RDTOWR_CPSPIN(lck,stb)		rdwr_cpspin(lck,RDWR_RDTOWR)

#define	NCXT_PSPIN(lck, stb)		ncxt_pspin(lck) 	
#define	NCXT_CPSPIN(lck, stb)		ncxt_cpspin(lck) 	
#define	NCXT_VSPIN(lck, stb)		ncxt_vspin(lck) 	
#define NCXT_FREE(lck,stb)		ncxt_free(lck)
#define	NCXT_CPSPIN_INTR(lck, stb)	ncxt_cpspin_intr(lck) 
#define	NCXT_VSPIN_INTR(lck, stb)	ncxt_vspin_intr(lck) 	

#endif	/* _MPSTATS || _LOCKTEST */

#ifdef __pyrsoft
/*
 * Special reentrant locks routines that never do locktest.
 * These should only be used for very special circumstances.
 */
#ifdef __STDC__
extern	void	cpuwaitpspin(reentlck_t *);
extern	int	cpuwaitcpspin(reentlck_t *);
extern	void	cpuwaitvspin(reentlck_t *);
extern	void	cpuwaitislocked(reentlck_t *);
#else
extern	void	cpuwaitpspin();
extern	int	cpuwaitcpspin();
extern	void	cpuwaitvspin();
extern	void	cpuwaitislocked();
#endif
#endif	/* __pyrsoft */

#define	RDWR_ISLOCKED(lck,type)		((lck)->rw_status & (type))

#define	DEADCHK(lck,cnt) \
	{ \
		if ((cnt) <= 0) { \
			catch_deadlock(((lck_t *)lck)); \
			(cnt) = MAXWAITTIME; \
		} \
	}

#else	/* _SMP */

/*
 * Eliminate the locking primitives in
 * the uniprocessor case
 */

#define	INITSPIN(lck,type,pl,lvl,name)

#define	PSPIN(lck,stb)
#define PSPINSAME(lck,stb)
#define	CPSPIN(lck,stb)		0
#define	VSPIN(lck,stb)
#define	QUEUED_PSPIN(lck,stb)
#define	QUEUED_CPSPIN(lck,stb)		0
#define	QUEUED_VSPIN(lck,stb)

#define	REENT_PSPIN(lck,stb)
#define	REENT_CPSPIN(lck,stb)	0
#define	REENT_VSPIN(lck,stb)

#define	RDWR_PSPIN(lck,rw,stb)
#define	RDWR_PSPINSAME(lck,rw,stb)
#define	RDWR_CPSPIN(lck,rw,stb)	0
#define	RDWR_VSPIN(lck,stb)
#define	RDWR_FREE(lck,stb)	((lck_t*)NULL)

#define READ_PSPIN(lck,stb)
#define WRITE_PSPIN(lck,stb)

#define READ_PSPINSAME(lck,stb)
#define WRITE_PSPINSAME(lck,stb)

#define WRTORD_PSPIN(lck,stb)
#define RDTOWR_PSPIN(lck,stb)

#define WRTORD_CPSPIN(lck,stb)          0
#define RDTOWR_CPSPIN(lck,stb)          0

#define	NCXT_PSPIN(lck, stb)
#define	NCXT_CPSPIN(lck, stb)		0
#define	NCXT_VSPIN(lck, stb)
#define NCXT_FREE(lck,stb)		((lck_t*)NULL)
#define	NCXT_CPSPIN_INTR(lck, stb)	0
#define	NCXT_VSPIN_INTR(lck, stb)

#endif /* _SMP */

/*
 * Static declarations for spin and semaphore lock data
 * structures.  Use as:
 *
 * 	lck_t 		lck = SPIN_DECL(pl, lvl, name);
 * 	reentlck_t 	relck = REENTSPIN_DECL(pl, lvl, name);
 * 	rdwrlck_t 	rwlck = RDWRSPIN_DECL(pl, lvl, name);
 *	ncxtlck_t	nclck = NCXTSPIN_DECL(pl, lvl, name);
 *	sema_t		sem = SEMA_DECL(val, max, lvl, name);
 *	reentsema_t	resem = REENTSEMA_DECL(lvl, name);
 *	rdwrsema_t	rwsem = RDWRSEMA_DECL(lvl, name);
 *
 * where:
 *	
 *	pl = machine independent priority level this lock is to be locked at
 *	     (meaningless for semaphores)
 *	lvl = relative lock order
 *	name = string identifying or describing this lock
 *	max = maximum value for this semaphore
 *
 * NOTE: formerly these values (pl and lvl) were #defined in lockorder.h.
 * This has now gone away since all files in the kernel with locks declared
 * or intialized had to include it and would recompile anytime a new lock
 * was added. Instead, we now declare/initialize locks with an #defined SPL
 * (e.g. SPL_0) and a hex constant (e.g. 0x100). An additional argument, a
 * string is also required. A new utility is run to extract this information
 * and produce a formatted and sorted list of locks and levels.
 *
 */


#if LCK_BEEF_BEVOR > 0
#define LCK_BEEF_INIT_BEVOR {0},
#else
#define LCK_BEEF_INIT_BEVOR
#endif
#if LCK_BEEF_AFTER > 0
#define LCK_BEEF_INIT_AFTER {0},
#else
#define LCK_BEEF_INIT_AFTER
#endif

#ifdef _MPPRFSTATS

#define	SPIN_DECL(pl, lvl, name) \
		{ { 0, LCK_SPIN|_MDBGFLG, pl, lvl }, 0}
#define	QUEUED_SPIN_DECL(pl, lvl, name) { \
	{ { 0, LCK_QUEUED|_MDBGFLG, pl, lvl }, 0 }, \
	0, \
	Q_UNLOCKED, \
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, \
	-1, -1, -1, -1, -1, -1 \
}

#else /* ! _MPPRFSTATS */

#define	SPIN_DECL(pl, lvl, name) \
		{ 0, LCK_SPIN|_MDBGFLG, pl, lvl }
#define	QUEUED_SPIN_DECL(pl, lvl, name) { \
	{ 0, LCK_QUEUED|_MDBGFLG, pl, lvl }, \
	0, \
	Q_UNLOCKED, \
	-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, \
	-1, -1, -1, -1, -1, -1 \
}


#endif /* _MPPRFSTATS */

#define	REENTSPIN_DECL(pl, lvl, name) \
		{  SPIN_DECL(pl,lvl,name), LCK_SPIN|LCK_REENT|_MDBGFLG, 0, NOCPU }
#define	RDWRSPIN_DECL(pl, lvl, name)	\
		{ SPIN_DECL(pl,lvl,name), LCK_SPIN|LCK_RDWR|_MDBGFLG, 0, 0, 0 }
#define	NCXTSPIN_DECL(pl, lvl, name) \
		{  SPIN_DECL(pl,lvl,name), LCK_SPIN|LCK_NCXT|_MDBGFLG, 0, NOCPU }

#define	SEMA_DECL(val, lvl, name) \
	{ SPIN_DECL(SPL_HI, 0x7F0, "sema"), LCK_SEMA|_MDBGFLG, \
	  val, ((val == 0) ? 1 : val), NOCPU, ((struct proc *)NULL), \
	  ((struct proc *)NULL), ((struct proc *)NULL) }
#define	REENTSEMA_DECL(lvl, name) \
	{ SPIN_DECL(SPL_HI, 0x7F0, "sema"), LCK_SEMA|LCK_REENT|_MDBGFLG, \
	  0, NOCPU, ((struct proc *)NULL), ((struct proc *)NULL), \
	  ((struct proc *)NULL) }
#define	RDWRSEMA_DECL(lvl, name)	\
	{ SPIN_DECL(SPL_HI, 0x7F0, "sema"), LCK_SEMA|LCK_RDWR|_MDBGFLG, \
	  0, 0, NOCPU, ((struct proc *)NULL), ((struct proc *)NULL), \
	  ((struct proc *)NULL), ((struct proc *)NULL), ((struct proc *)NULL) }

#ifdef __STDC__

extern	void	initsema(caddr_t, int, int);
extern	int	valusema(sema_t *);

extern	int	rdwrsemachk(rdwrsema_t *, int, struct proc *);
extern	int	rdwrsemunlink(rdwrsema_t *, int, struct proc *);

extern	int	psema(sema_t *, int);
extern	int	cpsema(sema_t *);
extern	int	vsema(sema_t *);
extern	int	wsema(sema_t *, struct proc *, int);

extern	int	reent_psema(reentsema_t *, int);
extern	int	reent_cpsema(reentsema_t *);
extern	int	reent_vsema(reentsema_t *);

extern	int	pauto(sema_t *, int);
extern	int	cpauto(sema_t *);
extern	int	vauto(sema_t *);

extern	int	semunlink(sema_t *, struct proc *);
extern	int	reentsemunlink(reentsema_t *, struct proc *);

extern	int	is_spinlocked(lck_t *);
extern	int	is_relocked(reentlck_t *);
extern	int	is_readlocked(rdwrlck_t *);
extern	int	is_writelocked(rdwrlck_t *);

extern	lck_t	*rdwr_free(rdwrlck_t *);
extern	lck_t	*ncxt_free(ncxtlck_t *);

#else

extern	void	initsema();
extern	int	valusema();

extern	int	rdwrsemachk();
extern	int	rdwrsemunlink();

extern	int	psema();
extern	int	cpsema();
extern	int	vsema();
extern	int	wsema();

extern	int	reent_psema();
extern	int	reent_cpsema();
extern	int	reent_vsema();

extern	int	pauto();
extern	int	cpauto();
extern	int	vauto();

extern	int	semunlink();
extern	int	reentsemunlink();

extern	int	is_spinlocked();
extern	int	is_relocked();
extern	int	is_readlocked();
extern	int	is_writelocked();

extern	lck_t	*rdwr_free();
extern	lck_t	*ncxt_free();

#endif /* __STDC__ */

#if	defined(_MPSTATS) || defined(_LOCKTEST)

/*
 * Versions of the semaphores that collect
 * locking statistics.
 */

#ifdef __STDC__

extern	int	mps_psema(sema_t *, int, mpstats_t *);
extern	int	mps_cpsema(sema_t *, mpstats_t *);
extern	int	mps_vsema(sema_t *, mpstats_t *);
extern	int	mps_wsema(sema_t *, struct proc *, int, mpstats_t *);

extern	int	mps_reent_psema(reentsema_t *, int, mpstats_t *);
extern	int	mps_reent_cpsema(reentsema_t *, mpstats_t *);
extern	int	mps_reent_vsema(reentsema_t *, mpstats_t *);

extern	int	mps_rdwr_psema(rdwrsema_t *, int, int, mpstats_t *);
extern	int	mps_rdwr_cpsema(rdwrsema_t *, int, mpstats_t *);
extern	int	mps_rdwr_vsema(rdwrsema_t *, mpstats_t *);

extern	int	mps_pauto(sema_t *, int, mpstats_t *);
extern	int	mps_cpauto(sema_t *, mpstats_t *);
extern	int	mps_vauto(sema_t *, mpstats_t *);

#else

extern	int	mps_psema();
extern	int	mps_cpsema();
extern	int	mps_vsema();
extern	int	mps_wsema();

extern	int	mps_reent_psema();
extern	int	mps_reent_cpsema();
extern	int	mps_reent_vsema();

extern	int	mps_rdwr_psema();
extern	int	mps_rdwr_cpsema();
extern	int	mps_rdwr_vsema();

extern	int	mps_pauto();
extern	int	mps_cpauto();
extern	int	mps_vauto();

#endif /* __STDC__ */

#define	INITSEMA(sema,semtype,val,name) mps_initsema((caddr_t)sema,semtype|_MDBGFLG,val)

#define	PSEMA(sema,disp,stb)		mps_psema(sema,disp,stb)
#define	CPSEMA(sema,stb)		mps_cpsema(sema,stb)
#define	VSEMA(sema,stb)			mps_vsema(sema,stb)
#define	WSEMA(sema,p,pflg,stb)		mps_wsema(sema,p,pflg,stb)

#define	REENT_PSEMA(sema,disp,stb)	mps_reent_psema(sema,disp,stb)
#define	REENT_CPSEMA(sema,stb)		mps_reent_cpsema(sema,stb)
#define	REENT_VSEMA(sema,stb)		mps_reent_vsema(sema,stb)

#define	RDWR_PSEMA(sema,rw,disp,stb)	mps_rdwr_psema(sema,rw,disp,stb)
#define	RDWR_CPSEMA(sema,rw,stb)	mps_rdwr_cpsema(sema,rw,stb)
#define	RDWR_VSEMA(sema,stb)		mps_rdwr_vsema(sema,stb)

#else	/* _MPSTATS || _LOCKTEST */

/*
 * The normal versions of the semaphores
 * that do not collect statistics.
 */
#define	INITSEMA(sema,semtype,val,name)	initsema((caddr_t)sema,semtype,val)

#define	PSEMA(sema,disp,stb)		psema(sema,disp)
#define	CPSEMA(sema,stb)		cpsema(sema)
#define	VSEMA(sema,stb)			vsema(sema)
#define	WSEMA(sema,p,pflg,stb)		wsema(sema,p,pflg)

#define	REENT_PSEMA(sema,disp,stb)	reent_psema(sema,disp)
#define	REENT_CPSEMA(sema,stb)		reent_cpsema(sema)
#define	REENT_VSEMA(sema,stb)		reent_vsema(sema)

#define	RDWR_PSEMA(sema,rw,disp,stb)	rdwr_psema(sema,rw,disp)
#define	RDWR_CPSEMA(sema,rw,stb)	rdwr_cpsema(sema,rw)
#define	RDWR_VSEMA(sema,stb)		rdwr_vsema(sema)

#endif	/* _MPSTATS || _LOCKTEST */

#define	VALUSEMA(sema)			valusema(sema)

#define	INITSEMVAL(sema, val)		(sema)->s_val = (val); \
					(sema)->s_maxval = \
						((val) == 0) ? 1 : (val)

#ifdef	_SMP

#define	AUTOSAVE(s) { \
	(s)->save_fs = u.u_fssema; \
	(s)->save_drsp = u.u_drsp; \
}

#define AUTORESTORE(s) { \
	u.u_fssema = (s)->save_fs; \
	u.u_drsp = (s)->save_drsp; \
}

#else  /* _SMP */

#define	AUTOSAVE(s)
#define	AUTORESTORE(s)

#endif /* _SMP */

/*
 * Atomic arithmetic manipulation routines
 */

#ifdef __STDC__

extern	long	atom_setl(long *, long);

extern	long	atom_incrl(long *, long);
extern	long	atom_decrl(long *, long);

extern	long	atom_andl(long *, long);
extern	long	atom_orl(long *, long);

#else

extern	long	atom_setl();

extern	long	atom_incrl();
extern	long	atom_decrl();

extern	long	atom_andl();
extern	long	atom_orl();

#endif /* __STDC__ */


#define	LOCK_LOG_SIZE	1024		/* Size of lock log */

#if defined(_SMP) && defined(A20R)
/* _SMP_A20R: */

#ifdef _LOCKTEST

#ifdef __STDC__

extern	void	lock_log(int, caddr_t, int, int, int, int, int, int);

#else

extern	void	lock_log();

#endif 	/* __STDC__ */

/* Macros for logging spinlock ops
 */


/* the return address is get by get_caller() instead of getra() */

#define SPINLOGBEGIN(lck, type, lop, a, b, c, d) { \
		if (__ASSERTENABLED(LOCKTEST_ASSERT,ASSERT_MODE2)) \
		    lock_log(get_caller(2), (caddr_t)(lck), (type), (lop)|LLOG_BEGIN, a, b, c, d); \
	}

#define SPINLOGEND(lck, type, lop, a, b, c, d) { \
		if (__ASSERTENABLED(LOCKTEST_ASSERT,ASSERT_MODE2)) \
		    lock_log(get_caller(2), (caddr_t)(lck), (type), (lop)|LLOG_END, a, b, c, d); \
	}

/* Macros for logging semaphore ops
 */

#define SEMALOGBEGIN(sem, type, lop, a, b, c, d) { \
		if (__ASSERTENABLED(LOCKTEST_ASSERT,ASSERT_MODE2)) \
		    lock_log(get_caller(2), (caddr_t)(sem), (type), (lop)|LLOG_BEGIN, a, b, c, d); \
	}

#define SEMALOGEND(sem, type, lop, a, b, c, d) { \
		if (__ASSERTENABLED(LOCKTEST_ASSERT,ASSERT_MODE2)) \
		    lock_log(get_caller(2), (caddr_t)(sem), (type), (lop)|LLOG_END, a, b, c, d); \
	}
#else /* _LOCKTEST */

#define SPINLOGBEGIN(lck, type, lop, a, b, c, d) 
#define SPINLOGEND(lck, type, lop, a, b, c, d) 

#define SEMALOGBEGIN(sem, type, lop, a, b, c, d)
#define SEMALOGEND(sem, type, lop, a, b, c, d)

#endif	/* _LOCKTEST */

#else /* ! (_SMP && A20R) */

/*
 * Lock operation log - maintained by lock_log()
 * that is called from the individual primitives
 */
typedef struct {
	caddr_t		lg_lock;	/* Address of lock */
        int		lg_caller;	/* Address of caller */
        unsigned short	lg_info;	/* Lock type/variation */
        unsigned short	lg_op;		/* Operation on lock */
        int		lg_secs;	/* Second of lock op */
	int		lg_nsecs;	/* Nanosecs at log time */
        cpuid_t		lg_cpu;		/* CPU requesting lock op. */
        int		lg_data[4];	/* Lock-specific data */
} lock_log_t;

#ifdef _LOCK_LOG

extern	int	lock_log_enable;

#define SPINLOGBEGIN(lck, type, lop, a, b, c, d) { \
	if (lock_log_enable) \
		lock_log(getra(), (caddr_t)(lck), (type), (lop)|LLOG_BEGIN, a, b, c, d); \
	}

#define SPINLOGEND(lck, type, lop, a, b, c, d) { \
	if (lock_log_enable) \
		lock_log(getra(), (caddr_t)(lck), (type), (lop)|LLOG_END, a, b, c, d); \
	}

/* Macros for logging semaphore ops
 */

#define SEMALOGBEGIN(sem, type, lop, a, b, c, d) { \
	if (lock_log_enable) \
		lock_log(getra(), (caddr_t)(sem), (type), (lop)|LLOG_BEGIN, a, b, c, d); \
	}

#define SEMALOGEND(sem, type, lop, a, b, c, d) { \
	if (lock_log_enable) \
		lock_log(getra(), (caddr_t)(sem), (type), (lop)|LLOG_END, a, b, c, d); \
	}

#else /* _LOCK_LOG */

#define SPINLOGBEGIN(lck, type, lop, a, b, c, d) 
#define SPINLOGEND(lck, type, lop, a, b, c, d) 

#define SEMALOGBEGIN(sem, type, lop, a, b, c, d)
#define SEMALOGEND(sem, type, lop, a, b, c, d)

#endif	/* _LOCK_LOG */

#endif	/* (_SMP && A20R) */

/*
 * Things to make locktest and SMP spls all work.
 */

extern	volatile cpuid_t bindmap[];

#ifdef _SMP

#define	SLEEPFREE1(chan,pri,lp1)	    sleepfree(chan,pri,lp1,0)
#define	SLEEPFREE2(chan,pri,lp1,lp2)	    sleepfree(chan,pri,lp1,lp2,0)
#define	SLEEPFREE3(chan,pri,lp1,lp2,lp3)    sleepfree(chan,pri,lp1,lp2,lp3,0)

#define	WAKEUP1(chan)			    wakeup1(chan)

#ifdef _LOCKTEST

#define LKASSERT_ENABLED(mode)	__ASSERTENABLED(LOCKTEST_ASSERT, mode)
#define	LKASSERT(ex, s)	if (LKASSERT_ENABLED(ASSERT_MODE3)) \
				__lkassert(ex, s, __FILE__, __LINE__)
#define	LKASSERTBLK(mode, code) \
			if (LKASSERT_ENABLED(mode)) \
				{code}
#define	LKASSERTBLK_ELSE(mode, code) \
			if (LKASSERT_ENABLED(mode)) \
				{code} \
			else

/*
 * TEMPNOTE: (pauls) Include driver locks here (lastlock_ddi)?
 */
#define	NOLOCKS()	((lastlock == (signed char)-1) || \
			 (lockteston != LTEST_RUNNING) || \
			 (locksoff)) /* SMP no locks held */

#define ASSERTLOCKED(l)		ASSERT((((lck_t *)(l))->l_lock) || locksoff)

#else

#define LKASSERT_ENABLED(mode)	0		/* LOCKTEST off */
#define	LKASSERT(ex, s)
#define	LKASSERTBLK(mode, code)
#define	LKASSERTBLK_ELSE(mode, code)
#define	NOLOCKS()	1			/* no locks held */
#define ASSERTLOCKED(l)		

#endif

/*
 * Force this context onto a specific cpu with a hard kernel binding
 * (used for load-balancing and for non-symmetric code).  The kernel binding
 * takes precedence, but if we are giving up the kernel binding, evaluate
 * the remaining bindings and determine if we need to switch cpus.
 */

#ifdef __i386__

#define CALLPREEMPT(s) \
	{ \
		s = splhi(); \
		preempt(); \
		splx(s); \
	}

#else

#define CALLPREEMPT(s)	preempt()

#endif

extern reentsema_t cpucntl_sema;

#if	defined(mips) || defined(u3b2)

#define	CHECKPREEMPT() {						\
		SPLX(s);						\
		if (!(procp->p_curbind & lcpumask)) { 			\
			REENT_VSEMA(&cpucntl_sema, NULL);		\
			runrun = FORCE_RESCHED;				\
			preempt(); 					\
		} else							\
			REENT_VSEMA(&cpucntl_sema, NULL);		\
	}
#else

/*
 * Do this on the x86 since preempt() (actually swtch()) does
 * not attempt to return back to the caller at the IPL that
 * was established when it was entered.
 */
#define	CHECKPREEMPT() {						\
		if (!(procp->p_curbind & lcpumask)) { 			\
			REENT_VSEMA(&cpucntl_sema, NULL);		\
			runrun = FORCE_RESCHED;				\
			preempt(); 					\
			SPLX(s);					\
		} else {						\
			SPLX(s);					\
			REENT_VSEMA(&cpucntl_sema, NULL);		\
		}							\
	}

#endif

/*
 * Force this context onto a specific cpu with a hard kernel binding
 * (used for load-balancing and for non-symmetric code).  The kernel binding
 * takes precedence, but if we are giving up the kernel binding, evaluate
 * the remaining bindings and determine if we need to switch cpus.
 * Note that the cpu specified in the BINDTOCPU macro is mapped via
 * "bindcpu[]".  This allows cpus to be taken offline and any imbedded
 * cpu binding info (ie for compatibility mode modules) will be then
 * mapped to a different cpu.
 */

#define	BINDTOCPU(cpu,oldbind,map)					\
	{ 								\
		register int s; 					\
		register proc_t *procp = u.u_procp;			\
		/* protect cpu state while we do binding */		\
		REENT_PSEMA(&cpucntl_sema, PZERO, NULL);		\
		if (((oldbind)) != NULL)				\
			if (procp->p_kernbind) { 			\
				register cpuid_t i; 			\
				for (i=0; i<cpucnt; i++) 		\
					if ((CPUNO_TO_LCPUID(i) & 	\
					    procp->p_kernbind)) 	\
						(*(cpuid_t *)(oldbind)) = i; \
			} else 						\
				(*(cpuid_t *)(oldbind)) = NOCPU; 	\
		SPLHI(s);						\
		PSPIN(&procp->p_qmplock, &mpsbuf[MPS_SPIN_QUIES]); 	\
		if ((cpu) == NOCPU) 					\
			procp->p_kernbind = 0; 				\
		else if ((map))						\
			procp->p_kernbind = CPUNO_TO_LCPUID(bindmap[cpu]); \
		else 							\
			procp->p_kernbind = CPUNO_TO_LCPUID(cpu);	\
		eval_bindings(procp);  					\
		VSPIN(&procp->p_qmplock, &mpsbuf[MPS_SPIN_QUIES]); 	\
		CHECKPREEMPT();						\
	}

/* change spl only if MP */

#define SPL7(s)		(s = spl7())		/* DDI */
#define SPL6(s)		(s = spl6())		/* DDI */
#define SPL5(s)		(s = spl5())		/* DDI */
#define SPL4(s)		(s = spl4())		/* DDI */
#define SPL1(s)		(s = spl1())		/* DDI */
#define SPLNET(s)	(s = splnet())		/* DDI */
#define SPL0(s)		(s = spl0())		/* DDI */

#define SPLHI(s)	(s = splhi())		/* DDI */
#define SPLSTR(s)	(s = splstr())		/* DDI */
#define SPLTTY(s)	(s = spltty())		/* DDI */
#define SPLX(x)		splx(x)			/* DDI */

#define SPLPP(s)	(s = splpp())
#define SPLVM(s)	(s = splvm())
#define SPLIMP(s)	(s = splimp())
#ifdef mips
#define SPL(s,ipl)	((s) = setpl(ipl))
#define INTR_DISABLE(s)	((s) = splhi())
#define INTR_RESTORE(s)	splx(s)
#endif /* mips */
#ifdef __i386__
#define INTR_DISABLE(s)	intr_disable()
#define INTR_RESTORE(s)	intr_restore()
#endif /* __i386__ */
#ifdef u3b2
#define INTR_DISABLE(s)	((s) = splhi())
#define INTR_RESTORE(s)	splx(s)
#endif
#define SPLLOWER(s)	spllower(s)

#else						/* SINGLE CPU KERNEL */

#define LKASSERT_ENABLED(mode)	0		/* LOCKTEST off */
#define	LKASSERT(ex, s)
#define	LKASSERTBLK(mode, code)
#define	LKASSERTBLK_ELSE(mode, code)
#define	NOLOCKS()	1			/* SMP no locks held */

#define ASSERTLOCKED(sp)

#define	SLEEPFREE1(chan, pri, lp1)			sleep(chan, pri)
#define	SLEEPFREE2(chan, pri, lp1, lp2)			sleep(chan, pri)
#define	SLEEPFREE3(chan, pri, lp1, lp2, lp3)		sleep(chan, pri)

#define	WAKEUP1(chan)					wakeup(chan)

#define	BINDTOCPU(cpu,oldbind,map)

/* change spl only if MP */

#define SPL7(s)
#define SPL6(s)
#define SPL5(s)
#define SPL4(s)
#define SPL1(s)
#define	SPLNET(s)
#define SPL0(s)

#define SPLHI(s)
#define SPLSTR(s)
#define SPLTTY(s)
#define SPLX(s)

#define SPLPP(s)
#define SPLVM(s)
#define SPLIMP(s)
/* TEMPNOTE: 386 (pauls) until the drivers remove private SPL #defines */
#ifdef mips
#define SPL(s,ipl)
#endif /* mips */
#define SPLLOWER(s)

#endif	/* _SMP */

extern volatile int	locksoff;	/* set (after panic) to make locks succeed */
extern int	lockteston;	/* MP lock locking protocol enforcement */
extern int	lockipltest;	/* exact ipl to MP lock ipl enforcement */

extern int	splteston;	/* Standard ipl protocol enforcement */	

extern int	sleepteston;	/* TEMP turn on checking for sleep calls
				 * (instead of sleepfree)
				 */	
extern int	lkassertok;	/* Determines whether lock assertion failures
				   are fatal */
#if defined(ATTSMP) && defined(CACHEKLUDGE)
extern        caddr_t nocacheloc;     /* CACHE KLUDGE */
#endif

#endif /* _KERNEL */

#endif	/* _SYS_MPLOCKS_H */
