#ident "@(#)$Header: param.h,v 1.8 94/03/15 17:22:33 phil Exp $ SNI"
/*
 * "@(#)param.h	Revision: 3.3	93/02/17 09:46:16"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*
 * +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 * 		PROPRIETARY NOTICE (Combined)
 * 
 * This source code is unpublished proprietary information
 * constituting, or derived under license from AT&T's UNIX(r) System V.
 * In addition, portions of such source code were derived from Berkeley
 * 4.3 BSD under license from the Regents of the University of
 * California.
 * 
 * 
 * 
 * 		Copyright Notice 
 * 
 * Notice of copyright on this source code product does not indicate 
 * publication.
 * 
 * 	(c) 1986,1987,1988,1989  Sun Microsystems, Inc
 * 	(c) 1983,1984,1985,1986,1987,1988,1989  AT&T.
 * 	          All rights reserved.
 *  
 */

#ifndef _SYS_PARAM_H
#define _SYS_PARAM_H


#include <sys/types.h>
#include <sys/fs/s5param.h>
/*
 * Fundamental variables; don't change too often.
 */
#ifndef _POSIX_VDISABLE
#define _POSIX_VDISABLE 0 /* Disable special character functions */
#endif

#ifndef MAX_INPUT
#define MAX_INPUT 512     /* Maximum bytes stored in the input queue */
#endif

#ifndef MAX_CANON
#define MAX_CANON 256     /* Maximum bytes in a line for canoical processing */
#endif

#define UID_NOBODY  60001   /* user ID no body */
#define GID_NOBODY  UID_NOBODY

#define UID_NOACCESS    60002   /* user ID no access */


#define	MAXPID	30000		/* max process id */
#define	MAXUID	60002		/* max user id */
#define	MAXLINK	2000		/* max links */

#ifdef u3b2
#define	SSIZE	1		/* initial stack size (*2048 bytes) */
#define	SINCR	1		/* increment of stack (*2048 bytes) */
#else
#define	SSIZE	1		/* initial stack size (*4096 bytes) */
#define	SINCR	1		/* increment of stack (*4096 bytes) */
#endif /* u3b2 */

#ifdef __i386__
#define	USIZE	MINUSIZE	/* inital size of user block (*4096) */
#define	MINUSIZE  2		/* min size of user block (*4096 bytes) */
#define	MAXUSIZE 18		/* max size of user block (*4096 bytes) */
#endif
#ifdef u3b2
#define	USIZE	MINUSIZE	/* inital size of user block (*2048) */
#define	MINUSIZE  3		/* min size of user block (*2048 bytes) */
#define	MAXUSIZE  3		/* max size of user block (*2048 bytes) */
#endif
#ifdef mips
#define	USIZE	3		/* inital size of user block (*4096) */
#define KSTKSZ	0x2800		/* size of the kernel stack in bytes */
#define CPUPRISIZE 	1	/* size of cpu private (*4k bytes) */
#endif

#define	CANBSIZ	256		/* max size of typewriter line	*/
#define	HZ	100		/* 100 ticks/second of the clock */
#define TICK    10000000	/* nanoseconds per tick */


#define NOFILE	20		/* this define is here for	*/
				/* compatibility purposes only	*/
				/* and will be removed in a	*/
				/* later release		*/

/*
 * The following macros are no longer supported in SVR 4.0
 * since there is no longer a limit on the number of files that
 * a process can open. However, for SVR3.2 source compatibility, 
 * you may uncomment  NOFILES_MIN and NOFILES_MAX.
 */

/* #define	NOFILES_MIN	 20	SVR3.2 Source Compatibility */
/* #define	NOFILES_MAX	100	SVR3.2 Source Compatibility */

/*
 * These define the maximum and minimum allowable values of the
 * configurable parameter NGROUPS_MAX.
 */
#define	NGROUPS_UMAX	32
#define	NGROUPS_UMIN	0

/*
 * The following defines apply to the kernel virtual address space.
 */

#ifdef __i386__
/*
 * The size of the kernel segment table in pages.  The starting address
 * comes from the vuifile.
 */
#define MAXKSEG		127	/*max no of pages per kseg */
#endif

#ifdef u3b2
/*
 * The size of the kernel segment table in pages.  The starting address
 * comes from the vuifile (for COFF compilation) or mapfile (for ELF).
 * Changes in the vuifile or mapfile may require corresponding changes
 * to NS*SDE.
 */
#define	SYSSEGSZ 1024

#define	NS0SDE	0xB00	/* number of kernel segments in section 0. */
#define	NS1SDE	0xC0	/* number of kernel segments in section 1. */
#define	NS2SDE	0x0	/* number of kernel segments in section 2. */
#define	NS3SDE	0x1	/* number of kernel segments in section 3. */
#endif

/*
 * To avoid prefetch errors at the end of a region, it must
 * be padded with the following number of bytes.
 */

#ifdef u3b2
#define	PREFETCH	12
#else
#define	PREFETCH	0
#endif

/*
 * Priorities.  Should not be altered too much.
 */

#define	PMASK	0177
#define	PCATCH	0400
#define	PNOSTOP	01000
#define	PSIGON	02000
#define	PSIGOFF	04000
#define	PSWP	0
#define	PINOD	10
#define PSNDD	PINOD
#define	PRIBIO	20
#define	PZERO	25
#define PMEM	0
#define	NZERO	20
#define	PPIPE	26
#define PVFS	27
#define	PWAIT	30
#define	PSLEP	39
#define	PUSER	60
#define	PIDLE	127

/*
 * Fundamental constants of the implementation--cannot be changed easily.
 */

#define	NBPW	sizeof(int)	/* number of bytes in an integer */
#ifdef __i386__
#define	NCPPT	1024		/* Number of clicks per page table */
#define	CPPTSHIFT	10	/* LOG2(NCPPT) if exact */
#endif
#ifdef u3b2
#define NBPS	0x20000		/* Number of bytes per segment */
#define	NBPW	sizeof(int)	/* number of bytes in an integer */
#define	NCPS	64		/* Number of clicks per segment */
#ifndef NULL
#ifdef __cplusplus
#define __NULL_TYPE
#else /* !defined(__cplusplus) */
#define __NULL_TYPE (void *)
#endif /* !defined(__cplusplus) */
#define NULL (__NULL_TYPE 0)
#endif /* !defined(NULL) */
#define	CMASK	0		/* default mask for file creation */
#define	CDLIMIT	(1L<<11)	/* default max write address */
#define	NBPSCTR		512	/* Bytes per disk sector.	*/
#define	UBSIZE		512	/* unix block size.		*/
#define SCTRSHFT	9	/* Shift for BPSECT.		*/
#endif

#ifdef mips
#define	NCPS		1024		/* Number of clicks per page table */
#define	CPSSHIFT	10		/* LOG2(NCPS) if exact */
#define	NBPS		(NCPS*NBPC)	/* Number of bytes per segment */
#endif /* mips */
#ifdef u3b2
#define	NBPC	2048		/* Number of bytes per click */
#define	CPSSHIFT	6	/* LOG2(NCPS) if exact */
#define	BPCSHIFT	11	/* LOG2(NBPC) if exact */
#else
#define	NBPC	4096		/* Number of bytes per click */
#define	BPCSHIFT	12	/* LOG2(NBPC) if exact */
#endif
#ifndef NULL
#ifndef NULL
#ifdef __cplusplus
#define __NULL_TYPE
#else /* !defined(__cplusplus) */
#define __NULL_TYPE (void *)
#endif /* !defined(__cplusplus) */
#define NULL (__NULL_TYPE 0)
#endif /* !defined(NULL) */
#endif
#define	CMASK	0		/* default mask for file creation */
#ifndef u3b2
#define	CDLIMIT	(1L<<14)	/* default max write address */
#endif
#define NBPSCTR         512     /* Bytes per LOGICAL disk sector. */
#define	UBSIZE		512	/* unix block size.		*/
#define SCTRSHFT	9	/* Shift for BPSECT.		*/

#ifdef __i386__
#define	UMODE	3		/* current Xlevel == user */
#define	USERMODE(cs)	(((cs) & SEL_RPL) == UMODE)
#endif

#ifdef u3b2
#define	UMODE	3		/* current Xlevel == user */
#define	USERMODE(psw)	((psw).CM == UMODE)
#define	BASEPRI(psw)	((psw).IPL > 8)
#define	MAXSCALL	142
#endif

#ifdef u3b2v4
/*
 * the psw is the status register
 */
#define	USERMODE(psw)	(((psw) & SR_KUP) == SR_KUP)
#ifdef MONITOR3B2
/*
 * The following values are dynamically determined in os/sysent.c
 * and os/space.c.  Define these here for use in the kernel monitor
 * cmd mpr (mpr.c).  These values need to be changed as the array
 * sizes change.
 */
#define	MAXSCALL		143		/* sysentsize */ 
#define	MIPS_SV_MAXSCALL	210		/* mips_sv_nsysent */
#define	MIPS_BSD_MAXSCALL	1  		/* mips_bsd_nsysent */
#endif
#endif

#ifdef __i386__	/* little endian */
#define	lobyte(X)	(((unsigned char *)&(X))[0])
#define	hibyte(X)	(((unsigned char *)&(X))[1])
#define	loword(X)	(((ushort *)&(X))[0])
#define	hiword(X)	(((ushort *)&(X))[1])
#else		/* big endian */
#define	lobyte(X)	(((unsigned char *)&(X))[1])
#define	hibyte(X)	(((unsigned char *)&(X))[0])
#define	loword(X)	(((ushort *)&(X))[1])
#define	hiword(X)	(((ushort *)&(X))[0])
#endif

#ifdef u3b2
/*
 *  Interrupt stack size in STKENT units
 */
#define QSTKSZ	1000
#define ISTKSZ	1000
#endif

#define	MAXSUSE	255

/* REMOTE -- whether machine is primary, secondary, or regular */
#define SYSNAME 9		/* # chars in system name */
#define PREMOTE 39

#ifdef __i386__
/* XENIX compatibility */
#define	ktop(vaddr)	((paddr_t)svirtophys(vaddr))
#endif

/*
 * MAXPATHLEN defines the longest permissible path length,
 * including the terminating null, after expanding symbolic links.
 * MAXSYMLINKS defines the maximum number of symbolic links
 * that may be expanded in a path name. It should be set high
 * enough to allow all legitimate uses, but halt infinite loops
 * reasonably quickly.
 * MAXNAMELEN is the length (including the terminating null) of
 * the longest permissible file (component) name.
 */
#define	MAXPATHLEN	1024
#ifdef mips		/* MIPS ABI */
#define	MAXSYMLINKS	30
#else
#define	MAXSYMLINKS	20
#endif
#define	MAXNAMELEN	256

#ifndef NADDR
#define NADDR 13
#endif

/*
 * The following are defined to be the same as
 * defined in /usr/include/limits.h.  They are
 * needed for pipe and FIFO compatibility.
 */
#ifndef PIPE_BUF	/* max # bytes atomic in write to a pipe */
#ifdef u3b15
#define PIPE_BUF	4096
#else
#define PIPE_BUF	5120
#endif	/* u3b15 */
#endif	/* PIPE_BUF */

#ifndef PIPE_MAX	/* max # bytes written to a pipe in a write */
#ifdef u3b15
#define PIPE_MAX	4096
#else
#define PIPE_MAX	5120
#endif	/* u3b15 */
#endif	/* PIPE_MAX */

#ifndef NBBY
#define NBBY	8			/* number of bits per byte */
#endif

/*
 * File system parameters and macros.
 *
 * The file system is made out of blocks of at most MAXBSIZE units,
 * with smaller units (fragments) only in the last direct block.
 * MAXBSIZE primarily determines the size of buffers in the buffer
 * pool. It may be made larger without any effect on existing
 * file systems; however making it smaller make make some file
 * systems unmountable.
 *
 * Note that the blocked devices are assumed to have DEV_BSIZE
 * "sectors" and that fragments must be some multiple of this size.
 */
#ifdef mips
#define	MAXBSIZE	16384
#else
#define	MAXBSIZE	8192
#endif
#define	DEV_BSIZE	512
#define	DEV_BSHIFT	9		/* log2(DEV_BSIZE) */
#define	MAXFRAG 	8

#define	btodb(bytes)	 		/* calculates (bytes / DEV_BSIZE) */ \
	((unsigned)(bytes) >> DEV_BSHIFT)
#define	dbtob(db)			/* calculates (db * DEV_BSIZE) */ \
	((unsigned)(db) << DEV_BSHIFT)

/*
 * MMU_PAGES* describes the physical page size used by the mapping hardware.
 * PAGES* describes the logical page size used by the system.
 */

#ifdef u3b2
#define	MMU_PAGESIZE	0x800		/* 2048 bytes */
#define	MMU_PAGESHIFT	11		/* log2(MMU_PAGESIZE) */
#else
#define	MMU_PAGESIZE	0x1000		/* 4096 bytes */
#define	MMU_PAGESHIFT	12		/* log2(MMU_PAGESIZE) */
#endif

#define	MMU_PAGEOFFSET	(MMU_PAGESIZE-1)/* Mask of address bits in page */
#define	MMU_PAGEMASK	(~MMU_PAGEOFFSET)

#ifdef u3b2
#define	PAGESIZE	0x800
#define	PAGESHIFT	11
#else
#define	PAGESIZE	0x1000		/* All of the above, for logical */
#define	PAGESHIFT	12
#endif

#define	PAGEOFFSET	(PAGESIZE - 1)
#define	PAGEMASK	(~PAGEOFFSET)

#ifndef NODEV
#define NODEV	(dev_t)(-1)
#endif

/*
 * Some random macros for units conversion.
 */

/*
 * MMU pages to bytes, and back (with and without rounding)
 */
#define	mmu_ptob(x)	((x) << MMU_PAGESHIFT)
#define	mmu_btop(x)	(((unsigned)(x)) >> MMU_PAGESHIFT)
#define	mmu_btopr(x)	((((unsigned)(x) + MMU_PAGEOFFSET) >> MMU_PAGESHIFT))

/*
 * pages to bytes, and back (with and without rounding)
 */
#define	ptob(x)		((x) << PAGESHIFT)
#define	btop(x)		(((unsigned)(x)) >> PAGESHIFT)
#define	btopr(x)	((((unsigned)(x) + PAGEOFFSET) >> PAGESHIFT))

#ifdef __i386__
#define shm_alignment	ctob(1)		/* segment size */
#endif
#ifdef u3b2
#define shm_alignment	stob(1)		/* segment size */
#endif
#ifdef mips
#define shm_alignment	NBPS			/* segment size */
#endif

	/* Maximum number of CPUs - used */
	/* to size various compile- and */
	/* run-time data structrures */
#ifdef mips

#ifdef	A20R

#ifdef	_SMP
#define	NCPU	4
#else
#define	NCPU	1
#endif

#else	/* A20R */

#define NCPU	24

#endif	/* A20R */

#endif	/* mips */

#ifdef __i386__
#define NCPU	32
#endif
#ifdef u3b2
#define NCPU	4
#endif

/*
 * Maximum physical cpu number range.
 */
#ifdef mips
#define MAXPCPU 32
#else
#define MAXPCPU NCPU
#endif

#ifdef mips
/*
 * DELAY(n) should spin for roughly n microseconds.
 */
extern void		wastetime(int);
#define	DELAY(n)	wastetime(n)
#else
#define	DELAY(n)	drv_usecwait(n)
#endif

#define NOCPU	((cpuid_t) -1)

#if defined(_SHAREII)
/*
 *	Required for Share patches
 */
#define	LI_ENFORCE	0x1
#define	LI_UPDATE	0x2
#endif	/* _SHAREII) */

#endif	/* _SYS_PARAM_H */
