#ident "@(#)$Header: proc.h,v 1.11 93/10/22 13:49:02 schwarz Exp $ SNI"
/*
 * "@(#)proc.h	Revision: 3.3	92/08/28 14:52:30"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_PROC_H
#define _SYS_PROC_H

/*#ident	"@(#)ATTDSG usr/src/gencpu/gensys/uts/sys	1.1.2.1"*/

#include <sys/param.h>
#include <sys/immu.h>
#include <sys/mplocks.h>
#include <sys/dl.h>

#define PSARGSZ		80	/* Space for exec arguments (used by ps(1)) */ 
#define	PSCOMSIZ	14

/*
 * One structure allocated per active process.  It contains all
 * data needed about the process while the process may be swapped
 * out.  Other per-process data (user.h) may be swapped with the
 * process.
 */

typedef struct	proc {
	char	p_stat;			/* status of process */
	char	p_cpu;			/* cpu usage for scheduling */
	u_char	p_curflt;		/* current fault (/proc) */
	u_char	p_swlocks;		/* number of swap vnode locks held */
	u_int	p_flag;			/* flags defined below */
	o_uid_t	p_uid;			/* real user id */

	/* the following pid fields declared o_pid_t are for
	** binary compatibility only. They will be removed in
	** the next release following SVR4.0.
	*/

	o_pid_t	p_oppid;		/* process id of parent*/
	o_pid_t	p_opgrp;		/* name of process group leader */
	o_pid_t	p_opid;			/* unique process id*/
	struct	cred	*p_cred;	/* process credentials */
	struct sess	*p_sessp;	/* session information */
	int	p_pri;			/* scheduling priority */
	
	union {				/* wait addr for sleeping processes */
		caddr_t p_cad;		/* Union is for XENIX compatibility */
		int	p_int;
	} p_unw;
#define p_wchan p_unw.p_cad		/* Map MP name to old UNIX name */
#define p_arg	p_unw.p_int		/* Map MP name to old UNIX name */

	struct	proc	*p_link;	/* forward link */
	struct	proc	*p_parent;	/* ptr to parent process */
	struct	proc	*p_child;	/* ptr to first child process */
	struct	proc	*p_sibling;	/* ptr to next sibling proc on chain */
	int	p_clktim;		/* time to alarm clock signal */

	caddr_t	p_brkbase;		/* base address of heap */
	u_int	p_brksize;		/* heap size in bytes */
	caddr_t	p_stkbase;		/* base address of stack */
	u_int	p_stksize;		/* stack size in bytes */

	u_int	p_swrss;		/* resident set size before last swap */
	clock_t	p_utime;		/* user time, this process */
	clock_t	p_stime;		/* system time, this process */
					 
#ifdef u3b2
/* TEMPNOTE (rwf): 3b2 used to have ublock page table here.
 *		   removing changes offsets...this may be a no-no.
	pte_t	p_ubptbl[USIZE + 7];
 */
#endif
	ushort	p_usize;		/* size of u-block (*4096 bytes) */
	ushort	p_user_license;		/* per-user licensing */

#ifdef __i386__
	caddr_t	p_ldt;			/* address of ldt */

	/* for MERGE386    */
	struct	vm86	*p_vm86p;	/* info about Merge vm86 task */
#endif

#ifdef mips
#ifndef NWIREDENTRIES			/* ##rued: KLUDGE should use sbd.h */
#define NWIREDENTRIES 8
#endif

#ifdef SNI_R4000
	pte_t	p_ubptbl[NWIREDENTRIES][2]; /* TLB with double entries */
#else	/* !SNI_R4000 */
	pte_t	p_ubptbl[NWIREDENTRIES];
#endif	/* SNI_R4000 */
					/* page table for the u-block */
					/* and extras to reduce double */
					/* misses */
	u_int	p_tlbhi_tbl[NWIREDENTRIES];
					/* virtual addresses of p_ubptbl */
	u_int	p_nexttlb;		/* next avail. entry in above */
	long	p_fp;			/* generate SIGFPE on fp interrupts */
#endif /* mips */

	struct as *p_as;		/* process address space pointer */
	int 	p_wdata;		/* current wait return value */
	char	p_wcode;		/* current wait code */
	char	p_pollflag;		/* flags for use during poll(2) */
	u_char	p_cursig;		/* current signal */
	pid_t	p_epid;			/* effective pid; normally same as
					 * p_pid; for servers, the system that
					 * sent the msg
					 */
	sysid_t p_sysid;		/* normally same as sysid; for servers,
					 * the system that sent the msg
					 */
	struct	proc  *p_rlink;		/* linked list for server */
	int	p_srwchan;		/* RFS server awaiting work; sleep */
	struct	vnode *p_trace;		/* pointer to /proc vnode */
	k_sigset_t p_sig;		/* signals pending to this process */
	k_sigset_t p_sigmask;		/* tracing signal mask for /proc */
	k_sigset_t p_hold;		/* hold signal bit mask */
	k_sigset_t p_ignore;		/* ignore when generated */
	k_sigset_t p_siginfo;		/* gets signal info with signal */

#ifdef __i386__
	struct	v86dat *p_v86;		/* pointer to v86 structure */
	char	p_filler1[72];		/* unused */
#endif

	u_short	p_whystop;
	u_short	p_whatstop;

#if defined(__i386__) || defined(u3b2)
	pte_t	*p_ubptbl;		/* pointer to (floating) ublock page tbl */
#endif
#ifdef __i386__
	char	p_filler2[68];		/* unused */
#endif

	k_fltset_t	p_fltmask;	/* mask of traced faults (/proc) */
	struct	evpd	*p_evpdp;	/* ptr to events per-process data */

	struct timer  *p_italarm[2];	/* Ptrs to the alarms for the clocks
					 * measuring user  process virtual
					 * time and user+system process
					 * virtual time.
					 */
	struct proc *p_pglinkf;		/* process group chain forward link */
	struct proc *p_pglinkb;		/* process group chain backward link */
	clock_t	p_cutime;		/* sum of children's user time */
	clock_t	p_cstime;		/* sum of children's system time */
 	short	p_aiocount;		/* # of async requests accepted */
 	short	p_aiowcnt;		/* # of async operations currently
 					 * in progress and the process is
 					 * waiting for their completion
					 */
 	id_t	p_cid;			/* scheduling class id */
 	_VOID	*p_clproc;		/* per process class specific data */
 	struct classfuncs *p_clfuncs;	/* ptr to structure containing
 					 * class specific function ptrs
					 */
	struct sigqueue *p_sigqueue;	/* queued siginfo structures */
	struct sigqueue *p_curinfo;	/* siginfo for current signal */
	caddr_t *p_segacct;		/* segment accounting info */
	struct seguser *p_segu;		/* u segment */
	struct	vnode *p_exec;		/* pointer to a.out vnode */
	pid_t	p_ppid;			/* process id of parent*/
	struct pid *p_pidp;		/* process ID info */
	struct pid *p_pgidp;		/* process group ID info */
	struct sd *p_sdp;		/* pointer to XENIX shared data */
	struct proc *p_next;		/* active chain link */
	struct proc *p_nextofkin;	/* gets accounting info at exit */
	struct proc *p_orphan;
	struct proc *p_nextorph;

	/* General MP process control */
	/* may want to reoranize so that (some) locks are
	 * not in the same cache lines with one another.
	 */

    k_sigset_t p_pgsig;			/* pgrp signals pending to this proc */
    lck_t  p_mplock;			/* Process-specific lock */
    caddr_t	p_w2chan;		/* Wait channel for semaphore */
    struct proc	*p_semlink;		/* List for semaphore queue */
    struct proc	*p_slplink;		/* List for sleep queue */
    int		p_slptime;		/* length of current sleep (secs) */
    rdwrsema_t	p_exiting;		/* process exiting semaphore */
    sema_t	p_vfork;		/* synchronize parent/child vfork  */
    sema_t	p_scall_sema;		/* system call semaphore (eg. poll) */

	/* Process quiesce control */
    lck_t  p_qmplock;                   /* lock protecting mpflag */
					/* and holdcnt/waitcnt */
    volatile unsigned int p_mpflag;	/* New SMP flags - see below */
    unsigned int p_holdcnt;		/* #procs with quiesce claim on
					 * this process */
    unsigned int p_waitcnt;		/* #procs waiting for this process
					 * to quiesce */
    sema_t       p_quiesce;		/* Semaphore for Quiesce Mechanism */
    struct proc *p_target;		/* Target system process that is
					 * quiesced while I am running, but
					 * allowed to execute when I'm
					 * switched out.
					 */
    int		p_procholds;		/* Number of procs. held */

	/* Compatibility control */
    drmp_t	*p_savedrsp;		/* Saved driver state structure */
    sema_t	*p_savefssema;		/* Saved driver semaphore */

	/* process-to-cpu bindings */
    cpumask_t	p_kernbind;		/* Kernel CPU binding information */
    cpumask_t	p_userbind;		/* User CPU binding information */
    cpumask_t	p_affnbind;		/* Affinity CPU binding information */
    cpumask_t	p_curbind;		/* resultant of bind variables above */
    cpuid_t	p_affncpu;		/* affinity cpu	(if p_affnbind != 0) */
    cpuid_t	p_lastcpu;		/* Last CPU this proc executed upon */
    int		p_syswaitcpu;		/* cpu an I/O wait was started on */

	/* affinity binding aging metrics */
    clock_t	p_lastaffin;		/* freshness of affin binding (ticks) */
    unsigned	p_lostcpu;		/* freshness of affin binding in terms
					 * of affinity decay metrics */
    clock_t	p_affinage;		/* age (ticks) of affin binding */
    int		p_affinexpire;		/* ticks til fork affinity expires */

    int		*p_noprmptloc;		/* Loc of user flag for preempt cntl */
    int		p_inoutage;		/* Time spent in core or on swap */
#ifdef mips
    int		*p_nosigloc;		/* Loc of user flag for signal cntl (really a *sigset_t) */
    u_int	p_optflags;		/* optional flags set by user */
    int		p_rflags;		/* mips compatibility flags
					 * no priority or locks required
					 */
    int		p_rflags1;		/* mips compatibility flags
					 * update only at splhi
					 * no locks required
					 */
    int		p_rflags2;		/* mips compatibility flags
					 * splhi and p_mplock lock required
					 */
    char	*p_rptr;		/* mips compatibility */
    int		p_segmaprefcnt;
    char	*p_umemptr;		/* you do not want to know */
    k_sigset_t	p_catch;		/* mask of caught signals. */
#endif /* mips */
    struct bsess	*p_bsessp;	/* Background session pointer */
    uint	p_nshmseg;		/* moved here from the u area: number of attached shm segments */
    /*
     * Next three fields moved here from u area
     */
    time_t	p_start;		/* start time */
    char 	p_psargs[PSARGSZ];	/* arguments from exec */
    char	p_comm[PSCOMSIZ];	/* command */
#ifdef _SHAREII
#ifdef B20R
    int         p_xtra[2];              /* room to patch */
    volatile int cpum_trace_proc;       /* flag for traceing process with
                                         * cpu hardware monitor 
					 * (unilab:020593(RSD) */
    struct ShadProc_t *p_shareP;        /* Pointer to shadow proc entry */
#else
    int         p_xtra[3];              /* room to patch */
    struct ShadProc_t *p_shareP;        /* Pointer to shadow proc entry */
#endif /* B20R */
#else  /* _SHAREII */
#ifdef B20R
    int         p_xtra[3];              /* room to patch */
    volatile int cpum_trace_proc;       /* flag for traceing process with
                                         * cpu hardware monitor */
#else
    int         p_xtra[4];              /* room to patch */
#endif /* B20R */
#endif  /* _SHAREII */
} proc_t;

#ifdef mips
#define	ubptbl(PP)	((unsigned long)(PP)->p_ubptbl)

/* flags for p_fp */
#define P_FP_SIGINTR1	1
#define P_FP_SIGINTR2	2

#endif

/* Well known processes */

extern proc_t *proc_sched;	/* memory scheduler */
extern proc_t *proc_init;	/* init */
extern proc_t *proc_pageout;	/* pageout daemon */
extern proc_t *proc_bdflush;	/* block cache flush daemon */

/* process ID info */

struct pid {
	unsigned int pid_prinactive :1;
	unsigned int pid_pgorphaned :1;
	unsigned int pid_ref :6;
	unsigned int pid_prslot :24;
	pid_t pid_id;
	struct proc *pid_pglinkhead;
	struct proc *pid_pglinktail;
	struct pid *pid_link;
};

extern struct pid pid0;

#ifdef mips
extern struct pid pid_null;
#endif

#define p_pgrp p_pgidp->pid_id
#define p_pid  p_pidp->pid_id
#define p_slot p_pidp->pid_prslot
#define p_detached p_pgidp->pid_pgorphaned
#ifdef _SMP
#define PID_HOLD_NOLOCK(pidp)  (++(pidp)->pid_ref)
#define PID_HOLD(pidp)					\
	{						\
		int smplvl;	\
		SPLHI(smplvl);	\
		SWITCHABLE_PSPIN(&pidlock, RDWR_WRITE, STAT_PID);	\
		PID_HOLD_NOLOCK(pidp);			\
		SWITCHABLE_VSPIN(&pidlock, STAT_PID);			\
		SPLX(smplvl);	\
	}
/*
 * TEMPNOTE (rwf): tried for almost exact compatability, but i don't
 *		   think it will work ...is necessary ?
 */
#define PID_RELE(pidp)					\
	{ 						\
		int smplvl;	\
		SPLHI(smplvl);	\
		SWITCHABLE_PSPIN(&pidlock, RDWR_WRITE, STAT_PID);	\
		if ((pidp)->pid_ref>1) {		\
			--(pidp)->pid_ref;	\
		} else {				\
			pid_rele(pidp);		\
		}					\
		SWITCHABLE_VSPIN(&pidlock, STAT_PID);	\
		SPLX(smplvl);	\
	}
#else
#define PID_HOLD(pidp)  (++(pidp)->pid_ref)
#define PID_HOLD_NOLOCK(pidp)	PID_HOLD(pidp)
#define PID_RELE(pidp)    				\
	{						\
		if ((pidp)->pid_ref>1)			\
			--(pidp)->pid_ref;		\
		else					\
			pid_rele(pidp);			\
	}
#endif


#if defined(_KERNEL)

#if defined(__STDC__)

/* process management functions */
extern caddr_t findvaddr(proc_t *);
extern paddr_t vtop(caddr_t, proc_t *);
extern void pexit(void);
extern int newproc(int, pid_t *, int *);
extern void vfwait(pid_t);
/*
 * TEMPNOTE (rwf): non-standard C versions not yet defined.
 */
#ifdef _SMP
extern void freeproc(proc_t *, int);
#else
extern void freeproc(proc_t *);
#endif
extern void setrun(proc_t *);
extern void unsleep(proc_t *);
extern void exit(int, int);
extern void relvm(proc_t *);

extern void sigcld(proc_t *);
extern void psig(void);
extern int stop(proc_t *, int, int, int);
extern int issig(int);
extern void psignal(proc_t *, int);
extern void sigtoproc(proc_t *, int, int);

void pid_setmin(void);
pid_t pid_assign(int, proc_t **);
void pid_rele(struct pid *);
void pid_exit(proc_t *);
proc_t *prfind(pid_t);
proc_t *pgfind(pid_t);
void pid_init(void);
proc_t *pid_entry(int);
int pid_slot(proc_t *);
void signal(pid_t, int);
void prsignal(struct pid *, int);

void pgsignal(struct pid *, int);
#ifdef _SMP
void pgsignal_locked(struct pid *, int);
#else
#define pgsignal_locked(x,y)	pgsignal(x,y)
#endif

#ifdef _SMP
proc_t *smp_pid_hold(pid_t, int);
proc_t *smp_proc_hold(proc_t *, int);
void smp_proc_rele(proc_t *);
void smp_proc_rele_locked(proc_t *);
void smp_target_set(proc_t *);
void smp_target_clr(proc_t *);
#endif

void pgjoin(proc_t *, struct pid *);
void pgexit(proc_t *);
void pgdetach(proc_t *);
int pgmembers(pid_t);


#else 

extern caddr_t findvaddr();
extern paddr_t vtop();
extern void pexit();
extern int newproc();
extern void vfwait();
extern void freeproc();
extern void setrun();
extern void unsleep();
extern void exit();
extern void relvm();

extern void sigcld();
extern void psig();
extern int stop();
extern int issig();
extern void psignal();
extern void sigtoproc();

void pid_setmin();
pid_t pid_assign();
void pid_rele();
void pid_exit();
proc_t *prfind();
proc_t *pgfind();
void pid_init();
proc_t *pid_entry();
int pid_slot();
void signal();
void prsignal();

void pgsignal();
void pgjoin();
void pgexit();
void pgdetach();
int pgmembers();

#endif /* __STDC__ */

#endif /* _KERNEL */

/* stat codes */

#define	SSLEEP	1		/* awaiting an event */
#define	SRUN	2		/* running */
#define	SZOMB	3		/* process terminated but not waited for */
#define	SSTOP	4		/* process stopped by debugger */
#define	SIDL	5		/* intermediate state in process creation */
#define	SONPROC	6		/* process is being run on a processor */
#define SXBRK	7		/* process being xswapped */

/* flag codes */
/*
 * The following are "in context" only flags which need no protection:
 * and have for performance reasons been moved to p_mpflag.
 */

		/* NONE AT THIS TIME */

/*
 * The following are flags which might be changed "out of context" or
 * even if only changed "in context" are referenced in some manner
 * that dicates that they remain in a protected field.
 */

		/* THIS INCLUDES ALL FLAGS AT THIS TIME */

#define	SSYS	0x00000001	/* system (resident) process */
#define	STRC	0x00000002	/* process is being traced */
#define	SPRWAKE	0x00000004	/* debugger is waiting to prlock() */
#define	SNWAKE	0x00000008	/* process cannot be awakened by a signal */
#define	SLOAD	0x00000010	/* in core */
#define	SLOCK	0x00000020	/* process cannot be swapped */
#define SLKDONE 0x00000040	/* NFS record-locking has been done */
#define	SPOLL	0x00000080	/* process in stream poll */
#define	SPRSTOP	0x00000100	/* process is being stopped via /proc */
#define	SPROCTR	0x00000200	/* signal or syscall tracing via /proc */
#define	SPROCIO	0x00000400	/* doing I/O via /proc, so don't run */
#define	SPRFORK	0x00000800	/* child inherits /proc tracing flags */
#define	SPROPEN	0x00001000	/* process is open via /proc */
#define	SULOAD	0x00002000	/* u-block in core */
#define	SRUNLCL	0x00004000	/* set process running on last /proc close */
#define	SNOSTOP	0x00008000	/* proc asleep, stop not allowed */
#define	SPTRX	0x00010000	/* process is exiting via ptrace(2) */
#define	SASLEEP	0x00020000	/* proc is stopped within a call to sleep() */
#define	SUSWAP	0x00040000	/* u-block is being swapped in or out */
#define	SUWANT	0x00080000	/* waiting for u-block swap to complete */
#define SEXECED 0x00100000	/* this process has execed */
#define SDETACHED 0x00200000	/* this process detached from ctty */
#define SNOTCHILD 0x00400000	/* this is a bogus "child" of init */
#if !defined(mips)
/* unused 	0x00800000 */
#else
#define SOLDBIN	0x00800000	/* old MIPS binary */
#endif
#define SJCTL	0x01000000	/* SIGCLD sent when children stop/continue */
#define SNOWAIT 0x02000000	/* children never become zombies */
#define SVFORK	0x04000000	/* process resulted from vfork */
#define SVFDONE 0x08000000	/* vfork child releasing parent as */
#define SSWLOCKS 0x10000000	/* process has swap locks */
#define	SXSTART	0x20000000	/* setrun() by SIGCONT or ptrace() */
#define	SPSTART	0x40000000	/* setrun() by /proc */
#define	SNEWSYS	0x80000000	/* proc in sys class being created */

#ifdef mips
/*
 * p_rflags mips compatibility flags
 *
 * The following mips compatibility flags do not require
 * a specific priority level or any SMP locks for update.
 */
#define MIPS_BSD_SIGCONTEXT	0x00001	/* use mips bsd43_sigcontext */
#define MIPS_SYSV_SIGCONTEXT	0x00002	/* use mips SYSV sigcontext */
#define	MIPS_RESTARTSYS		0x00004	/* restart system call */
#define MIPS_MAP_EAGAIN 	0x00008	/* map EAGAIN to EWOULDBLOCK */

/*
 * p_rflags1 mips compatibility flags
 *
 * The following mips compatibility flags require
 * splhi() for updating but do not require SMP locks.
 */
#define	MIPS_VITIMER	0x10000		/* process has a virtual itimer set */
#define	MIPS_PITIMER	0x20000		/* process has a prof itimer set */

/*
 * p_rflags2 mips compatibility flags
 *
 * The following mips compatibility flags require
 * splhi() and p_mplock locked for updating.
 * (None defined yet.)
 */

/*
 * mips compatibility sigcontext selection macros
 */
#define MIPS_SIGCONTEXT_SELECT (MIPS_BSD_SIGCONTEXT | MIPS_SYSV_SIGCONTEXT)
#define MIPS_SIGCONTEXT_NOT_SET 0

/*
 * mips compatibility flags to save on exec
 */
#define MIPS_SAVE_EXEC	0				/* p_rflags */
#define MIPS_SAVE_EXEC1	(MIPS_VITIMER | MIPS_PITIMER)	/* p_rflags1 */
#define MIPS_SAVE_EXEC2	0				/* p_rflags2 */

#define	MIPS_DO_MAP_EAGAIN()	(u.u_procp->p_rflags |= MIPS_MAP_EAGAIN)	

/*
 * Argument to user_mem_alloc() or user_mem_dealloc()
 */

extern int user_mem_alloc();
extern void user_mem_dealloc();

struct u_mem_alloc {
	caddr_t	m_base;		/* Beginning of memory */
	u_int	m_size;		/* Size of it */
	struct	u_mem_alloc *m_next;
};

#endif

/*
 * p_mpflag flag bits
 */
#define PRUNNING	0x00000001	/* Indicates the process is executing
					 * somewhere and cleared when it
					 * switches out.
					 */
#define PHOLD		0x00000002	/* Set for the interval between
					 * smp_proc_hold and smp_proc_rele.
					 */
#define PQUIESCE	0x00000004	/* Process will not execute while
					 * this flag is set.
					 */
#define PEXIT		0x00000008	/* Indicates someone attempted to
					 * freeproc() the target while it
					 * was quiesced.
					 */
#define	PBIND		0x00000010	/* Process is bound to one or more
					 * CPUs.
					 */
#define	PBINDXCLU	0x00000020	/* Process is exclusively bound to
					 * one or more CPUs.
					 */
#define	PAFFINOFF	0x00000040	/* Process is not allowed to gain
					 * affinity on a CPU.
					 */
#define	PNOPRMPT	0x00000180	/* Mask for non-preemptive behavior
					 * checking in the kernel
					 */
#define	PNOPRMPTSIG	0x00000080	/* Process should (temporarily) be
					 * immune from preemption
					 */
#define	PNOPRMPTNSIG	0x00000100	/* Process should (temporarily) be
					 * immune from preemption and signals
					 */
#define	PDRVCOMPAT	0x00000200	/* Process is blocked on a driver compat.
					 * semaphore - sched should leave it alone.
					 */
/* pollflags */

/*
 * ##SMP: replaced with p_scall_sema
 */
#define SINPOLL		0x01	/* process in poll */
#define SPOLLTIME	0x02	/* poll timeout pending */

/* Flags for p_user_license */

#define PU_LIM_OK	0x01
#define PU_LOGIN_PROC	0x02
#define PU_UUCP		0x04

#define EUA_GET_LIM	0
#define EUA_GET_CUR	1
#define EUA_REM_USER	3
#define EUA_ADD_USER	4
#define EUA_UUCP	5
#define EUA_FORK	6

#if defined(_KERNEL)
extern int enable_user_alloc(int);
#endif

/* Flags for newproc() */

#define NP_FAILOK	0x01	/* don't panic if cannot create process */
#define NP_NOLAST	0x02	/* don't use last process slot */
#define	NP_SYSPROC	0x04	/* system (resident) process */
#define	NP_INIT		0x08	/* this is init process */
#define NP_VFORK	0x10	/* share address space - vfork */
#define NP_SHARE	0x20	/* share address space - asyncio */
#define NP_IDLE		0x40	/* make an idleprocess (for pid_assign) */

/* Macro to convert proc table pointers to user block pointers */
/* must include user.h for definition of KUSER */
#define PTOU(p) KUSER((p)->p_segu)

#define PTRACED(p)	((p)->p_flag&(STRC|SPROCTR|SPROPEN))

/* Macro to reduce unnecessary calls to issig() */

#define	ISSIG(p, why) \
  (((p)->p_cursig || !sigisempty(&(p)->p_sig) || ((p)->p_flag & SPRSTOP)) \
    && issig(why))

#define	CHECKSIG(p) \
  ((p)->p_cursig || !sigisempty(&(p)->p_sig) || ((p)->p_flag & SPRSTOP))

/* Reasons for calling issig() */

#define	FORREAL		0	/* Usual side-effects */
#define	JUSTLOOKING	1	/* Don't stop the process */

/* Macros for pid manipulation */

#define	PIDSHIFT		12		/* 2^PIDSHIFT >= NPROC */
#define	PIDINDEXMAX		0x0fff		/* = 2^PIDSHIFT-1 */
#define	PIDINCARMAX		0x7000		/* 3 bits for incarnation number as of 08/15/88 */

#define	GET_INDEX(PI_PID)	((PI_PID)&(PIDINDEXMAX))
#define	GET_INCAR(PI_PID)	(((unsigned)((PI_PID)&(PIDINCARMAX))) >> (PIDSHIFT))
#define	INC_INCAR(PI_PID)	((PI_PID) = (((unsigned)(PI_PID) + ((0x1)<<(PIDSHIFT)))&((PIDINDEXMAX)|(PIDINCARMAX))))
#define INC_INDEX(PI_PID)	PUT_INDEX(PI_PID,(GET_INDEX(PI_PID)+1)%NPROC)
#define	PUT_INCAR(PI_PID,INCAR)	((PI_PID) = (((PI_PID)&(PIDINDEXMAX)) | (((INCAR)<<(PIDSHIFT))&(PIDINCARMAX))))
#define PUT_INDEX(PI_PID,INDEX)	((PI_PID) = (((PI_PID)&(PIDINCARMAX)) | ((INDEX)&(PIDINDEXMAX))))


/*
 * The following are used to access the practive hash
 */
extern int hashmask;
extern proc_t **practive;

#define HASHPROC(pid)		(practive[((pid)&(hashmask))])
#define HASHPROCLOCK(pid)	(practivelock[((pid)&(hashmask))])

/*
 * The following macros are used to control use of process quiescing.
 */

#ifdef _SMP

#define SMP_PID_HOLD(p, flg)    smp_pid_hold(p, flg)
#define SMP_PROC_HOLD(p, flg)   smp_proc_hold(p, flg)
#define SMP_PROC_RELE(p)        smp_proc_rele(p)
#define SMP_PROC_RELE_LOCKED(p) smp_proc_rele_locked(p)

/*
 * For saving the save state of the automatic semaphores
 * to allow nested setjmp/longjmp calls.  Used in conjunction
 * with the AUTOSAVE/AUTORESTORE macros.
 */
struct	autosave {
	drmp_t	*save_drsp;
	sema_t	*save_fs;
};

#else

#define SMP_PID_HOLD(p, flg)	(prfind(p))
#define SMP_PROC_HOLD(p, flg)	(p)
#define SMP_PROC_RELE(p)
#define SMP_PROC_RELE_LOCKED(p)

#endif /* _SMP */

#define NOCHECK 0x80000000      /* dont validate proc pointer */

/*
 * Data structures used to keep track of the number
 * of processes currently in existence for each uid.
 * Used by fork to eliminate needs to scan all active
 * processes to count processes.
 * Based on real user id.
 * Updated by pid_assign, pid_exit, and setuid.
 */

typedef struct uidhash {
        struct uidhash  *uh_nxt;        /* next entry on hash chain */
        uid_t           uh_uid;         /* the actual uid */
        unsigned short  uh_cnt;         /* number of active processes */
        unsigned int    uh_pfpriv;      /* privileged processflags() mask */
} uhash_t;

#define UIDHSZ          256
#define UIDHASH(uid)    ((uid) & (UIDHSZ - 1))
#define UIDHASHGROW	20

#endif	/* _SYS_PROC_H */
