#ident "@(#)$Header: stream.h,v 1.9 93/11/04 15:28:59 reinsch Exp $ SNI"
/*
 * "@(#)stream.h	Revision: 3.9	93/04/08 09:38:48"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_STREAM_H
#define _SYS_STREAM_H


/*
 * For source compatibility
 */
#include <sys/vnode.h>
#include <sys/poll.h>
#include <sys/strmdep.h>
#include <sys/cred.h>
#include <sys/cldmac.h>
#include <sys/strstat.h>

/*
 * Data queue
 */
#ifdef _STYPES

struct	queue {
	struct	qinit	*q_qinfo;	/* procs and limits for queue */
	struct	msgb	*q_first;	/* first data block */
	struct	msgb	*q_last;	/* last data block */
	struct	queue	*q_next;	/* Q of next stream */
	struct	equeue	*q_eq;		/* extended queue info */
	_VOID		*q_ptr;		/* to private data structure */
	ushort		q_count;	/* number of bytes on Q */
	ushort		q_flag;		/* queue state */
	short		q_minpsz;	/* min packet size accepted by */
					/* this module */
	short		q_maxpsz;	/* max packet size accepted by */
					/* this module */
	ushort		q_hiwat;	/* queue high water mark */
	ushort		q_lowat;	/* queue low water mark */
};

/*
 * Extended queue structure containing information that belongs
 * in the queue, but can't be added because of binary compatibility
 * of STREAMS modules and drivers.
 */
struct equeue {
	struct queue	*eq_link;	/* to next Q for scheduling */
	struct qband	*eq_bandp;	/* separate flow information */
	unsigned char	eq_nband;	/* number of priority bands > 0 */
};

#define q_link	q_eq->eq_link
#define q_bandp	q_eq->eq_bandp
#define q_nband	q_eq->eq_nband

#else /* large definition */

struct	queue {
	struct	qinit	*q_qinfo;	/* procs and limits for queue */
	struct	msgb	*q_first;	/* first data block */
	struct	msgb	*q_last;	/* last data block */
	struct	queue	*q_next;	/* Q of next stream */
#ifdef	mips
#ifdef	_SMP
	struct qu_runobj *q_objs;	/* Queue objects */
#else	/* !_SMP */
	struct	queue	*q_link;	/* to next Q for scheduling */
#endif	/* _SMP */
#else	/* !mips */
	struct queue_shadow *q_qshad;	/* ##SMP: shadow queue */
#endif	/* mips */
	_VOID		*q_ptr;		/* to private data structure */
	ulong		q_count;	/* number of bytes on Q */
	ulong		q_flag;		/* queue state */
	long		q_minpsz;	/* min packet size accepted by */
					/* this module */
	long		q_maxpsz;	/* max packet size accepted by */
					/* this module */
	ulong		q_hiwat;	/* queue high water mark */
	ulong		q_lowat;	/* queue low water mark */
	struct qband	*q_bandp;	/* separate flow information */
	unsigned char	q_nband;	/* number of priority bands > 0 */
	unsigned char	q_pad1[3];	/* reserved for future use */
	long		q_pad2[2];	/* reserved for future use */
#ifdef	mips
	struct	msgb	*q_pfirst;	/* ##SMP: first data block of put list*/
	struct	msgb	*q_plast;	/* ##SMP: last data block of put list */
	ulong		q_pcount;	/* ##SMP: number of bytes on put list */
	int		q_xcnt;		/* ##SMP: reference count */
	int		*q_xcntp;	/* ##SMP: ptr to reference field */
	struct qp_sync	*q_sync;	/* ##SMP: procedure synchronization */
	lck_t		q_lock;		/* ##SMP: queue lock, mainly message
					 * list
					 */
	lck_t		q_ilock;	/* ##SMP: internal queue lock */
	lck_t		*q_xlockp;	/* ##SMP: pointer to queue list lock */
	struct	queue	*q_scanlink;	/* pointer to next queue in hold list */
	drmp_t		*q_drsp;	/* ##SMP: compatibility semaphore */
#endif
};

#ifndef	mips
struct	queue_shadow	{
	struct	queue	*qs_link;	/* to next Q for scheduling */
	struct	msgb	*qs_pfirst;	/* ##SMP: first data block of put list*/
	struct	msgb	*qs_plast;	/* ##SMP: last data block of put list */
	ulong		qs_pcount;	/* ##SMP: number of bytes on put list */
	int		qs_xcnt;	/* ##SMP: reference count */
	int		*qs_xcntp;	/* ##SMP: ptr to reference field */
	struct qp_sync	*qs_sync;	/* ##SMP: procedure synchronization */
	lck_t		qs_lock;	/* ##SMP: queue lock, mainly message
					 * list
					 */
	lck_t		qs_ilock;	/* ##SMP: internal queue lock */
	lck_t		*qs_slockp;	/* ##SMP: pointer to 1st queue list lock */
	lck_t		*qs_xlockp;	/* ##SMP: pointer to 2nd queue list lock */
	drmp_t		*qs_drsp;	/* ##SMP: compatibility semaphore */
	struct	queue	*qs_scanlink;	/* pointer to next queue in hold list */

#define	q_link		q_qshad->qs_link
#define	q_pfirst	q_qshad->qs_pfirst
#define	q_plast		q_qshad->qs_plast
#define	q_pcount	q_qshad->qs_pcount
#define	q_xcnt		q_qshad->qs_xcnt
#define	q_xcntp		q_qshad->qs_xcntp
#define	q_sync		q_qshad->qs_sync
#define	q_lock		q_qshad->qs_lock
#define	q_ilock		q_qshad->qs_ilock
#define	q_slockp	q_qshad->qs_slockp
#define	q_xlockp	q_qshad->qs_xlockp
#define	q_drsp		q_qshad->qs_drsp
#define	q_scanlink	q_qshad->qs_scanlink

};
#endif

#endif /* _STYPES */

typedef struct queue queue_t;

/*
 * Queue flags.
 */
#define	QENAB	0x001			/* ##SMP: Queue's srv/put list is enabled for service */
#define	QWANTR	0x002			/* Someone wants to read Q */
#define	QWANTW	0x004			/* Someone wants to write Q */
#define	QFULL	0x008			/* Q is considered full */
#define	QREADR	0x010			/* This is the reader (first) Q */
#define	QUSE	0x020			/* This queue in use (allocation) */
#define	QNOENB	0x040			/* ##SMP: Don't enable Q's srv list
					 * via putq
					 */
#define	QOLD	0x080			/* Pre-SVR4 open/close interface */
#define QBACK	0x100			/* queue has been back-enabled */
#define QHLIST	0x200			/* strhead write queue is on "scanqhead" */

#ifdef _SMP

#define QBLOCKED	0x80000000	/* ##SMP: put/srv is serialized for duration of open/close */
#define QENAB_PUT	0x40000000	/* ##SMP: Q's put list is ready for service */
#define QENAB_SRV	0x20000000	/* ##SMP: Q's srv list is ready for service */
#define QPWANTR		0x10000000	/* ##SMP: it's ok to enable the put list */
#define	QDETACHING	0x08000000	/* ##SMP: in qdetach */
#define	QPUTLIST	0x04000000	/* ##SMP: data on put list */
#define	QPUTPROC	0x02000000	/* ##SMP: put list currently running */

#else

#define QBLOCKED	0
#define QENAB_PUT	0
#define QENAB_SRV	QENAB
#define QPWANTR		0
#define QDETACHING	0
#define	QPUTLIST	0
#define	QPUTPROC	0

#endif

#ifdef _SMP

/*
* ##SMP: driver execution level consists of two parts:
*	type : 16
*	mask : 16
*
* These are the supported types:
*/
#define TYP_COMPAT	0xffff	/* ##SMP: compatibility mode */
#define TYP_MULTI	0x0000	/* ##SMP: multithreaded mode, explicit locking */
#define	TYP_USL		0x0001	/* ##SMP: multithreaded mode, implicit locking */

/* ##SMP: assign ordinal number to each procedure */
#define	QP_IDX_RD_SRV	0	/* ##SMP: read service procedure */
#define	QP_IDX_RD_PUT	1	/* ##SMP: read put procedure */
#define	QP_IDX_WR_SRV	2	/* ##SMP: write service procedure */
#define	QP_IDX_WR_PUT	3	/* ##SMP: write put procedure */

/*
* These are the supported masks:
*/
#define	QP_MSK_RS	(1 << QP_IDX_RD_SRV)	/* ##SMP: 0x1 */
#define	QP_MSK_RP	(1 << QP_IDX_RD_PUT)	/* ##SMP: 0x2 */
#define	QP_MSK_WS	(1 << QP_IDX_WR_SRV)	/* ##SMP: 0x4 */
#define	QP_MSK_WP	(1 << QP_IDX_WR_PUT)	/* ##SMP: 0x8 */

#define	QP_MSK_ALL	(QP_MSK_RS|QP_MSK_RP|QP_MSK_WS|QP_MSK_WP)
#define	QP_MSK_SRVPAIR	(QP_MSK_RS|QP_MSK_WS)

#define pl_mask(type, wput, wsrv, rput, rsrv)	\
	( ((type) << 16) | ((wput) << 12) | ((wsrv) << 8) | ((rput) << 4) | (rsrv) )

#define	PL_COMPAT	-1	/* compatibility mode */

#define	PL_COORD_ALL	/* coordinate execution of put and srv procs */ \
		pl_mask(TYP_MULTI, QP_MSK_ALL, QP_MSK_ALL, QP_MSK_ALL, QP_MSK_ALL)

#define	PL_COORD_SRVPAIR /* coordinate execution of put and srv procs */ \
		pl_mask(TYP_MULTI, 0, QP_MSK_SRVPAIR, 0, QP_MSK_SRVPAIR)

#define	PL_COORD_SRVS	/* coordinate each srv proc */ \
		pl_mask(TYP_MULTI, 0, QP_MSK_WS, 0, QP_MSK_RS)

#define	PL_NOCOORD	/* no coordination of procs */ \
		pl_mask(TYP_MULTI, 0, 0, 0, 0)

#define PL_USL	pl_mask(TYP_USL, 0, QP_MSK_WS, 0, QP_MSK_RS)
#else

#define	PL_COMPAT		0
#define	PL_COORD_ALL		0
#define	PL_COORD_SRVPAIR	0
#define	PL_COORD_SRVS		0
#define	PL_NOCOORD		0
#define PL_USL			0

#endif

/*
 * Structure that describes the separate information
 * for each priority band in the queue.
 */
struct qband {
	struct qband	*qb_next;	/* next band's info */
	ulong		qb_count;	/* number of bytes in band */
	struct msgb	*qb_first;	/* beginning of band's data */
	struct msgb	*qb_last;	/* end of band's data */
	ulong		qb_hiwat;	/* high water mark for band */
	ulong		qb_lowat;	/* low water mark for band */
	ulong		qb_flag;	/* see below */
	long		qb_pad1;	/* reserved for future use */
	ulong		qb_pcount;	/* ##SMP: number of messages targeted
					 * for this band that are in the
					 * put list.
					 */
};

typedef struct qband qband_t;

/*
 * qband flags
 */
#define QB_FULL		0x01		/* band is considered full */
#define QB_WANTW	0x02		/* Someone wants to write to band */
#define QB_BACK		0x04		/* queue has been back-enabled */

/*
 * Maximum number of bands.
 */
#define NBAND	256

/*
 * Fields that can be manipulated through strqset() and strqget().
 */
typedef enum qfields {
	QHIWAT	= 0,		/* q_hiwat or qb_hiwat */
	QLOWAT	= 1,		/* q_lowat or qb_lowat */
	QMAXPSZ	= 2,		/* q_maxpsz */
	QMINPSZ	= 3,		/* q_minpsz */
	QCOUNT	= 4,		/* q_count or qb_count */
	QFIRST	= 5,		/* q_first or qb_first */
	QLAST	= 6,		/* q_last or qb_last */
	QFLAG	= 7,		/* q_flag or qb_flag */
	QBAD	= 8
} qfields_t;

/*
 * Module information structure
 */

#ifdef _STYPES

struct module_info {
	ulong	mi_idnum;		/* module id number */
	char 	*mi_idname;		/* module name */
	short   mi_minpsz;		/* min packet size accepted */
	short   mi_maxpsz;		/* max packet size accepted */
	ushort	mi_hiwat;		/* hi-water mark */
	ushort 	mi_lowat;		/* lo-water mark */
};

#else /* large definition */

struct module_info {
	ulong	mi_idnum;		/* module id number */
	char 	*mi_idname;		/* module name */
	long	mi_minpsz;		/* min packet size accepted */
	long	mi_maxpsz;		/* max packet size accepted */
	ulong	mi_hiwat;		/* hi-water mark */
	ulong 	mi_lowat;		/* lo-water mark */
};

#endif /* _STYPES */

/*
 * queue information structure
 */
struct	qinit {
	int	(*qi_putp)();		/* put procedure */
	int	(*qi_srvp)();		/* service procedure */
	int	(*qi_qopen)();		/* called on startup */
	int	(*qi_qclose)();		/* called on finish */
	int	(*qi_qadmin)();		/* for future use */
	struct module_info *qi_minfo;	/* module information structure */
	struct module_stat *qi_mstat;	/* module statistics structure */
};

/*
 * ##SMP: qinit overlay for supporting compatibility mode.
 */
struct  nqinit {
        int     (*qi_putp)();           /* stream_put procedure */
        int     (*qi_srvp)();           /* service procedure */
        int     (*qi_qopen)();          /* called on startup */
        int     (*qi_qclose)();         /* called on finish */
        int     (*qi_qadmin)();         /* admin procedure with lock */
        struct module_info *qi_minfo;   /* module information structure */
        struct module_stat *qi_mstat;   /* module statistics structure */
        int     (*qi_strput)();         /* original put procedure */
        int     (*qi_stradm)();         /* original admin procedure */
};

/*
 * Streamtab (used in cdevsw and fmodsw to point to module or driver)
 */

struct streamtab {
	struct qinit *st_rdinit;
	struct qinit *st_wrinit;
	struct qinit *st_muxrinit;
	struct qinit *st_muxwinit;
};

/*
 * ##SMP: streamtab overlay for supporting compatibility mode.
 */
struct nstreamtab {
	struct nqinit	*st_rdinit;
	struct nqinit	*st_wrinit;
	struct nqinit	*st_muxrinit;
	struct nqinit	*st_muxwinit;

	drmp_t		*st_drsp;    	/* ##SMP: driver state structure */
	long		st_rwpl;	/* ##SMP: level of parallelism. */
	long		st_muxpl;	/* ##SMP: ditto, but for MUX queues */
};

/*
 * Structure sent to mux drivers to indicate a link.
 */
#ifdef _STYPES

struct linkblk {
	queue_t *l_qtop;	/* lowest level write queue of upper stream */
				/* (set to NULL for persistent links) */
	queue_t *l_qbot;	/* highest level write queue of lower stream */
	int      l_index;	/* index for lower stream. */
};

#else /* large definition */

struct linkblk {
	queue_t *l_qtop;	/* lowest level write queue of upper stream */
				/* (set to NULL for persistent links) */
	queue_t *l_qbot;	/* highest level write queue of lower stream */
	int      l_index;	/* index for lower stream. */
	long	 l_pad[5];	/* reserved for future use */
};

#endif /* _STYPES */

/*
 * Class 0 data buffer freeing routine
 */
struct free_rtn {
	void (*free_func)();
	char *free_arg;
};

/*
 *  Data block descriptor
 */

#ifdef _STYPES

struct datab {
	union {
		struct datab	*freep;
		struct free_rtn *frtnp;
	} db_f;
	unsigned char	*db_base;
	unsigned char	*db_lim;
	unsigned char	db_ref;
	unsigned char	db_type;
	unsigned char	db_band;
	unsigned char	db_iswhat;	/* status of the mesg/data/buffer triplet */
	unsigned int	db_size;
	unsigned short	db_flag;
	unsigned short	db_pad;	
	struct msgb_list *db_list;
	caddr_t		db_msgaddr; 	/* triplet mesg header that points to datab */
};

#else /* large definition */

struct datab {
	union {
		struct datab	*freep;
		struct free_rtn *frtnp;
		struct strevent	*freev;
	} db_f;
	unsigned char	*db_base;
	unsigned char	*db_lim;
	unsigned char	db_ref;
	unsigned char	db_type;
	unsigned char	db_iswhat;	/* status of the mesg/data/buffer triplet */
	unsigned char	db_pad;
	unsigned int	db_size;
	struct datab_list *db_list;
	caddr_t		db_msgaddr;	/* triplet mesg header that points to datab */
};

#endif /* _STYPES */

struct datab_list {
        int                     dl_flag;
        int                     dl_callera;
        int                     dl_callerb;
        int                     dl_callerc;
        struct datab_list       *dl_next;
};

#define DBL_ALLOC       1
#define DBL_FREE        2

#define db_freep db_f.freep
#define db_frtnp db_f.frtnp
#define db_freev db_f.freev

/*
 * Message block descriptor
 */

#ifdef _STYPES

struct	msgb {
	struct	msgb	*b_next;
	struct  msgb	*b_prev;
	struct	msgb	*b_cont;
	unsigned char	*b_rptr;
	unsigned char	*b_wptr;
	struct datab 	*b_datap;
};

#define b_band	b_datap->db_band
#define b_flag	b_datap->db_flag

#else /* large definition */

struct	msgb {
	struct	msgb	*b_next;
	struct  msgb	*b_prev;
	struct	msgb	*b_cont;
	unsigned char	*b_rptr;
	unsigned char	*b_wptr;
	struct datab 	*b_datap;
	unsigned char	b_band;
	unsigned char	b_pad1;
	unsigned short	b_flag;
	long		b_pad2;
};

#endif /* _STYPES */

struct strsched_status {
	int		sss_resched;
	timestruc_t	sss_last;
};

typedef struct msgb mblk_t;
typedef struct datab dblk_t;
typedef struct free_rtn frtn_t;

typedef struct strsched_status strsched_stat_t;

/*
 * Message flags.  These are interpreted by the stream head.
 */
#define MSGMARK		0x01		/* last byte of message is "marked" */
#define MSGNOLOOP	0x02		/* don't loop message around to */
					/* write side of stream */
#define MSGDELIM	0x04		/* message is delimited */
#define MSGNOGET	0x08		/* getq does not return message */
#define	MSGNOTIFY	0x80		/* always perform signal, event, and
					   poll notification upon arrival,
					   even if head's queue is not empty. */

/*
 * Streams message types.
 */

/*
 * Data and protocol messages (regular and priority)
 */
#define	M_DATA		0x00		/* regular data */
#define M_PROTO		0x01		/* protocol control */

/*
 * Control messages (regular and priority)
 */
#define	M_BREAK		0x08		/* line break */
#define M_PASSFP	0x09		/* pass file pointer */
#define M_EVENT		0x0a		/* post an event to an event queue */
#define	M_SIG		0x0b		/* generate process signal */
#define	M_DELAY		0x0c		/* real-time xmit delay (1 param) */
#define M_CTL		0x0d		/* device-specific control message */
#define	M_IOCTL		0x0e		/* ioctl; set/get params */
#define M_SETOPTS	0x10		/* set various stream head options */
#define M_RSE		0x11		/* reserved for RSE use only */

/*
 * Control messages (high priority; go to head of queue)
 */
#define	M_IOCACK	0x81		/* acknowledge ioctl */
#define	M_IOCNAK	0x82		/* negative ioctl acknowledge */
#define M_PCPROTO	0x83		/* priority proto message */
#define	M_PCSIG		0x84		/* generate process signal */
#define	M_READ		0x85		/* generate read notification */
#define	M_FLUSH		0x86		/* flush your queues */
#define	M_STOP		0x87		/* stop transmission immediately */
#define	M_START		0x88		/* restart transmission after stop */
#define	M_HANGUP	0x89		/* line disconnect */
#define M_ERROR		0x8a		/* fatal error used to set u.u_error */
#define M_COPYIN	0x8b		/* request to copyin data */
#define M_COPYOUT	0x8c		/* request to copyout data */
#define M_IOCDATA	0x8d		/* response to M_COPYIN and M_COPYOUT */
#define M_PCRSE		0x8e		/* reserved for RSE use only */
#define	M_STOPI		0x8f		/* stop reception immediately */
#define	M_STARTI	0x90		/* restart reception after stop */
#define M_PCEVENT	0x91		/* post an event to an event queue */

/*
 * Queue message class definitions.  
 */
#define QNORM		0x00		/* normal priority messages */
#define QPCTL		0x80		/* high priority cntrl messages */

/*
 *  IOCTL structure - this structure is the format of the M_IOCTL message type.
 */

#ifdef _STYPES

struct iocblk {
	int 	ioc_cmd;		/* ioctl command type */
	o_uid_t	ioc_uid;		/* effective uid of user */
	o_gid_t	ioc_gid;		/* effective gid of user */
	uint_t	ioc_id;			/* ioctl id */
	uint_t	ioc_count;		/* count of bytes in data field */
	int	ioc_error;		/* error code */
	int	ioc_rval;		/* return value  */
};

#else /* large definition */

struct iocblk {
	int 	ioc_cmd;		/* ioctl command type */
	cred_t	*ioc_cr;		/* full credentials */
	uint_t	ioc_id;			/* ioctl id */
	uint_t	ioc_count;		/* count of bytes in data field */
	int	ioc_error;		/* error code */
	int	ioc_rval;		/* return value  */
	long	ioc_filler[4];		/* reserved for future use */
};

#define ioc_uid ioc_cr->cr_uid
#define ioc_gid ioc_cr->cr_gid

#endif /* _STYPES */

/*
 * structure for the M_COPYIN and M_COPYOUT message types.
 */

#ifdef _STYPES

struct copyreq {
	int	cq_cmd;			/* ioctl command (from ioc_cmd) */
	o_uid_t	cq_uid;			/* effective uid of user */
	o_gid_t	cq_gid;			/* effective gid of user */
	uint_t	cq_id;			/* ioctl id (from ioc_id) */
	caddr_t	cq_addr;		/* address to copy data to/from */
	uint_t	cq_size;		/* number of bytes to copy */
	int	cq_flag;		/* see below */
	mblk_t *cq_private;		/* privtate state information */
};

#else /* large defintion */

struct copyreq {
	int	cq_cmd;			/* ioctl command (from ioc_cmd) */
	cred_t	*cq_cr;			/* full credentials */
	uint_t	cq_id;			/* ioctl id (from ioc_id) */
	caddr_t	cq_addr;		/* address to copy data to/from */
	uint_t	cq_size;		/* number of bytes to copy */
	int	cq_flag;		/* see below */
	mblk_t *cq_private;		/* privtate state information */
	long	cq_filler[4];		/* reserved for future use */
};

#define cq_uid cq_cr->cr_uid
#define cq_gid cq_cr->cr_gid

#endif /* _STYPES */

/* cq_flag values */

#define STRCANON	0x01		/* b_cont data block contains */
					/* canonical format specifier */
#define RECOPY		0x02		/* perform I_STR copyin again, */
					/* this time using canonical */
					/* format specifier */

/*
 * structure for the M_IOCDATA message type.
 */

#ifdef _STYPES

struct copyresp {
	int	cp_cmd;			/* ioctl command (from ioc_cmd) */
	o_uid_t	cp_uid;			/* effective uid of user */
	o_gid_t	cp_gid;			/* effective gid of user */
	uint_t	cp_id;			/* ioctl id (from ioc_id) */
	caddr_t	cp_rval;		/* status of request: 0 -> success */
					/*             non-zero -> failure */
	uint_t	cp_pad1;		/* reserved */
	int	cp_pad2;		/* reserved */
	mblk_t *cp_private;		/* private state information */
};

#else /* large definition */

struct copyresp {
	int	cp_cmd;			/* ioctl command (from ioc_cmd) */
	cred_t	*cp_cr;			/* full credentials */
	uint_t	cp_id;			/* ioctl id (from ioc_id) */
	caddr_t	cp_rval;		/* status of request: 0 -> success */
					/*             non-zero -> failure */
	uint_t	cp_pad1;		/* reserved */
	int	cp_pad2;		/* reserved */
	mblk_t *cp_private;		/* private state information */
	long	cp_filler[4];		/* reserved for future use */
};

#define cp_uid cp_cr->cr_uid
#define cp_gid cp_cr->cr_gid

#endif /* _STYPES */

/*
 * Options structure for M_SETOPTS message.  This is sent upstream
 * by a module or driver to set stream head options.
 */

#ifdef _STYPES

struct stroptions {
	short	so_flags;		/* options to set */
	short	so_readopt;		/* read option */
	ushort	so_wroff;		/* write offset */
	short	so_minpsz;		/* minimum read packet size */
	short	so_maxpsz;		/* maximum read packet size */
	ushort	so_hiwat;		/* read queue high water mark */
	ushort	so_lowat;		/* read queue low water mark */
	unsigned char so_band;		/* band for water marks */
};

#else /* large definition */

struct stroptions {
	ulong	so_flags;		/* options to set */
	short	so_readopt;		/* read option */
	ushort	so_wroff;		/* write offset */
	long	so_minpsz;		/* minimum read packet size */
	long	so_maxpsz;		/* maximum read packet size */
	ulong	so_hiwat;		/* read queue high water mark */
	ulong	so_lowat;		/* read queue low water mark */
	unsigned char so_band;		/* band for water marks */
};

#endif /* _STYPES */

/* flags for stream options set message */

#define SO_ALL		0x003f	/* set all old options */
#define SO_READOPT	0x0001	/* set read option */
#define SO_WROFF	0x0002	/* set write offset */
#define SO_MINPSZ	0x0004	/* set min packet size */
#define SO_MAXPSZ	0x0008	/* set max packet size */
#define SO_HIWAT	0x0010	/* set high water mark */
#define SO_LOWAT	0x0020	/* set low water mark */
#define SO_MREADON      0x0040	/* set read notification ON */
#define SO_MREADOFF     0x0080	/* set read notification OFF */
#define SO_NDELON	0x0100	/* old TTY semantics for NDELAY reads/writes */
#define SO_NDELOFF      0x0200	/* STREAMS semantics for NDELAY reads/writes */
#define SO_ISTTY	0x0400	/* the stream is acting as a terminal */
#define SO_ISNTTY	0x0800	/* the stream is not acting as a terminal */
#define SO_TOSTOP	0x1000	/* stop on background writes to this stream */
#define SO_TONSTOP	0x2000	/* do not stop on background writes to stream */
#define SO_BAND		0x4000	/* water marks affect band */
#define SO_DELIM	0x8000	/* messages are delimited */
#ifndef _STYPES
#define SO_NODELIM	0x010000	/* turn off delimiters */
#define SO_STRHOLD    0x020000    /* enable strwrite message coalescing */
#endif /* _STYPES */

/*
 * Structure for M_EVENT and M_PCEVENT messages.  This is sent upstream
 * by a module or driver to have the stream head generate a call to the
 * General Events subsystem.  It is also contained in the first M_DATA
 * block of an M_IOCTL message for the I_STREV and I_UNSTREV ioctls.
 */
struct str_evmsg {
	long		 sv_event;	/* the event (module-specific) */
	vnode_t		*sv_vp;		/* vnode pointer of event queue */
	long		 sv_eid;	/* same as ev_eid */
	long		 sv_evpri;	/* same as ev_pri */
	long		 sv_flags;	/* same as ev_flags */
	uid_t		 sv_uid;	/* user id of posting process */
	pid_t		 sv_pid;	/* process id of posting process */
	hostid_t	 sv_hostid;	/* host id of posting process */
	long		 sv_pad[4];	/* reserved for future use */
};

#ifdef	DEBUG
#	ifndef	STRDEBUG
#		define	STRDEBUG
#	endif
#endif
#ifdef	STRDEBUG

#ifdef _KERNEL
#if defined(__STDC__)
extern int assfail(char *, char *, int);
#define STRASSERT(EX) ((void)((EX) || assfail(#EX, __FILE__, __LINE__)))
#else
extern int assfail();
#define STRASSERT(EX) ((void)((EX) || assfail("EX", __FILE__, __LINE__)))
#endif	/* end __STDC__ */
#endif	/* _KERNEL */

#else

#define STRASSERT(EX)

#endif	/* DEBUG || STRDEBUG */

/*
 * Miscellaneous parameters and flags.
 */

/*
 * New code for two-byte M_ERROR message.
 */
#define NOERROR	((unsigned char)-1)

/*
 * Values for stream flag in open to indicate module open, clone open;
 * return value for failure.
 */
#define MODOPEN 	0x1		/* open as a module */
#define CLONEOPEN	0x2		/* open for clone, pick own minor device */
#define OPENFAIL	-1		/* returned for open failure */

/*
 * Priority definitions for block allocation.
 */
#define BPRI_LO		1
#define BPRI_MED	2
#define BPRI_HI		3

/*
 * Value for packet size that denotes infinity
 */
#define INFPSZ		-1

/*
 * Flags for flushq()
 */
#define FLUSHALL	1	/* flush all messages */
#define FLUSHDATA	0	/* don't flush control messages */

/*
 * Flag for transparent ioctls
 */
#define TRANSPARENT	(unsigned int)(-1)

/*
 * Sleep priorities for stream io
 */
#define	STIPRI	PZERO+3
#define	STOPRI	PZERO+3

/*
 * Stream head default high/low water marks 
 */
#define STRHIGH 5120
#define STRLOW	1024

/*
 * Block allocation parameters
 */
#define MAXIOCBSZ	1024		/* max ioctl data block size */

/*
 * amount of time to hold small messages in strwrite hoping to to
 * able to append more data from a subsequent write.  one tick min.
 */
#define STRSCANP	((10*HZ+999)/1000)	/* 10 ms in ticks */

/*
 * Definitions of Streams macros and function interfaces.
 */


/*
 * Definition of spl function needed to provide critical region protection
 * for streams drivers and modules.
 *
 * Note that splstr() has been implemented as an assembly language routine
 * in ml/misc.s, and that on the 386 processor is controlled by a tunable
 * parameter (SPLSTRVAL). The #define below is left for historical purposes.
 *
 * #ifdef __i386__
 * #define splstr() spl6()
 * #else
 * #define splstr() spltty()
 * #endif
 */

/*
 * Finding related queues
 */
#define	OTHERQ(q)	((q)->q_flag&QREADR? (q)+1: (q)-1)
#define	WR(q)		((q)+1)
#define	RD(q)		((q)-1)
#define SAMESTR(q)	(((q)->q_next) && (((q)->q_flag&QREADR) == ((q)->q_next->q_flag&QREADR)))

/*
 * Put a message of the next queue of the given queue.
 */
#if 0	/* ##SMP: Have to use a subroutine in SMP world. */
#define putnext(q, mp)	((*(q)->q_next->q_qinfo->qi_putp)((q)->q_next, (mp)))
#endif

#ifdef	_SMP

#define	QLOCK(q)	PSPIN(&(q)->q_lock, &mpsbuf[MPS_SPIN_STR_Q])
#define	QUNLOCK(q)	VSPIN(&(q)->q_lock, &mpsbuf[MPS_SPIN_STR_Q])

#define QXLOCK(q)	PSPIN((q)->q_xlockp, &mpsbuf[MPS_SPIN_STR_QX])
#define QXUNLOCK(q)	VSPIN((q)->q_xlockp, &mpsbuf[MPS_SPIN_STR_QX])

/*
* Modules should refrain from using
* these two primitives. They are
* subject to change.
*/
#define	QILOCK(q)	PSPIN(&(q)->q_ilock, &mpsbuf[MPS_SPIN_STR_QI])
#define	QIUNLOCK(q)	VSPIN(&(q)->q_ilock, &mpsbuf[MPS_SPIN_STR_QI])

#define	QPHOLD(q)	qphold(q)
#define	QPRELE(q)	qprele(q)

#define	QPHOLDQX(q)	qpholdqx(q)
#define	QPRELEQX(q)	qpreleqx(q)

#define	QI_PUTP(q, mp)	qi_putp(q, mp)
#define	QI_SRVP(q)	qi_srvp(q)

#define	QPBLOCK(q)	qpblock(q)
#define	QPUNBLOCK(q)	qpunblock(q)

#define QPSETLVL(q, level)	qpsetlvl(q, level)
#define QPGETLVL(q)		qpgetlvl(q)

#else

#define	QLOCK(q)
#define	QUNLOCK(q)

#define QXLOCK(q)
#define QXUNLOCK(q)

#define	QILOCK(q)
#define	QIUNLOCK(q)

#define	QPHOLD(q)
#define	QPRELE(q)

#define	QPHOLDQX(q)
#define	QPRELEQX(q)

#define	QI_PUTP(q, mp)	((*(q)->q_qinfo->qi_putp)((q), (mp)))
#define	QI_SRVP(q)	((*(q)->q_qinfo->qi_srvp)((q)))

#define	QPBLOCK(q)
#define	QPUNBLOCK(q)

#define QPSETLVL(q, level)
#define QPGETLVL(q)	0

#endif

#define QSLOCK(q)
#define QSUNLOCK(q)

/*
 * Test if data block type is one of the data messages (i.e. not a control
 * message).
 */
#define datamsg(type) ((type) == M_DATA || (type) == M_PROTO || (type) == M_PCPROTO || (type) == M_DELAY)

/*
 * Extract queue class of message block.
 */
#define queclass(bp) (((bp)->b_datap->db_type >= QPCTL) ? QPCTL : QNORM)

/*
 * Align address on next lower word boundary.
 */
#define straln(a)	(caddr_t)((long)(a) & ~(sizeof(int)-1))

/*
 * Find the max size of data block.
 */
#define bpsize(bp) ((unsigned int)(bp->b_datap->db_lim - bp->b_datap->db_base))

#ifdef _KERNEL

/*
 * declarations of common routines
 */
#ifdef __STDC__
extern struct msgb *allocb(int size, uint pri);
extern mblk_t *esballoc(unsigned char *base, int size, uint pri, frtn_t *fr_rtn);
extern int esbbcall(uint pri, void (*func)(), long arg);
extern int testb(int size, uint pri);
extern int bufcall(uint size, uint pri, void (*func)(), long arg);
extern void unbufcall(int id);
extern int unbufcall_nowait(int id);
extern int unbufcall_main(int id, int nowait);
extern void freeb(struct msgb *bp);
extern void freemsg(mblk_t *bp);
extern mblk_t *dupb(mblk_t *bp);
extern mblk_t *dupmsg(mblk_t *bp);
extern mblk_t *copyb(mblk_t *bp);
extern mblk_t *copymsg(mblk_t *bp);
extern void linkb(mblk_t *mp, mblk_t *bp);
extern mblk_t *unlinkb(mblk_t *bp);
extern mblk_t *rmvb(mblk_t *mp, mblk_t *bp);
extern int pullupmsg(struct msgb *mp, int len);
extern struct msgb *pullup_copy(struct msgb *mp, unsigned char *dst, int len);
extern void pullup_release(struct datab *dbp);
extern int adjmsg(mblk_t *mp, int len);
extern int msgdsize(mblk_t *bp);
extern mblk_t *getq(queue_t *q);
extern void rmvq(queue_t *q, mblk_t *mp);
extern void flushq(queue_t *q, int flag);
extern void flushband(queue_t *q, unsigned char pri, int flag);
extern int canputnext(queue_t *q);
extern int canput(queue_t *q);
extern int bcanputnext(queue_t *q, unsigned char pri);
extern int bcanput(queue_t *q, unsigned char pri);
extern int ebcanput(queue_t *q, unsigned char pri, int set_wantw);
extern int putq(queue_t *q, mblk_t *bp);
extern int putbq(queue_t *q, mblk_t *bp);
extern int insq(queue_t *q, mblk_t *emp, mblk_t *mp);
extern int putnextctl(queue_t *q, int type);
extern int putctl(queue_t *q, int type);
extern int putnextctl1(queue_t *q, int type, int param);
extern int putctl1(queue_t *q, int type, int param);
extern queue_t *backq(queue_t *q);
extern void qreply(queue_t *q, mblk_t *bp);
extern void qenable(queue_t *q);
extern int qsize(queue_t *qp);
extern void noenable(queue_t *q);
extern void enableok(queue_t *q);
extern ushort getmid(char *name);
extern int (*getadmin(unsigned short))();
extern int strqset(queue_t *q, qfields_t what, unsigned char pri, long val);
extern int strqget(queue_t *q, qfields_t what, unsigned char pri, long *valp);
extern void qlock(queue_t *q);
extern void qunlock(queue_t *q);
extern void qilock(queue_t *q);
extern void qiunlock(queue_t *q);
extern void qxlock(queue_t *q);
extern void qxunlock(queue_t *q);
extern void qphold(queue_t *q);
extern void qprele(queue_t *q);
extern void qpholdqx(queue_t *q);
extern void qpreleqx(queue_t *q);
extern void qpblock(queue_t *q);
extern void qpunblock(queue_t *q);
extern int qi_putp(queue_t *q, mblk_t *mp);
extern int qi_srvp(queue_t *q);
#ifdef _SMP
extern int putnext(queue_t *q, mblk_t *mp);
extern void qenable_put(queue_t *q);
extern int qi_markexec(queue_t *q, int proctype);
extern void qi_markexit(queue_t *q, int proctype);
extern void run_srvp(queue_t *q);
extern void run_put(queue_t *q);
extern int stp_bind(cpuid_t target, cpuid_t *savep);
extern int stp_unbind(cpuid_t cpuloc);
#endif
extern void qpsetlvl(queue_t *q, ulong level);
extern long qpgetlvl(queue_t *q);
extern void qprocson(queue_t *qp);
extern void qprocsoff(queue_t *qp);
extern mblk_t *msgpullup(mblk_t *mp, int len);
extern int pcmsg(int type);
extern void put(queue_t *qp, mblk_t *bp);
extern int mblktopack(caddr_t ap, mblk_t *mp);
extern int mblktoptr(mblk_t *mp, struct mac_buf *mbp, int *mblenp);
extern mblk_t *packtomblk(caddr_t *cp, int skip, int len, int off);
extern void strrput(queue_t *q, mblk_t *bp);
#ifdef mips
extern void strrput2(queue_t *q, mblk_t *bp);
#endif
#else /* __STDC__ */
extern mblk_t *allocb();
extern mblk_t *esballoc();
extern int esbbcall();
extern int testb();
extern int bufcall();
extern void freeb();
extern void freemsg();
extern mblk_t *dupb();
extern mblk_t *dupmsg();
extern mblk_t *copyb();
extern mblk_t *copymsg();
extern void linkb();
extern mblk_t *unlinkb();
extern mblk_t *rmvb();
extern int pullupmsg();
extern int adjmsg();
extern int msgdsize();
extern mblk_t *getq();
extern void rmvq();
extern void flushq();
extern void flushband();
extern int canput();
extern int bcanput();
extern int putq();
extern int putbq();
extern int insq();
extern int putctl();
extern int putctl1();
extern queue_t *backq();
extern void qreply();
extern int qi_putp();	/* ##SMP: replacement routine for qi_putp
			 * in qinfo struct.
			 */
extern int qi_srvp();	/* ##SMP: wrapper used for direct invocations of
			 * service procedure.
			 */
extern void qenable();
extern int qsize();
extern void noenable();
extern void enableok();
extern ushort getmid();
extern int strqset();
extern int strqget();
extern void unbufcall();
#endif /* __STDC__ */

/*
 * shared or externally configured data structures
 */
extern int strmsgsz;			/* maximum stream message size */
extern int strctlsz;			/* maximum size of ctl part of message */
extern int nstrpush;			/* maxmimum number of pushes allowed */
extern struct strstat strst;		/* STREAMS statistics structure */
#ifdef _SMP
/*
* TEMPNOTE: i386 specific? 
* queueflag replaced by ps_queueflag[]
*/
#else
extern char queueflag;          	/* set iff inside queuerun() */
#endif

#endif	/* _KERNEL */

#ifdef __i386__
/*
 * Structure for 386 ioctls requiring user context
*/
struct  v86blk {
    struct  proc    *v86_u_procp;
    ulong   v86_u_renv ;
    pid_t   v86_p_pid;
    pid_t   v86_p_ppid;
    struct cred *v86_p_cred;
    struct  v86dat  *v86_p_v86;
};
#endif

#endif	/* _SYS_STREAM_H */
