#ident "@(#)$Header: strsubr.h,v 1.7 93/03/10 12:46:10 meer Exp $ SNI"
/*
 * "@(#)strsubr.h	Revision: 3.5	92/08/27 14:17:03"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_STRSUBR_H
#define _SYS_STRSUBR_H


/*
 * WARNING:
 * Everything in this file is private, belonging to the
 * STREAMS subsystem.  The only guarantee made about the
 * contents of this file is that if you include it, your
 * code will not port to the next release.
 */
#include <sys/vnode.h>
#include <sys/evecb.h>
#include <sys/proc.h>
#include <sys/session.h>
#include <sys/stropts.h>
#include <sys/file.h>

/*
 * Header for a stream: interface to rest of system.
 */
typedef struct stdata {
	struct queue *sd_wrq;		/* write queue */
	struct msgb *sd_iocblk;		/* return block for ioctl */
	struct vnode *sd_vnode;		/* pointer to associated vnode */
#ifdef	_SMP
	struct nstreamtab *sd_strtab;	/* pointer to streamtab for stream */
#else
	struct streamtab *sd_strtab;	/* pointer to streamtab for stream */
#endif
	ulong sd_flag;			/* state/flags */
	long sd_iocid;			/* ioctl id */
	ushort sd_iocwait;		/* count of procs waiting to do ioctl */
	struct pid *sd_sidp;		/* controlling session info */
	struct pid *sd_pgidp;		/* controlling process group info */
	ushort sd_wroff;		/* write offset */
	int sd_rerror;			/* read error to set u.u_error */
	int sd_werror;			/* write error to set u.u_error */
	int sd_pushcnt;			/* number of pushes done on stream */
	int sd_sigflags;		/* logical OR of all siglist events */
	struct strevent *sd_siglist;	/* pid linked list to rcv SIGPOLL sig */
	int sd_eventflags;		/* logical OR of all eventlist events */
	struct strevent *sd_eventlist;	/* linked list to rcv general events */
	struct msgb *sd_mark;		/* "marked" message on read queue */
	int sd_closetime;		/* time to wait to drain q in close */
	clock_t sd_rtime;		/* time to release held message */

	/*
	 * If building _SMP, the poll list is allocated by POLLHEAD_ALLOC().
	 * Otherwise, it is the responsibility of the stream head to allocate
	 * a poll list. In the interest of keeping the structure sizes the
	 * same, we allocate a pointer to a poll list in either case. If
	 * !_SMP is off, the poll list is allocated at the end of the shinfo
	 * structure.
	 */
#ifdef	_SMP
	struct npollhead		/* ##SMP: from POLLHEAD_ALLOC() */
#else
	struct pollhead			/* ##!SMP: from shinfo */
#endif
			*sd_pollistp;	/* list of all pollers to wake up */

#define sd_pollist	sd_pollistp[0]

	lck_t	sd_lock;		/* ##SMP: lock for stream/queue list */
	lck_t	*sd_lockp;		/* ##SMP: pointer to above lock */
	int	sd_plumb;		/* ##SMP: flag for plumbing */
	int	*sd_plumbp;		/* ##SMP: ptr to above for twisted streams */
	cpuid_t	sd_cpuloc;		/* ##SMP: processor push/pops bound to */
	int	sd_bindcnt;		/* ##SMP: number of bound components in stream */

#ifdef	mips
	caddr_t	sd_private;		/* Extra pointer ala q->q_ptr */
	void	(*sd_rfilter)(/* q, bp */);	/* head read put filter */
#endif
	caddr_t	sd_session;		/* Back pointer to current session */
	caddr_t sd_bsession;		/* Back pointer to current bsession */
} stdata_t;

/*
 * stdata flag field defines
 */
#define	IOCWAIT		0x00000001	/* Someone wants to do ioctl */
#define RSLEEP		0x00000002	/* Someone wants to read/recv msg */
#define	WSLEEP		0x00000004	/* Someone wants to write */
#define STRPRI		0x00000008	/* An M_PCPROTO is at stream head */
#define	STRHUP		0x00000010	/* Device has vanished */
#define	STWOPEN		0x00000020	/* waiting for 1st open */
#define STPLEX		0x00000040	/* stream is being multiplexed */
#define STRISTTY	0x00000080	/* stream is a terminal */
#define RMSGDIS		0x00000100	/* read msg discard */
#define RMSGNODIS	0x00000200	/* read msg no discard */
#define STRDERR		0x00000400	/* fatal read error from M_ERROR */
#define STRTIME		0x00000800	/* used with timeout strtime */
#define STR2TIME	0x00001000	/* used with timeout str2time */
#define STR3TIME	0x00002000	/* used with timeout str3time */
#define STRCLOSE	0x00004000	/* wait for a close to complete */
#define SNDMREAD	0x00008000	/* used for read notification */
#define OLDNDELAY	0x00010000	/* use old TTY semantics for NDELAY
					/* reads and writes */
#define RDBUFWAIT	0x00020000	/* used with bufcall in strqbuf() */
#define STRSNDZERO	0x00040000	/* send 0-length msg. down pipe/FIFO */
#define STRTOSTOP	0x00080000	/* block background writes */
#define	RDPROTDAT	0x00100000	/* read M_[PC]PROTO contents as data */
#define RDPROTDIS	0x00200000	/* discard M_[PC]PROTO blocks and */
					/* retain data blocks */
#define STRMOUNT	0x00400000	/* stream is mounted */
#define STRSIGPIPE	0x00800000	/* controlling process not group */
#define STRDELIM	0x01000000	/* generate delimited messages */
#define STWRERR		0x02000000	/* fatal write error from M_ERROR */
#define STRHOLD		0x04000000	/* enable strwrite message coalescing */

/*
 * ##SMP: If we need to add more bits this list, decrement
 * STSMPSHFT, and make the new bit, (8<<STSMPSHFT). This means that
 * the STRLOCKR, STRLOCKW, STRBUILDING can have different binary values
 * across releases, but this is no big deal since modules outside of
 * the stream head had better not reference these bits (or strsubr.h
 * for that matter).
 */
#define STSMPSHFT	29		/* ##SMP: bit # of first SMP flag */
#define STRLOCKR	(1u<<STSMPSHFT) /* lock around read sequence */
#define STRLOCKW	(2u<<STSMPSHFT)	/* ##SMP: lock around write sequence */
#define STRBUILDING	(4u<<STSMPSHFT)	/* ##SMP: plumbing operation in
					 * progress.
					 */

/*
 * Structure of list of processes to be sent SIGSEL signal
 * on request, or for processes sleeping on select().  The valid 
 * SIGSEL events are defined in stropts.h, and the valid select()
 * events are defined in select.h.
 */
struct strevent {
	union {
		struct {
			struct proc	*procp;
			long		events;
		} e;	/* stream event */
		struct {
			void (*func)();
			long arg;
			int size;

			/*
			* ##SMP: used to help serialize unbufcall with 
			* servicing bufcall requests in queuerun.
			*/
			volatile int state;	/* volatile: fool optimizer */
		} b;	/* bufcall event */
		struct {
			/* ##SMP: free routines set up by esballoc
			 * must get a lock free context, which freeb()
			 * is not guaranteed to have. So make free routines
			 * events.
			 *
			 * SMP aside, it is a good thing to a copy of the
			 * free_rtn structure because that lets drivers
			 * have ptr's to free_rtn structures passed in
			 * from kernel stack addresses.
			 */
			struct free_rtn	new;
			struct free_rtn *orig;
		} fr;
		struct {
			vnode_t		*vp;
			ecb_t		 ecb;
			pid_t		 pid;
			hostid_t	 hostid;
			uid_t		 uid;
			long		 mask;
			unchar		 band;
		} g;	/* general events mechanism */
	} x;
	struct strevent *se_next;
#ifdef _SMP
	/* 
	* ##SMP: compatibility sema
	* for controlling dispatch of
	* events into non-symmetrized
	* drivers.
	*/
	drmp_t *se_drsp;  
#endif
};

#define se_procp	x.e.procp
#define se_events	x.e.events
#define se_func		x.b.func
#define se_arg		x.b.arg
#define se_size		x.b.size
#ifdef _SMP
#define se_state	x.b.state		/* ##SMP */
#endif
#define	se_free_func	x.fr.new.free_func	/* ##SMP */
#define se_free_arg	x.fr.new.free_arg	/* ##SMP */
#define se_free_orig	x.fr.orig		/* ##SMP */
#define se_vp		x.g.vp
#define se_kecb		x.g.ecb		/* name collision with struct str_sev */
#define se_pid		x.g.pid
#define se_hostid	x.g.hostid
#define se_uid		x.g.uid
#define se_kmask	x.g.mask	/* name collision with struct str_sev */
#define se_kband	x.g.band	/* name collision with struct str_sev */

#define SE_SLEEP	0	/* ok to sleep in allocation */
#define SE_NOSLP	1	/* don't sleep in allocation */

/*
 * bufcall list
 */
struct bclist {
	struct strevent	*bc_head;
	struct strevent	*bc_tail;
#ifdef _SMP
	struct strevent	*bc_srv_head;
	struct strevent	*bc_srv_tail;

	struct strevent	*bc_def_head;
	struct strevent	*bc_def_tail;
#endif
};

/*
 * Structure used to track mux links and unlinks.
 */
struct mux_node {
	long		 mn_imaj;	/* internal major device number */
	ushort		 mn_indegree;	/* number of incoming edges */
	struct mux_node *mn_originp;	/* where we came from during search */
	struct mux_edge *mn_startp;	/* where search left off in mn_outp */
	struct mux_edge *mn_outp;	/* list of outgoing edges */
	uint		 mn_flags;	/* see below */
};

/*
 * Flags for mux_nodes.
 */
#define VISITED	1

/*
 * Edge structure - a list of these is hung off the
 * mux_node to represent the outgoing edges.
 */
struct mux_edge {
	struct mux_node	*me_nodep;	/* edge leads to this node */
	struct mux_edge	*me_nextp;	/* next edge */
	int		 me_muxid;	/* id of link */
};

/*
 * Structure to keep track of resources that have been allocated
 * for streams - an array of these are kept, one entry per
 * resource.  This is used by crash to dump the data structures.
 */

struct strinfo {
	void	*sd_head;	/* head of in-use list */
	int	sd_cnt;		/* total # allocated */
};

#define DYN_STREAM	0	/* for stream heads */
#define DYN_QUEUE	1	/* for queues */
#define DYN_MSGBLOCK	2	/* for message blocks */
#define DYN_MDBBLOCK	3	/* for mesg/data/buffer triplets */
#define DYN_LINKBLK	4	/* for mux links */
#define DYN_STREVENT	5	/* for stream event cells */
#define DYN_QBAND	6	/* for qband structures */

#define NDYNAMIC	7	/* number of different data types that are */
				/* dynamically allocated */

/*
 * The following structures are mainly used to keep track of
 * the resources that have been allocated so crash can find
 * them (they are stored in a doubly-linked list with the head
 * of it stored in the Strinfo array.  Other data may be stored
 * away here too since this is private to streams.  Pointers
 * to these objects are returned by the allocating procedures,
 * which are later passed to the freeing routine.  The data
 * structure itself must appear first because the pointer is
 * overloaded to refer to both the structure itself or its
 * envelope, depending on context.
 */

/*
 * Stream head info
 */
struct shinfo {
	stdata_t	sh_stdata;	/* must be first */
	struct shinfo	*sh_next;	/* next in list */
	struct shinfo	*sh_prev;	/* previous in list */
};

/*
 * data block info
 */
#ifdef STRDEBUG
/*
* values for d_type and m_type
*/
#define X_ALLOCB	1
#define X_DUPB		2
#define X_PULLUPMSG	3
#define X_FREEB		16
#endif

struct dbinfo {
	dblk_t	d_dblock;	/* the data block itself */
#ifdef STRDEBUG
	struct dbinfo *d_next;	/* next data block */
	struct dbinfo *d_prev;	/* previous */
	int	d_type;
	void	(*d_func)();	/* address of allocation function */	
#endif
};

/*
 * message block info
 */
struct mbinfo {
	mblk_t	m_mblock;	/* the message block itself */
#ifdef	STRDEBUG
	struct mbinfo *m_next;	/* next message block */
	struct mbinfo *m_prev;	/* previous message block */
	int	m_type;
#endif
	void	(*m_func)();	/* address of allocation function */	
};

/* convenient power of 2 */
#define	FASTBUF	(128 - sizeof(struct mbinfo) - sizeof(struct dbinfo))

/*
 * triplet
 */
struct	mdbblock {
	struct	mbinfo	msgblk;
	struct	dbinfo	datblk;
	char	databuf[FASTBUF];
};


#ifdef DEBUG
#define _INSERT_MSG_INUSE(x)	insert_msg_inuse(x)
#define _INSERT_MDB_INUSE(y)	insert_mdb_inuse(y)
#define _DELETE_MSG_INUSE(x)	delete_msg_inuse(x)
#define _DELETE_MDB_INUSE(y)	delete_mdb_inuse(y)
#else
#define _INSERT_MSG_INUSE(x)
#define _INSERT_MDB_INUSE(y)
#define _DELETE_MSG_INUSE(x)
#define _DELETE_MDB_INUSE(y)
#endif

/*
 * Stream event info
 */
struct seinfo {
	struct strevent	s_strevent;	/* must be first */
	struct seinfo	*s_next;	/* next in list */
	struct seinfo	*s_prev;	/* previous in list */
};

/*
 * ##SMP: Put lists and service procedures are scheduled and dispatched
 * independently by having separate objects. These objects have a reference
 * to the queue struct.
 */
struct	qu_runobj {
	int		qo_type; /* 1 == put list, 0 == srv list */
	queue_t		*qo_q;
	struct qu_runobj *qo_link;
	int		qo_cnt; /* ##SMP: per procedure reference cnt */
	clock_t		qo_start;	/* Time when procedure was invoked */
	clock_t		qo_resched;	/* Time when procedure was rescheduled */
};

typedef struct qu_runobj qu_runobj_t;
#define	QTOTYPE(q, isput) ((isput) + ((!((q)->q_flag & QREADR)) << 1))

/*
 * ##SMP: Queue pair synchronization structure. Used to maintain a
 * private job list of queues that are blocked because of compatibility,
 * processing level, or open/close execution.
 */
struct	qp_sync	{
	ulong	qps_level;		/* ##SMP: queue execution level */
	qu_runobj_t	*qps_head;	/* ##SMP: list of procedures enabled */
	qu_runobj_t	*qps_tail;	/* 	to run. */
	int	qps_runcnt;	/* ##SMP: run count of queues this series */
	int	qps_runlimit;	/* ##SMP: run count threshold */
	qu_runobj_t	qps_objs[4];	/* ##SMP: space for objects */
};

/*
 * Queue info
 */
#ifdef _STYPES

struct queinfo {
	struct queue	qu_rqueue;	/* read queue - must be first */
	struct queue	qu_wqueue;	/* write queue - must be second */
	struct equeue	qu_requeue;	/* extended queue info (read) */
	struct equeue	qu_wequeue;	/* extended queue info (write) */
	struct queinfo	*qu_next;	/* next in list */
	struct queinfo	*qu_prev;	/* previous in list */
};

#else /* expanded struct */

struct queinfo {
	struct queue	qu_rqueue;	/* read queue - must be first */
	struct queue	qu_wqueue;	/* write queue - must be second */
#ifndef	mips
	struct queue_shadow qu_rqshad;	/* shadows read queue for SMP */
	struct queue_shadow qu_wqshad;	/* shadows write queue for SMP */
#endif
	struct qp_sync	qu_sync;	/* synchronization structure */
	struct queinfo	*qu_next;	/* next in list */
	struct queinfo	*qu_prev;	/* previous in list */
};

#endif /* _STYPES */


/*
 * Multiplexed streams info
 */
struct linkinfo {
	struct linkblk	li_lblk;	/* must be first */
	struct file	*li_fpdown;	/* file pointer for lower stream */
	struct linkinfo	*li_next;	/* next in list */
	struct linkinfo *li_prev;	/* previous in list */
};

/*
 * Qband info
 */
struct qbinfo {
	struct qband	qbi_qband;	/* must be first */
	struct qbinfo	*qbi_next;	/* next in list */
	struct qbinfo	*qbi_prev;	/* previous in list */
};

#ifdef	_SMP
/*
 * Header for list of compat semaphores on a stream. Duplicates are
 * removed. List isn't really sorted, but duplicates are removed.
 * lock_all_compats() builds this list, and is careful to lock in
 * descending order of address of compat semaphore, as well to delete
 * the target driver's semaphore from the list. Order of release is
 * not important, so unlock_all_compats() unlocks in order of
 * occurrence.
 */
struct sort_list	{
	int	sl_count;
	drmp_t	*sl_drsp[1];
};
#endif

#ifdef	_SMP
#define PS_PARAMSZ	8

/*
* ps_rules.pr_flags
*/
#define PS_FUNMOD	0x00000001
#define PS_FUNDRV	0x00000002

struct ps_rules {
	char			pr_name[PS_PARAMSZ];
	int			pr_flags;
	long			pr_rwpl;
	long			pr_muxpl;
	int			pr_index;	/* into cdevsw[] or fmodsw[] */
	int			(* pr_adm_func[4])();
	struct nqinit		*pr_nqinit[4];
	struct nstreamtab	*pr_nstreamtab;
	drmp_t			*pr_drsp;
};
#endif
#ifdef	_SMP
struct	ps_stats {
	int pss_dummy;
};

extern struct ps_stats	ps_stats[];
extern cpuid_t		getpeid();

#define PS_BUMPUP(field)	((ps_stats[getpeid()].field)++)
#else
#define PS_BUMPUP(field)
#endif

/*
 * Miscellaneous parameters and flags.
 */

/*
 * Default timeout in seconds for ioctls and close
 */
#define STRTIMOUT 15

/*
 * Flag values for stream io waiting procedure (strwaitq)
 */
#define WRITEWAIT	0x1	/* waiting for write event */
#define READWAIT	0x2	/* waiting for read event */
#define NOINTR		0x4	/* error is not to be set for signal */
#define GETWAIT		0x8	/* waiting for getmsg event */

/*
 * Copy modes for tty and I_STR ioctls
 */
#define	U_TO_K 	01			/* User to Kernel */
#define	K_TO_K  02			/* Kernel to Kernel */

/*
 * canonical structure definitions
 */

#define STRLINK		"lli"
#define STRIOCTL	"iiil"
#define STRPEEK		"iiliill"
#define STRFDINSERT	"iiliillii"
#define O_STRRECVFD	"lssc8"
#define STRRECVFD	"lllc8"
#define STRNAME		"c0"
#define STRINT		"i"
#define STRTERMIO	"ssssc12"
#define STRTERMCB	"c6"
#define STRSGTTYB	"c4i"
#define STRTERMIOS	"llllc20"
#define STRLIST		"il"
#define STRSEV		"issllc1"
#define STRGEV		"ili"
#define STREVENT	"lssllliil"
#define STRLONG		"l"
#define STRBANDINFO	"ci"

#ifndef _STYPES
#define STRPIDT		"l"
#else
#define STRPIDT		"s"
#endif

/*
 * Tables we reference during open(2) processing.
 */
#define CDEVSW	0
#define FMODSW	1

/*
 * Mux defines.
 */
#define LINKNORMAL	0x01		/* normal mux link */
#define LINKPERSIST	0x02		/* persistent mux link */
#define LINKTYPEMASK	0x03		/* bitmask of all link types */
#define LINKCLOSE	0x04		/* unlink from strclose */
#define LINKIOCTL	0x08		/* unlink from strioctl */
#define LINKNOEDGE	0x10		/* no edge to remove from graph */

/*
 * Definitions of Streams macros and function interfaces.
 */

#define canenable(q)	!((q)->q_flag & QNOENB)

#ifdef _SMP

/*
 * ##SMP: The qrunflag isn't used because scheduling is interrupt driven,
 * not cooperative. The method of delivering interrupts is machine dependent
 * though, so setqsched() is a subroutine in strmdep.c.
 */

#else
/*
 *  Queue scheduling macros
 */
#define setqsched(x,y)     qrunflag = 1	/* set up queue scheduler */
#define qready()	qrunflag	/* test if queues are ready to run */
#endif

#define	STRLOCK_READ(stp)	STRLOCK(stp, &stp->sd_flag, STRLOCKR)
#define	STRLOCK_READX(stp, s)	STRLOCKX(stp, &stp->sd_flag, STRLOCKR, s)
#define	STRTRYLOCK_READX(stp)	STRTRYLOCKX(stp, &stp->sd_flag, STRLOCKR)
#define	STRUNLOCK_READ(stp)	STRUNLOCK(stp, &stp->sd_flag, STRLOCKR)
#define	STRUNLOCK_READX(stp)	STRUNLOCKX(stp, &stp->sd_flag, STRLOCKR)

#ifdef	_SMP

#define	STRLOCK_WRITE(stp)	STRLOCK(stp, &stp->sd_flag, STRLOCKW)
#define	STRLOCK_WRITEX(stp, s)	STRLOCKX(stp, &stp->sd_flag, STRLOCKW, s)
#define	STRTRYLOCK_WRITEX(stp)	STRTRYLOCKX(stp, &stp->sd_flag, STRLOCKW)
#define	STRUNLOCK_WRITE(stp)	STRUNLOCK(stp, &stp->sd_flag, STRLOCKW)
#define	STRUNLOCK_WRITEX(stp)	STRUNLOCKX(stp, &stp->sd_flag, STRLOCKW)

#define	STRLOCK_PLUMB(stp)	STRLOCK(stp, stp->sd_plumbp, STRBUILDING)
#define	STRUNLOCK_PLUMB(stp)	STRUNLOCK(stp, stp->sd_plumbp, STRBUILDING)

#else

#define	STRLOCK_WRITE(stp)
#define	STRLOCK_WRITEX(stp, s)
#define	STRUNLOCK_WRITE(stp)
#define	STRUNLOCK_WRITEX(stp)
#define	STRLOCK_PLUMB(stp)
#define	STRUNLOCK_PLUMB(stp)

#endif

/*
 * ##SMP: macros dealing with serializing I/O and ioctl's from STREAM HEAD
 */
#define STRLOCK(stp, sd_flagp, flag) \
	{ \
		int s = splstr(); \
		void *str_lock_addr = (void *)(((ulong)(sd_flagp)) \
			+ ((flag)>>STSMPSHFT)); \
		STPLOCK(stp); \
		while ( *(sd_flagp) & (flag) ) { \
			if (SLEEPFREE1(str_lock_addr, STOPRI | PCATCH, \
				(stp)->sd_lockp)) { \
				splx(s); \
				return EINTR; \
			} \
			STPLOCK(stp); \
		} \
		*(sd_flagp) |= (flag); \
		if ((flag) == STRBUILDING) \
			*(sd_flagp) |= (long)(u.u_procp->p_opid); \
		STPUNLOCK(stp); \
		splx(s); \
	}

#define STRLOCKX(stp, sd_flagp, flag, s) \
	{ \
		void *str_lock_addr = (void *)(((ulong)(sd_flagp)) \
			+ ((flag)>>STSMPSHFT)); \
		ASSERTLOCKED(stp->sd_lockp);	\
		while ( *(sd_flagp) & (flag) ) { \
			if (SLEEPFREE1(str_lock_addr, STOPRI | PCATCH, \
				(stp)->sd_lockp)) { \
				splx(s); \
				return EINTR; \
			} \
			STPLOCK(stp); \
		} \
		*(sd_flagp) |= (flag); \
	}

#define STRTRYLOCKX(stp, sd_flagp, flag) \
	( ((*(sd_flagp)) & (flag)) ? 1 : ((*(sd_flagp) |= flag), 0) )

#define	STRUNLOCK(stp, sd_flagp, flag) \
	{ \
		int s = splstr(); \
		STPLOCK(stp); \
		STRUNLOCKX(stp, sd_flagp, flag); \
		STPUNLOCK(stp); \
		splx(s); \
	}

#define	STRUNLOCKX(stp, sd_flagp, flag) \
	{ \
		void *str_lock_addr = (void *)(((ulong)(sd_flagp)) \
			+ ((flag)>>STSMPSHFT)); \
		ASSERTLOCKED(stp->sd_lockp);	\
		*(sd_flagp) &= ~(flag); \
		if ((flag) == STRBUILDING) \
			*(sd_flagp) = 0; \
		wakeup((caddr_t)str_lock_addr); \
	}

#ifdef	_SMP
/*
 * ##SMP: macros for locking stream header and queue list from STREAM HEAD.
 */
#define	STPLOCK(stp)	PSPIN((stp)->sd_lockp, &mpsbuf[MPS_SPIN_STR_QX])
#define	STPUNLOCK(stp)	VSPIN((stp)->sd_lockp, &mpsbuf[MPS_SPIN_STR_QX])

/*
 * SMP: Macros dealing with band masks.
 */

#define	QBF_NBANDBITS	(sizeof(unsigned long) * 8)
#define	QBF_SET(qbf, idx)	\
	((qbf)[(idx)/QBF_NBANDBITS] |= (1 << ((idx) % QBF_NBANDBITS)))
#define	QBF_ISSET(qbf, idx)	\
	((qbf)[(idx)/QBF_NBANDBITS] & (1 << ((idx) % QBF_NBANDBITS)))
#else
#define	STPLOCK(stp)
#define	STPUNLOCK(stp)
#endif

#define	STPSLOCK(stp)
#define	STPSUNLOCK(stp)

/*
 * Macros to reset and set the STRPRI state. Both QLOCK and STPLOCK must be on,
 * and a PCPROTO cannot be at head.
 */
#define	STP_RESETPRI(stp)	{	\
	register queue_t *q = RD(stp->sd_wrq);	\
\
	ASSERTLOCKED(&q->q_lock);	\
	ASSERTLOCKED(stp->sd_lockp);	\
	if (q->q_first == NULL || q->q_first->b_datap->db_type != M_PCPROTO) \
		stp->sd_flag &= ~STRPRI;	\
}

#define	STP_SETPRI(stp)	{	\
	register queue_t *q = RD(stp->sd_wrq);	\
\
	ASSERTLOCKED(&q->q_lock);	\
	ASSERTLOCKED(stp->sd_lockp);	\
	if (q->q_first == NULL || q->q_first->b_datap->db_type != M_PCPROTO) \
		stp->sd_flag |= STRPRI;	\
}

/*
 * Macros dealing with mux_nodes.
 */
#define MUX_VISIT(X)	((X)->mn_flags |= VISITED)
#define MUX_CLEAR(X)	((X)->mn_flags &= (~VISITED)); \
			((X)->mn_originp = NULL)
#define MUX_DIDVISIT(X)	((X)->mn_flags & VISITED)

/*
 * Declarations of private routines.
 */
#ifdef __STDC__
#ifdef _SMP
struct nqinit *ps_fix_qinit(struct qinit *oqinit, struct nqinit *nqinit, int (*adm_func)());
#endif /* _SMP */
void strsendsig(struct strevent *siglist, int event, long data);
void strevpost(struct stdata *stp, int event, long data);
void strdrpost(mblk_t *mp);
int qattach(queue_t *qp, dev_t *devp, int flag, int table, int idx, cred_t *crp);
void qdetach(queue_t *qp, int clmode, int flag, int table, cred_t *crp);
void strscan(void);
void strtime(struct stdata *stp);
void str2time(struct stdata *stp);
void str3time(struct stdata *stp);
int putiocd(mblk_t *bp, mblk_t *ebp, caddr_t arg, int copymode, int flag, char *fmt);
int getiocd(mblk_t *bp, caddr_t arg, int copymode, char *fmt);
struct linkinfo *alloclink(queue_t *qup, queue_t *qdown, file_t *fpdown);
void lbfree(struct linkinfo *linkp);
int linkcycle(stdata_t *upstp, stdata_t *lostp);
struct linkinfo *findlinks(stdata_t *stp, int index, int type);
queue_t *getendq(queue_t *q);
int munlink(struct stdata *stp, struct linkinfo *linkp, int flag, cred_t *crp, int *rvalp);
int munlinkall(struct stdata *stp, int flag, cred_t *crp, int *rvalp);
int mux_addedge(stdata_t *upstp, stdata_t *lostp, int muxid);
void mux_rmvedge(stdata_t *upstp, int muxid);
void setq(queue_t *rq, struct qinit *rinit, struct qinit *winit);
int strmakemsg(struct strbuf *mctl, int count, struct uio *uiop, struct stdata *stp, long flag, mblk_t **mpp);
#ifdef _SMP
void strsetrun(proc_t *pp);
#endif /* _SMP */
int strwaitbuf(int size, int pri);
void strunbcall(int size, struct proc *p);
int strwaitq(struct stdata *stp, int flag, off_t count, int fmode, int *done);
int str2num(char **str);
void adjfmtp(char **str, mblk_t *bp, int bytes);
void strqbuf(struct stdata *stp);
void strctty_bg_session(stdata_t *stp);
int straccess(struct stdata *stp, enum jcaccess mode);
int xmsgsize(mblk_t *bp);
struct stdata *shalloc(queue_t *qp);
void shfree(struct stdata *stp);
struct msgb *xmsgalloc(void);
struct mdbblock *xmdballoc(void);
#ifndef _SMP
queue_t *allocq(void);
#else
queue_t *allocq(lck_t *slockp, lck_t *xlockp, struct qp_sync *qp_sync);
#endif /* _SMP */
void freeq(queue_t *qp);
qband_t *allocband(void);
void freeband(qband_t *qbp);
struct strevent *sealloc(int slpflag);
void sefree(struct strevent *sep);
void queuerun(void);
#ifndef _SMP
void runqueues(void);
#else
void qps_queuerun(queue_t *, int);
void strbcsched(void);
int str_is_mark(mblk_t *);
#endif /* _SMP */
int findmod(char *name);
void setqback(queue_t *q, int pri);
int strcopyin(caddr_t from, caddr_t to, unsigned int len, char *fmt, int copyflag);
int strcopyout(caddr_t from, caddr_t to, unsigned int len, char *fmt, int copyflag);
void strsignal(struct stdata *stp, int sig, long band);
void strhup(struct stdata *stp);
void strallocttyx(sess_t *sp, struct stdata *stp);
void stralloctty(sess_t *sp, struct stdata *stp);
void strfreectty1(struct stdata *stp, int hangup);
void strfreectty(struct stdata *stp);
void strpunlink(struct cred *crp);
int strctty(proc_t *pp, struct stdata *stp);
int strlck_twist(stdata_t *stp1, stdata_t *stp2, lck_t **fn_mplockpp);
void strlck_untwist(stdata_t *stp);
#ifdef _SMP
void str_compat_lock(drmp_t *drsp);
int str_compat_c_lock(drmp_t *drsp);
void str_compat_unlock(drmp_t *drsp);
int str_private_q(drmp_t *drsp);
void str_reschedule(drmp_t *drsp);
drmp_t *ps_get_compat(void);
drmp_t *ps_set_compat(drmp_t *drsp);
struct sort_list *lock_all_compats(queue_t *qp, drmp_t *drsp);
void unlock_all_compats(struct sort_list *sort_list);
void ps_bind(queue_t *rq, long service, drmp_t *new_drsp);
int stream_cadm(mblk_t *arg, int ind, int type);
int stream_fadm(mblk_t *arg, int ind, int type);
void	qpquiesce(queue_t *, int);
#endif /* _SMP */
#else /* __STDC__ */
extern void strsendsig();
extern void strevpost();
extern void strdrpost();
extern int qattach();
extern void qdetach();
extern void strtime();
extern void str2time();
extern void str3time();
extern int putiocd();
extern int getiocd();
extern struct linkinfo *alloclink();
extern void lbfree();
extern int linkcycle();
extern struct linkinfo *findlinks();
extern queue_t *getendq();
extern int munlink();
extern int munlinkall();
extern int mux_addedge();
extern void mux_rmvedge();
extern void setq();
extern int strmakemsg();
extern int strwaitbuf();
extern void strunbcall();
extern int strwaitq();
extern void strqbuf();
extern int strctty();
extern int straccess();
extern int xmsgsize();
extern struct stdata *shalloc();
extern void shfree();
extern struct mdbblock *xmdballoc();
extern mblk_t *xmsgalloc();
extern queue_t *allocq();
extern void freeq();
extern qband_t *allocband();
extern void freeband();
extern struct strevent *sealloc();
extern void sefree();
extern void queuerun();
extern void runqueues();
extern int findmod();
extern caddr_t allocstrpage();
extern void adjfmtp();
extern int str2num();
extern void strclearpg();
extern void strclearsid();
extern void strclearctty();
extern void setqback();
extern int strcopyin();
extern int strcopyout();
extern void strsignal();
extern void strscan();
#endif /* __STDC__ */

#ifdef _SMP
extern	lck_t	str_scan_mplock;
extern	lck_t	stralloc_mplock;
extern	lck_t	str_runq_mplock;
extern	lck_t	str_link_mplock;
extern	sema_t	str_linkop_mpsema;
#endif

#endif	/* _SYS_STRSUBR_H */
