#ident "@(#)$Header: types.h,v 1.10.1.1 94/05/06 15:06:59 V542flo Exp $ SNI"
/*
 * "@(#)types.h	Revision: 3.4	93/01/21 12:15:42"
 */

/*	Copyright (c) 1984, 1986, 1987, 1988, 1989, 1990, 1991 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ifndef _SYS_TYPES_H
#define _SYS_TYPES_H


#ifdef __i386__
#define	_LABEL_SIZE	6
#endif
#ifdef u3b2
#define	_LABEL_SIZE	10
#endif
#ifdef mips
#define	_LABEL_SIZE	12
#endif

/*
 * These were added to allow non-ANSI compilers to compile the system.
 */

#ifdef __STDC__

#ifndef _VOID
#define _VOID	void
#endif

	/* End of ANSI section */

#else

#ifndef _VOID
#define _VOID	char
#endif

#ifndef	mips		/* mips has const without STDC */
#ifndef const
#define const
#endif

#endif /* mips */

#ifndef u3b2v4
#ifndef volatile
#define volatile
#endif
#endif

#endif /* of non-ANSI section */

/* POSIX Extensions */

typedef	unsigned char	uchar_t;
typedef	unsigned int	uint_t;

#ifndef _USHORT_T
#define _USHORT_T
typedef	unsigned short	ushort_t;
#endif /* _USHORT_T */

#ifndef _ULONG_T
#define _ULONG_T
typedef	unsigned long	ulong_t;
#endif /* _ULONG_T */


/* For BSD compatibility */
typedef char *		addr_t; /* ?<core address> type */

typedef	char *		caddr_t;	/* ?<core address> type */
typedef	long		daddr_t;	/* <disk address> type */

#ifndef _OFF_T
#define _OFF_T
typedef	long		off_t;		/* ?<offset> type */
#endif /* _OFF_T */

typedef	short		cnt_t;		/* ?<count> type */
typedef	ulong_t paddr_t;	/* <physical address> type */
typedef	uchar_t use_t;		/* use count for swap.  */
typedef	short		sysid_t;
typedef	short		index_t;
/*
 * NOTE: USL has re-defined this to be a real
 * MP lock.  We remove it from types.h and hope
 * that nobody cares - the new definition is in
 * ksynch.h
 */
#ifdef notdef
typedef	short		lock_t;		/* lock work for busy wait */
#endif

#if !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)
typedef struct _label { int val[_LABEL_SIZE]; } label_t;
typedef enum boolean { B_FALSE, B_TRUE } boolean_t;
#endif /* !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE) */

#ifdef __i386__
/*
 * New type from XENIX
 */
typedef char *      faddr_t;    /* same as caddr_t for 8086/386 */
typedef ushort_t      sel_t;	/* Selector type */
#endif 
#if defined(u3b2) || defined(u3b2v4)
typedef char *      faddr_t;
#endif 

typedef ulong_t k_sigset_t;	/* kernel signal set type */
typedef ulong_t k_fltset_t;	/* kernel fault set type */

/*
 * The following type is for various kinds of identifiers.  The
 * actual type must be the same for all since some system calls
 * (such as sigsend) take arguments that may be any of these
 * types.  The enumeration type idtype_t defined in sys/procset.h
 * is used to indicate what type of id is being specified.
 */

typedef long		id_t;		/* A process id,	*/
					/* process group id,	*/
					/* session id, 		*/
					/* scheduling class id,	*/
					/* user id, or group id.*/


/* Typedefs for dev_t components */

typedef ulong_t	major_t;	/* major part of device number */
typedef ulong_t	minor_t;	/* minor part of device number */


/*
 * For compatilbility reasons the following typedefs (prefixed o_) 
 * can't grow regardless of the EFT definition. Although,
 * applications should not explicitly use these typedefs
 * they may be included via a system header definition.
 * WARNING: These typedefs may be removed in a future
 * release. 
 *		ex. the definitions in s5inode.h remain small 
 *			to preserve compatibility in the S5
 *			file system type.
 */
typedef	ushort_t o_mode_t;		/* old file attribute type */
typedef short	o_dev_t;		/* old device type	*/
typedef	ushort_t o_uid_t;		/* old UID type		*/
typedef	o_uid_t	o_gid_t;		/* old GID type		*/
typedef	short	o_nlink_t;		/* old file link type	*/
typedef short	o_pid_t;		/* old process id type */
typedef ushort_t o_ino_t;		/* old inode type	*/


/* POSIX and XOPEN Declarations */

#ifndef _KEY_T
#define _KEY_T
typedef	int		key_t;		/* IPC key type */
#endif /* _KEY_T */

#ifndef _MODE_T
#define _MODE_T
typedef	ulong_t	mode_t;			/* file attribute type	*/
#endif /* _MODE_T */

#ifndef _UID_T
#define _UID_T
typedef	long	uid_t;			/* UID type		*/
#endif /* _UID_T */

#ifndef _GID_T
#define _GID_T
typedef	uid_t	gid_t;			/* GID type		*/
#endif /* _GID_T */

typedef	ulong_t nlink_t;		/* file link type	*/
typedef ulong_t	dev_t;		/* expanded device type */
typedef ulong_t	ino_t;		/* expanded inode type */

#ifndef _PID_T
#define _PID_T
typedef long	pid_t;			/* process id type	*/
#endif /* _PID_T */

#ifndef _SIZE_T
#define _SIZE_T
#ifndef __SIZE_TYPE__
#define __SIZE_TYPE__ long unsigned int
#endif
typedef __SIZE_TYPE__ size_t;		/* len param for string funcs */
#endif

#ifndef _SSIZE_T
#define _SSIZE_T
typedef	int	ssize_t;	/* return byte count or indicate error */
#endif

typedef ushort_t      sel_t;      /* Selector type */

#ifndef _TIME_T
#define _TIME_T
typedef	long		time_t;		/* time of day in seconds */
#endif  /* _TIME_T */

#ifndef _CLOCK_T
#define _CLOCK_T
typedef	long		clock_t; /* relative time in a specified resolution */
#endif	/* ifndef _CLOCK_T */


#if defined(_KERNEL) || (!defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE))

typedef	struct { int r[1]; } *	physadr;
typedef	unsigned char	unchar;
typedef	unsigned short	ushort;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;




#if defined(_KERNEL)

#define SHRT_MIN        -32768          /* min value of a "short int" */
#define SHRT_MAX        32767           /* max value of a "short int" */
#define USHRT_MAX       65535		/* max value of an "unsigned short int" */
#define INT_MIN         (-2147483647-1)     /* min value of an "int" */
#define INT_MAX         2147483647      /* max value of an "int" */
#define UINT_MAX        4294967295	/* max value of an "unsigned int" */
#define LONG_MIN        (-2147483647-1)		/* min value of a "long int" */
#define LONG_MAX        2147483647      /* max value of a "long int" */
#define ULONG_MAX       4294967295 	/* max value of an "unsigned long int" */

#endif	/* defined(_KERNEL) */


#define	P_MYPID	((pid_t)0)

/*
 * The following is the value of type id_t to use to indicate the
 * caller's current id.  See procset.h for the type idtype_t
 * which defines which kind of id is being specified.
 */

#define	P_MYID	(-1)
#define NOPID (pid_t)(-1)

#ifndef NODEV
#define NODEV (dev_t)(-1)
#endif

/*
 * A host identifier is used to uniquely define a particular node
 * on an rfs network.  Its type is as follows.
 */

typedef	long	hostid_t;

/*
 * The following value of type hostid_t is used to indicate the
 * current host.  The actual hostid for each host is in the
 * kernel global variable rfs_hostid.
 */

#define	P_MYHOSTID	(-1)

typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned int	u_int;
typedef unsigned long	u_long;

#if !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE)
typedef struct _quad { long val[2]; } quad;	/* used by UFS */
#endif /* !defined(_POSIX_SOURCE) && !defined(_XOPEN_SOURCE) */


/*
 * Nested include for BSD/sockets source compatibility.
 * (The select macros used to be defined here).
 */
#include <sys/select.h>

/*
 * There are several MP locks that are used in the system.
 * Each has its own set of manipulation routines. Calling a
 * routine for a different type of MP lock is bad.
 * Exceptions are (there are always exceptions):
 *	When a process needs to sleep on an event, sleepfree can be
 *	    called to sleep on the event and atomically unlock a list
 *	    of MP locks (each of which can be of any type).
 *
 * The simplest MP lock, a spinlock, consists of only a lock primitive,
 * it is by far the most common MP lock in use in the system.
 *
 * Each MP lock contains a common primitive. This primitive
 * is a simple lock, with an associated level, pl and type.
 *
 * See also mplocks.h for each locks' interface.
 * See also ddi.h for DDI/DKI interface to MP locks.
 *
 * the ANSI ":0;" directive is used to force locks onto a word boundary.
 *
 */

typedef	char	cpuid_t;
typedef uint_t	cpumask_t;

#ifdef __i386__
/*
 * Structure to hold 64 bit time value.
 */
struct longtime  { unsigned val[2]; };
#endif

/*
 * Simple spin lock
 */

#if	defined(_MPPRFSTATS)

typedef struct lck {
      struct real_lck {
volatile      uchar_t         l__lock;        /* The actual lock itself */
              uchar_t         l__flags;       /* Lock flags */
              ushort_t        l__pl:5,        /* EXACT PL for this lock */
                              l__lvl:11;      /* lock level */
      } l_union;
      unsigned                l_pc;
} lck_t;

#else

typedef union lck {
      struct real_lck {
volatile      uchar_t         l__lock;        /* The actual lock itself */
              uchar_t         l__flags;       /* Lock flags */
              ushort_t        l__pl:5,        /* EXACT PL for this lock */
                              l__lvl:11;      /* lock level */
      } l_union;
      int                     l_align;        /* force word alignment */
} lck_t;

#endif

#if (defined(_KERNEL))
#define	l_lock	l_union.l__lock
#define	l_flags	l_union.l__flags
#define	l_pl	l_union.l__pl
#define	l_lvl	l_union.l__lvl
#endif

/*
 * Reentrant spin lock
 */
typedef struct reentlck {
		lck_t	re_lock;
		uchar_t	re_flags;	/* Lock flags */
		char	re_depth;	/* Re-entrancy depth */
		cpuid_t	re_cpu;		/* CPU ID for reentrant lock */
} reentlck_t;

/*
 * Read/Write spin lock
 */
typedef struct rdwrlck {
		lck_t	rw_lock;
		uchar_t	rw_flags;	/* Lock flags */
		char	rw_rdc;		/* Reader count */
		char	rw_wrpend;	/* Writer pending count */
		uchar_t	rw_status;	/* Information about the lock */
} rdwrlck_t;

typedef struct	ncxtlck {
		lck_t	 nc_lock;
		uchar_t	 nc_flags;	/* Lock flags */
		cpuid_t	 nc_cpu;	/* CPU ID for reentrancy check */
		ushort_t nc_nolock;	/* Nesting status flag */
} ncxtlck_t;


typedef	reentlck_t	ctxtlock_t;
typedef	rdwrlck_t	shlock_t;
typedef ncxtlck_t	vnpagelck_t;

/*
 * The simplest semaphore type
 */

typedef struct sema {
		lck_t	s_lock;		/* Spinlock protecting s_val */
		uint_t	s_flags;	/* Semaphore flags */
		int	s_val;		/* Semaphore value */
		int	s_maxval;	/* Maximum value for semaphore */
		int	s_hier;		/* Semaphore hierarchy value */
	 struct	proc	*s_pown;	/* Proc. ptr. of last `P' op. */
	 struct proc	*s_phead;	/* Process wait list head */
	 struct proc	*s_ptail;	/* Process wait list tail */
} sema_t;

/*
 * Reentrant semaphore - not counting
 */

typedef struct reentsema {
		lck_t	re_lock;	/* Basic atomic lock */
		uint_t	re_flags;	/* Semaphore flags */
		int	re_depth;	/* Reentrancy depth */
		int	re_hier;	/* Semaphore hierarchy value */
	 struct proc	*re_phead;	/* Process wait list head */
	 struct proc	*re_ptail;	/* Process wait list tail */
	 struct	proc	*re_pown;	/* Proc. ptr. of last `P' op. */
} reentsema_t;

/*
 * Read/write semaphore
 */

typedef	struct rdwrsema {
    	lck_t		rw_lock;	/* Basic atomic lock */
	uint_t		rw_flags;	/* Semaphore flags */
	ushort_t	rw_rdc;		/* Reader count */
	ushort_t	rw_status;	/* Lock status */
	int		rw_hier;	/* Semaphore hierarchy value */
	struct proc	*rw_rhead;	/* Head of waiting readers */
	struct proc	*rw_rtail;	/* Tail of waiting readers */
	struct proc	*rw_whead;	/* Head of waiting writers */
	struct proc	*rw_wtail;	/* Tail of waiting writers */
	struct proc	*rw_uproc;	/* Waiting upgrader */
} rdwrsema_t;

/* this struct should begin on a cache line */

struct queued_lock {
        lck_t   q_lt_lock;              /* used by locktest */
        char    q_lock;              	/* locks this struct - must be first */
        char    q_index;                /* index into q_cpulist for next cpu to
                                         * get the lock */
        char    q_cpulist[23];    	/* list of waiting cpus (NCPU - 1) */
        char   	q_filler[3];    	/* pad to a cache line */
};

/* values for q_index
 *      -2 -> unlocked
 *      -1 -> locked, no cpus waiting
 *    >= 0 -> locked, index (in q_cpulist[]) of next cpu to get the lock
 */

#define Q_UNLOCKED      -2
#define Q_LOCKEDNOWAIT  -1

/* queue_local_spin[NCPU][NUMBER OF IPLS = CACHELINE SIZE] */

extern char queue_local_spin[24][32];

/*
 * Declarations pertinent to lock statistics
 * collection.
 *
 * Locking stats buffer.  The locking primitives
 * will accept a pointer to this structure and
 * update it with statistics - if the pointer is
 * NULL, no action is taken by the primtives.
 */

typedef struct mpstats {
	 uint_t		mps_req[4];	/* Request counts */
	 uint_t		mps_col;	/* Collision */
	 uint_t		mps_time;	/* Time waiting */
	 uint_t		mps_maxwait;	/* Maximum # procs waiting on sema (read) */
	 uint_t		mps_maxwwait;	/* Maximum # procs waiting for write */
	 uint_t		mps_mulrdrs;	/* # times we had multiple readers */
	 uint_t		mps_pad[3];	/* extra space */
} mpstats_t;



/*
 * Event tagging structure.  When an asynchronous event (i.e. interrupt,
 * timeout or Xenix poll function should be run but cannot be run
 * (due to semaphore contention), the event is tagged to the device
 * driver MP state structure and will be executed before the semaphore
 * is unlocked.
 */

struct tag_evnt {
	void	(*t_func)();	/* function to call to handle event */
	caddr_t	t_evnt;		/* pointer to event structure */
	struct tag_evnt	*t_prvp,
			*t_nxtp;

	clock_t	t_strt;		/* MPSTATS: time that event was deferred */
};

typedef struct tag_evnt	mptag_t;

/*
 * State structure to support both single and multi-threaded 
 * device drivers and STREAMS modules on a multiprocessor system.
 */

struct driver_mp {
	int	d_flgs;		/* various flags */
	lck_t	d_spin;		/* spin lock to protect this structure */
	sema_t	d_sema;		/* compatibility semaphore */
	cpuid_t	d_cpuid;	/* processor binding information */
	caddr_t	d_priv;		/* private data (i.e. STREAMS-specific) */
	mptag_t	*d_begp,	/* pointer to beginning of tagged event list */
		*d_endp;	/* pointer to end of tagged event list */
	ulong_t	d_type;		/* execution type (eg. TYP_MULTI) */
	int	d_rsvd[4];	/* reserved for future enhancements */

	ulong_t	d_base_t_cnt,	/* MPSTATS: count of calls to base-level */
		d_intr_t_cnt,	/* MPSTATS: count of interrupts serviced */
		d_intr_d_cnt;	/* MPSTATS: count of deferred interrupts */
	clock_t	d_intr_m_lat,	/* MPSTATS: max interrupt latency (in ticks) */
		d_intr_t_lat;	/* MPSTATS: cum. deferred interupt latencies */
	ulong_t	d_time_t_cnt,	/* MPSTATS: count of timeouts serviced */
		d_time_d_cnt;	/* MPSTATS: count of deferred timeouts */
	clock_t	d_time_m_lat,	/* MPSTATS: max. timeout latency (in ticks) */
		d_time_t_lat;	/* MPSTATS: cum. deferred timeout latencies */
	ulong_t	d_xpll_t_cnt,	/* MPSTATS: count of xpolls serviced */
		d_xpll_d_cnt;	/* MPSTATS: count of deferred xpolls */
	clock_t	d_xpll_m_lat,	/* MPSTATS: maximum xpoll latency (in ticks) */
		d_xpll_t_lat;	/* MPSTATS: cum. deferred xpoll latencies */
};

typedef struct driver_mp	drmp_t;

/*
 * Saved compatibility locks structure.
 */

struct mp_sv_lcks {
	sema_t	*sv_fsp;
	drmp_t	*sv_drp;
};
#endif /* _KERNEL || (!_POSIX_SOURCE && !_XOPEN_SOURCE) */

#ifndef _SSIZE_T
#define _SSIZE_T
typedef int ssize_t;     /* len param for I/O funcs */
#endif

#endif	/* _SYS_TYPES_H */
